#target photoshop-12
//
// ImageProcessorNG.jsx
//
//
// $Id: ImageProcessorNG.jsx,v 1.50 2011/08/05 19:22:23 anonymous Exp $
// Copyright: (c)2011, xbytor, Adobe Systems, Inc.
// 2011-03-21
// License: http://www.opensource.org/licenses/bsd-license.php
// Contact: xbytor@gmail.com
//
// 03/02/2010 15:50
// c2007 Adobe Systems, Inc. All rights reserved.
// Produced and Directed by Dr. Brown ( a.k.a Russell Preston Brown )
// Written by Tom Ruark and Mike Shaw
// UI Design by Dr. Brown
//
/*
// BEGIN__HARVEST_EXCEPTION_ZSTRING

<javascriptresource>
  <about>$$$/JavaScripts/ImageProcessor/About=Image Processor Pro^r^rCopyright 2011 Adobe Systems Incorporated. All rights reserved.^r^rProcesses multiple input and output files.^rNOTE:It's better than the Image Processor!</about>
  <category>DrBrown</category>
  <name>$$$/JavaScripts/ImageProcessor/Name/ImageProcessorPro=Image Processor Pro...</name>
  <menu>automate</menu>
  <eventid>611736f0-9c46-11e0-aa82-0800200c9a66</eventid>
  <terminology><![CDATA[<< /Version 1
    /Events <<
       /611736f0-9c46-11e0-aa82-0800200c9a66 [($$$/JavaScripts/ImageProcessor/Name/ImageProcessorPro=Image Processor Pro...) /imageProcessorProSettings <<
           /ImageProcessorProSettings [(ImageProcessorPro Settings) /typeText]
           /Msge [(Message) /typeText]
         >>]
     >>
   >>
]]></terminology>

</javascriptresource>

// END__HARVEST_EXCEPTION_ZSTRING
*/
app;
//
//@show include
//
//
//
// psx.jsx
//   This file contains a collection code extracted from other parts
//   of xtools for use in production scripts written for Adobe.
//
// $Id: psx.jsx,v 1.11 2011/07/28 18:27:23 anonymous Exp $
// Copyright: (c)2011, xbytor
// License: http://www.opensource.org/licenses/bsd-license.php
// Contact: xbytor@gmail.com
//
//@show include
//
//

cTID = function(s) { return cTID[s] || cTID[s] = app.charIDToTypeID(s); };
sTID = function(s) { return sTID[s] || sTID[s] = app.stringIDToTypeID(s); };
id2char = function(s) {
  if (isNaN(Number(s))){
    return '';
  }
  var v;

  var lvl = $.level;
  $.level = 0;
  try {
    if (!v) {
      try { v = app.typeIDToCharID(s); } catch (e) {}
    }
    if (!v) {
      try { v = app.typeIDToStringID(s); } catch (e) {}
    }
  } catch (e) {
  }
  $.level = lvl;
  if (!v) {
    v = psx.numberToAscii(s);
  }
  return v ? v : s;
};

isWindows = function() { return $.os.match(/windows/i); };
isMac = function() { return !isWindows(); };

isPhotoshop = function() { return !!app.name.match(/photoshop/i); };
isBridge = function() { return !!app.name.match(/bridge/i); };

CSVersion = function() {
  return toNumber(app.version.match(/^\d+/)[0]) - 7;
};
CSVersion._version = CSVersion();

isCS6 = function()  { return CSVersion._version == 6; };
isCS5 = function()  { return CSVersion._version == 5; };
isCS4 = function()  { return CSVersion._version == 4; };
isCS3 = function()  { return CSVersion._version == 3; };
isCS2 = function()  { return CSVersion._version == 2; };
isCS  = function()  { return CSVersion._version == 1; };

psx = function() {};

psx.IOEXCEPTIONS_ENABLED = true;
psx.ERROR_CODE = 9001;
psx.IO_ERROR_CODE = 9002;

psx.numberToAscii = function(n) {
  if (isNaN(n)) {
    return n;
  }
  var str = (String.fromCharCode(n >> 24) +
             String.fromCharCode((n >> 16) & 0xFF) +
             String.fromCharCode((n >> 8) & 0xFF) +
             String.fromCharCode(n & 0xFF));

  return (psx.isAscii(str[0]) && psx.isAscii(str[1]) &&
          psx.isAscii(str[2]) && psx.isAscii(str[3])) ? str : n;
};
psx.ASCII_SPECIAL = "\r\n !\"#$%&'()*+,-./:;<=>?@[\]^_`{|}~";
psx.isSpecialChar = function(c) {
  return psx.ASCII_SPECIAL.contains(c[0]);
};
psx.isAscii = function(c) {
  return !!(c.match(/[\w\s]/) || psx.isSpecialChar(c));
};

psx._units = undefined;
psx._unitsInit = function() {
  if (!isPhotoshop()) {
    return;
  }
  psx._units = app.preferences.rulerUnits.toString();
  psx._unitMap = {};
  psx._unitMap[Units.INCHES.toString()] =  "in";
  psx._unitMap[Units.CM.toString()] =      "cm";
  psx._unitMap[Units.MM.toString()] =      "mm";
  psx._unitMap[Units.PERCENT.toString()] = "%";
  psx._unitMap[Units.PICAS.toString()] =   "pc";
  psx._unitMap[Units.PIXELS.toString()] =  "px";
  psx._unitMap[Units.POINTS.toString()] =  "pt";

  psx._unitStrMap = {};
  psx._unitStrMap["in"] = "in";
  psx._unitStrMap["cm"] = "cm";
  psx._unitStrMap["mm"] = "mm";
  psx._unitStrMap["%"]  = "%";
  psx._unitStrMap["pc"] = "picas";
  psx._unitStrMap["px"] = "pixels";
  psx._unitStrMap["pt"] = "points";
};
psx._unitsInit();
psx.getDefaultUnits = function() {
  return psx._unitMap[psx._units];
};
psx.getDefaultUnitsString = function() {
  return psx._unitStrMap[psx._unitMap[psx._units]];
};
psx.getDefaultRulerUnitsString = psx.getDefaultUnitsString;

psx.validateUnitValue = function(str, bu, ru) {
  var self = this;

  if (str instanceof UnitValue) {
    return str;
  }

  if (bu && bu instanceof Document) {
    var doc = bu;
    ru = doc.width.type;
    bu = UnitValue(1/doc.resolution, ru);

  } else {
    if (!ru) {
      ru = psx.getDefaultRulerUnitsString();
    }
    if (!bu) {
      UnitValue.baseUnit = UnitValue(1/72, ru);
    }
  }
  str = str.toString().toLowerCase();

  var zero = new UnitValue("0 " + ru);
  var un = zero;
  if (!str.match(/[a-z%]+/)) {
    str += ' ' + ru.units;
  }
  un = new UnitValue(str);

  if (isNaN(un.value) || un.type == '?') {
    return undefined;
  }

  if (un.value == 0) {
    un = zero;
  }

  return un;
};

//
// Invoke a Photoshop Event with no arguments
//
psx.doEvent = function(doc, eid, interactive, noDesc) {
  var id;

  if (doc != undefined && eid == undefined) {
    if (doc.constructor == Number) {
      eid = doc.valueOf();
    } else if (doc.constructor == String) {
      eid = doc;
    }
    doc = undefined;
  }

  if (!eid) {
    Error.runtimeError(8600); // Event key is missing "No event id specified");
  }

  if (eid.constructor != Number) {
    if (eid.length < 4) {
      // "Event id must be at least 4 characters long"
      Error.runtimeError(19, "eventID");
    }

    if (eid.length == 4) {
      id = cTID(eid);
    } else {
      id = sTID(eid);
    }
  } else {
    id  = eid;
  }

  interactive = (interactive == true);
  noDesc = (noDesc == true);

  function _ftn(id) {
    var dmode = (interactive ? DialogModes.ALL : DialogModes.NO);
    var desc = (noDesc ? undefined : new ActionDescriptor());
    return app.executeAction(id, desc, dmode);
  }

  return _ftn(id);
};

psx.hist = function(dir) {
  function _ftn() {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();
    ref.putEnumerated(cTID("HstS"), cTID("Ordn"), cTID(dir));
    desc.putReference(cTID("null"), ref);
    executeAction(cTID("slct"), desc, DialogModes.NO);
  }

  _ftn();
};
psx.undo = function () {
  psx.hist("Prvs");
};
psx.redo = function () {
  psx.hist("Nxt ");
};
psx.Undo = function () {
  psx.doEvent("undo");
};
psx.Redo = function () {
  psx.doEvent(sTID('redo'));
};


psx.SelectFolder = 
    localize("$$$/psx/SelectFolder=Select a folder");

psx.SelectFile = 
    localize("$$$/psx/SelectFile=Select a file");

psx.FileErrorStr = 
    localize("$$$/psx/FileError=File Error: ");

psx.BadFileSpecified = 
    localize("$$$/psx/BadFileSpecified=Bad file specified");

psx.UnableToOpenLogFile =
    localize("$$$/psx/UnableToOpenLogFile=Unable to open log file %%s : %%s");

psx.UnableToWriteLogFile =
    localize("$$$/psx/UnableToOpenLogFile=Unable to write to log file %%s : %%s");

psx.UnableToOpenFile =
    localize("$$$/psx/UnableToOpenFile=Unable to open file");

psx.UnableToOpenInputFile =
    localize("$$$/psx/UnableToOpenInputFile=Unable to open input file");

psx.UnableToOpenOutputFile =
    localize("$$$/psx/UnableToOpenOutputFile=Unable to open output file");

psx.CharacterConversionError =
    localize("$$$/psx/CharacterConversionError=Probable character conversion error");

psx.InstalledScripts = 
    localize("$$$/ScriptingSupport/InstalledScripts=Presets/Scripts");


psx.DocumentName =
    localize("$$$/psx/DocumentName=Document Name");

psx.LCDocumentName =
    localize("$$$/psx/LCDocumentName=document name");

psx.UCDocumentName =
    localize("$$$/psx/UCDocumentName=DOCUMENT NAME");

psx.FN1Digit =
    localize("$$$/psx/FN1Digit=1 Digit Serial Number");

psx.FN2Digit =
    localize("$$$/psx/FN2Digit=2 Digit Serial Number");

psx.FN3Digit =
    localize("$$$/psx/FN3Digit=3 Digit Serial Number");

psx.FN4Digit =
    localize("$$$/psx/FN4Digit=4 Digit Serial Number");

psx.FN5Digit =
    localize("$$$/psx/FN5Digit=5 Digit Serial Number");

psx.LCSerial =
    localize("$$$/psx/LCSerial=Serial Letter (a, b, c...)");

psx.UCSerial =
    localize("$$$/psx/UCSerial=Serial Letter (A, B, C...)");

psx.Date_mmddyy =
    localize("$$$/psx/Date/mmddyy=mmddyy (date)");

psx.Date_mmdd =
    localize("$$$/psx/Date/mmdd=mmdd (date)");

psx.Date_yyyymmdd =
    localize("$$$/psx/Date/yyyymmdd=yyyymmdd (date)");

psx.Date_yymmdd =
    localize("$$$/psx/Date/yymmdd=yymmdd (date)");

psx.Date_yyddmm =
    localize("$$$/psx/Date/yyddmm=yyddmm (date)");

psx.Date_ddmmyy =
    localize("$$$/psx/Date/ddmmyy=ddmmyy (date)");

psx.Date_ddmm =
    localize("$$$/psx/Date/ddmm=ddmm (date)");

psx.LCExtension =
    localize("$$$/psx/LCextension=extension");

psx.UCExtension =
    localize("$$$/psx/UCextension=EXTENSION");

psx.FileNaming =
    localize("$$$/psx/FileNaming=File Naming");

psx.ExampleLabel =
    localize("$$$/psx/ExampleLabel=Example:");

psx.StartingSerialNumber =
    localize("$$$/psx/StartingSerialNumber=Starting Serial#:");

psx.CompatibilityPrompt =
    localize("$$$/psx/CompatibilityPrompt=Compatibilty:");

psx.Windows =
    localize("$$$/psx/Windows=Windows");

psx.MacOS =
    localize("$$$/psx/MacOS=MacOS");

psx.Unix =
    localize("$$$/psx/Unix=Unix");

psx.CustomTextEditor =
    localize("$$$/psx/CustomTextEditor=Custom Text Editor");

psx.CreateCustomText =
    localize("$$$/psx/CreateCustomText=Create Custom Text");

psx.EditCustomText =
    localize("$$$/psx/EditCustomText=Edit Custom Text");

psx.DeleteCustomText =
    localize("$$$/psx/DeleteCustomText=Delete Custom Text");

psx.DeleteCustomTextPrompt =
    localize("$$$/psx/DeleteCustomTextPrompt=Do you reallt want to remove %%s?");

psx.CustomTextPrompt = 
    localize("$$$/psx/CustomTextPrompt=Please enter the desired Custom Text: ");

psx.Cancel = 
    localize("$$$/psx/Cancel=Cancel");

psx.Save = 
    localize("$$$/psx/Save=Save");

psx.UnitsPX = 
    localize("$$$/psx/Units/px=px");

psx.UnitsIN = 
    localize("$$$/psx/Units/in=in");

psx.UnitsCM = 
    localize("$$$/psx/Units/cm=cm");

psx.UnitsPT =
    localize("$$$/psx/Units/pt=pt");

psx.FontLabel =
    localize("$$$/psx/FontLabel=Font:");

//=========================== PS Paths =============================

psx.PRESETS_FOLDER =
  new Folder(app.path + '/' +
             localize("$$$/ApplicationPresetsFolder/Presets=Presets"));

psx.USER_PRESETS_FOLDER =
  new Folder(Folder.userData + '/' +
             localize("$$$/private/AdobeSystemFolder/Adobe=Adobe") + '/' +
             localize("$$$/private/FolderNames/AdobePhotoshopProductVersionFolder") + '/' +
             localize("$$$/private/FolderName/UserPresetsFolder/Presets=Presets"));

psx.SCRIPTS_FOLDER =
  new Folder(app.path + '/' +
             localize("$$$/ScriptingSupport/InstalledScripts=Presets/Scripts"));


//======================= File functions ===========================

psx.fileError = function(f, msg) {
 return (psx.FileErrorStr + (msg || '') + " \"" + decodeURI(f) +
         "\": " +  f.error + '.');
};

psx.convertFptr = function(fptr) {
  var f;
  if (fptr.constructor == String) {
    f = File(fptr);

  } else if (fptr instanceof File || fptr instanceof Folder) {
    f = fptr;

  } else {
    Error.runtimeError(19, "fptr");
  }
  return f;
};

psx.writeToFile = function(fptr, str, encoding, lineFeed) {
  var xfile = psx.convertFptr(fptr);
  var rc;

  if (encoding) {
    xfile.encoding = encoding;
  }

  rc = xfile.open("w");
  if (!rc) {
    Error.runtimeError(psx.IO_ERROR_CODE,
                       psx.fileError(xfile, psx.UnableToOpenOutputFile));
  }

  if (lineFeed) {
    xfile.lineFeed = lineFeed;
  }

  rc = xfile.write(str);
  if (!rc && psx.IOEXCEPTIONS_ENABLED) {
    Error.runtimeError(psx.IO_ERROR_CODE, psx.fileError(xfile));
  }

  rc = xfile.close();
  if (!rc && psx.IOEXCEPTIONS_ENABLED) {
    Error.runtimeError(psx.IO_ERROR_CODE, psx.fileError(xfile));
  }
};

psx.readFromFile = function(fptr, encoding, lineFeed) {
  var file = psx.convertFptr(fptr);
  var rc;

  rc = file.open("r");
  if (!rc) {
    Error.runtimeError(psx.IO_ERROR_CODE,
                       psx.fileError(file, psx.UnableToOpenInputFile));
  }
  if (encoding) {
    file.encoding = encoding;
  }
  if (lineFeed) {
    file.lineFeed = lineFeed;
  }
  var str = file.read();

  // in some situations, read() will set the file.error to
  // 'Character conversion error' but read the file anyway
  // in other situations it won't read anything at all from the file
  // we ignore the error if we were able to read the file anyway
  if (str.length == 0 && file.length != 0) {
    if (!file.error) {
      file.error = psx.CharacterConversionError;
    }
    if (psx.IOEXCEPTIONS_ENABLED) {
      Error.runtimeError(psx.IO_ERROR_CODE, psx.fileError(file));
    }
  }
  rc = file.close();
  if (!rc && psx.IOEXCEPTIONS_ENABLED) {
    Error.runtimeError(psx.IO_ERROR_CODE, psx.fileError(file));
  }

  return str;
};

psx.readXMLFile = function(fptr) {
  var rc;
  var file = psx.convertFptr(fptr);
  if (!file.exists) {
    Error.runtimeError(48); // File/Folder does not exist
  }

  file.encoding = "UTF8";
  file.lineFeed = "unix";

  rc = file.open("r", "TEXT", "????");
  if (!rc && psx.IOEXCEPTIONS_ENABLED) {
    Error.runtimeError(psx.IO_ERROR_CODE, psx.fileError(file));
  }

  var str = file.read();

  rc = file.close();
  if (!rc && psx.IOEXCEPTIONS_ENABLED) {
    Error.runtimeError(psx.IO_ERROR_CODE, psx.fileError(file));
  }

  return new XML(str);
};

psx.writeXMLFile = function(fptr, xml) {
  var rc;
  if (!(xml instanceof XML)) {
    Error.runtimeError(19, "xml"); // "Bad XML parameter";
  }

  var file = psx.convertFptr(fptr);
  file.encoding = "UTF8";

  rc = file.open("w", "TEXT", "????");
  if (!rc && psx.IOEXCEPTIONS_ENABLED) {
    Error.runtimeError(psx.IO_ERROR_CODE, psx.fileError(file));
  }

  // unicode signature, this is UTF16 but will convert to UTF8 "EF BB BF"
  // optional
  //file.write("\uFEFF");
  file.lineFeed = "unix";

  file.writeln('<?xml version="1.0" encoding="utf-8"?>');

  rc = file.write(xml.toXMLString());
  if (!rc && psx.IOEXCEPTIONS_ENABLED) {
    Error.runtimeError(psx.IO_ERROR_CODE, psx.fileError(file));
  }

  rc = file.close();
  if (!rc && psx.IOEXCEPTIONS_ENABLED) {
    Error.runtimeError(psx.IO_ERROR_CODE, psx.fileError(file));
  }

  return file;
};

psx.createFileSelect = function(str) {
  if (isWindows()) {
    return str;
  }

  if (!str.constructor == String) {
    return str;
  }

  var exts = [];
  var rex = /\*\.(\*|[\w]+)(.*)/;
  var m;
  while (m = rex.exec(str)) {
    exts.push(m[1].toLowerCase());
    str = m[2];
  }

  function macSelect(f) {
    var name = decodeURI(f.absoluteURI).toLowerCase();
    var _exts = macSelect.exts;

    // alert(name);

    while (f.alias) {
      try {
        f = f.resolve();
      } catch (e) {
        f = null;
      }

      if (f == null) {
        return false;
      }
    }

    if (f instanceof Folder) {
      return true;
    }

    for (var i = 0; i < _exts.length; i++) {
      var ext = _exts[i];
      if (ext == '.*') {
        return true;
      }
      if (name.match(RegExp("\\." + ext + "$", "i")) != null) {
        return true;
      }
    }
    return false;
  }

  macSelect.exts = exts;
  return macSelect;
};

//
// Open a dialog to prompt the user to select a file.
// An initial file or folder can optionally be specified
// Change the current directory reference if we it
// seems appropriate.
//
//  var file = psx.selectFileOpen("Choose a file to open",
//                                "JPEG Files: *.jpg", "/c/tmp")
//  var file = psx.selectFileSave("Choose a file to save",
//                                "JPEG Files: *.jpg", File("/c/tmp/tmp.jpg"))
//
psx.selectFileOpen = function(prompt, select, start) {
  return psx._selectFile(prompt, select, start, true);
};
psx.selectFileSave = function(prompt, select, start) {
  return psx._selectFile(prompt, select, start, false);
};
psx.selectFile = psx.selectFileOpen;

psx._selectFile = function(prompt, select, start, open) {
  var file;

  if (!prompt) {
    prompt = psx.SelectAFile;
  }

  if (start) {
    start = psx.convertFptr(start);
  }

  var classFtn = (open ? File.openDialog : File.saveDialog);

  if (!start) {
    file = classFtn(prompt, select);

  } else {
    if (start instanceof Folder) {
      while (start && !start.exists) {
        start = start.parent;
      }

      var files = start.getFiles(select);
      if (!files || files.length == 0) {
        files = start.getFiles();
      }
      for (var i = 0; i < files.length; i++) {
        if (files[i] instanceof File) {
          start = files[i];
          break;
        }
      }
      if (start instanceof Folder) {
        start = new File(start + "/file");
      }
    }

    if (start instanceof File) {
      var instanceFtn = (open ? "openDlg" : "saveDlg");
      file = start[instanceFtn](prompt, select);

    } else {
      file = Folder.selectDialog(prompt);
    }
  }

  if (file) {
    Folder.current = file.parent;
  }
  return file;
};

psx.selectFolder = function(prompt, start) {
  var folder;

  if (!prompt) {
    prompt = psx.SelectFolder;
  }

  if (start) {
    start = psx.convertFptr(start);
    while (start && !start.exists) {
      start = start.parent;
    }
  }

  if (!start) {
    folder = Folder.selectDialog(prompt);

  } else {
    if (start instanceof File) {
      start = start.parent;
    }

    folder = start.selectDlg(prompt);
  }

  return folder;
};

psx.getFiles = function(folder, mask) {
  var files = [];

  folder = psx.convertFptr(folder);

  if (folder.alias) {
    folder = folder.resolve();
  }

  return folder.getFiles(mask);
};

psx.getFolders = function(folder) {
  folder = psx.convertFptr(folder);

  if (folder.alias) {
    folder = folder.resolve();
  }
  var folders = psx.getFiles(folder,
                             function(f) { return f instanceof Folder; });
  return folders;
};

psx.findFiles = function(folder, mask) {
  folder = psx.convertFptr(folder);

  if (folder.alias) {
    folder = folder.resolve();
  }
  var files = psx.getFiles(folder, mask);
  var folders = psx.getFolders(folder);

  for (var i = 0; i < folders.length; i++) {
    var f = folders[i];
    var ffs = psx.findFiles(f, mask);
    // files.concat(ffs); This occasionally fails for some unknown reason (aka
    // interpreter Bug) so we do it manually instead
    while (ffs.length > 0) {
      files.push(ffs.shift());
    }
  }
  return files;
};

//
// Thanks to Bob Stucky for this...
//
psx.exceptionMessage = function(e) {
  var str = '';
  var fname = (!e.fileName ? '???' : decodeURI(e.fileName));
  str += "   Message: " + e.message + '\n';
  str += "   File: " + fname + '\n';
  str += "   Line: " + (e.line || '???') + '\n';
  str += "   Error Name: " + e.name + '\n';
  str += "   Error Number: " + e.number + '\n';

  if (e.source) {
    var srcArray = e.source.split("\n");
    var a = e.line - 10;
    var b = e.line + 10;
    var c = e.line - 1;
    if (a < 0) {
      a = 0;
    }
    if (b > srcArray.length) {
      b = srcArray.length;
    }
    for ( var i = a; i < b; i++ ) {
      if ( i == c ) {
        str += "   Line: (" + (i + 1) + ") >> " + srcArray[i] + '\n';
      } else {
        str += "   Line: (" + (i + 1) + ")    " + srcArray[i] + '\n';
      }
    }
  }

  try {
    if ($.stack) {
      str += '\n' + $.stack + '\n';
    }
  } catch (e) {
  }

  if (str.length > psx.exceptionMessage._maxMsgLen) {
    str = str.substring(0, psx.exceptionMessage._maxMsgLen) + '...';
  }

  if (LogFile.defaultLog.fptr) {
    str += "\nLog File:" + LogFile.defaultLog.fptr.toUIString();
  }

  return str;
};
psx.exceptionMessage._maxMsgLen = 5000;

//============================ LogFile =================================

LogFile = function(fname) {
  var self = this;
  
  self.filename = fname;
  self.enabled = fname != undefined;
  self.encoding = "UTF8";
  self.append = false;
  self.fptr = undefined;
};

LogFile.prototype.setFilename = function(filename, encoding) {
  var self = this;
  self.filename = filename;
  self.enabled = filename != undefined;
  self.encoding = encoding || "UTF8";
  self.fptr = undefined;
};

LogFile.prototype.write = function(msg) {
  var self = this;
  var file;

  if (!self.enabled) {
    return;
  }

  if (!self.filename) {
    return;
  }

  if (!self.fptr) {
    file = new File(self.filename);
    if (self.append && file.exists) {
      if (!file.open("e", "TEXT", "????"))  {
        var err = psx.UnableToOpenLogFile.sprintf(file.toUIString(),
                                                  file.error);
        Error.runtimeError(psx.IO_ERROR_CODE, err);
      }
      file.seek(0, 2); // jump to the end of the file

    } else {
      if (!file.open("w", "TEXT", "????")) {
        if (!file.open("e", "TEXT", "????")) {
          var err = psx.UnableToOpenLogFile.sprintf(file.toUIString(),
                                                    file.error);
          Error.runtimeError(psx.IO_ERROR_CODE, err);
        }
        file.seek(0, 0); // jump to the beginning of the file
      }
    }
    self.fptr = file;

  } else {
    file = self.fptr;
    if (!file.open("e", "TEXT", "????"))  {
      var err = psx.UnableToOpenLogFile.sprintf(file.toUIString(),
                                                file.error);
      Error.runtimeError(psx.IO_ERROR_CODE, err);
    }
    file.seek(0, 2); // jump to the end of the file
  }

  if (isMac()) {
    file.lineFeed = "Unix";
  }

  if (self.encoding) {
    file.encoding = self.encoding;
  }

  if (msg) {
    msg = msg.toString();
  }

  if (!file.writeln(new Date().toISODateString() + " - " + msg)) {
    var err = psx.UnableToOpenLogFile.sprintf(file.toUIString(),
                                              file.error);
    Error.runtimeError(psx.IO_ERROR_CODE, err);
  }

  file.close();
};

LogFile.defaultLog = new LogFile(Folder.userData + "/stdout.log");

LogFile.setFilename = function(fptr, encoding) {
  LogFile.defaultLog.setFilename(fptr, encoding);
};
LogFile.write = function(msg) {
  LogFile.defaultLog.write(msg);
};

LogFile.logException = function(e, msg, doAlert) {
  var log = LogFile.defaultLog;
  if (!log || !log.enabled) {
    return;
  }

  if (doAlert == undefined) {
    doAlert = false;

    if (msg == undefined) {
      msg = '';
    } else if (isBoolean(msg)) {
      doAlert = msg;
      msg = '';
    }
  }

  doAlert = !!doAlert;

  var str = ((msg || '') + "\n" +
             "==============Exception==============\n" +
             psx.exceptionMessage(e) +
             "\n==============End Exception==============\n");

  log.write(str);

  if (doAlert) {
    str += ("\r\r" + Strings.LogFileReferences + "\r" +
            "    " + log.fptr.toUIString());

    alert(str);
  }
};


function toBoolean(s) {
  if (s == undefined) { return false; }
  if (s.constructor == Boolean) { return s.valueOf(); }
  try { if (s instanceof XML) s = s.toString(); } catch (e) {}
  if (s.constructor == String)  { return s.toLowerCase() == "true"; }

  return Boolean(s);
};

function isBoolean(s) {
  return (s != undefined && s.constructor == Boolean);
}

function toNumber(s) {
  if (s == undefined) { return NaN; }
  try { if (s instanceof XML) s = s.toString(); } catch (e) {}
  if (s.constructor == String && s.length == 0) { return NaN; }
  if (s.constructor == Number) { return s.valueOf(); }
  return Number(s.toString());
};

function isNumber(s) {
  try { if (s instanceof XML) s = s.toString(); }
  catch (e) {}
  return !isNaN(s);
};

function isString(s) {
  return (s != undefined && s.constructor == String);
};

function toFont(fs) {
  if (fs.typename == "TextFont") { return fs.postScriptName; }

  var str = fs.toString();
  var f = psx.determineFont(str);  // first, check by PS name

  return (f ? f.postScriptName : undefined);
};

psx.getByName = function(container, value, all) {
  return psx.getByProperty(container, "name", value, all);
};
psx.getByProperty = function(container, prop, value, all) {
  // check for a bad index
  if (prop == undefined) {
    Error.runtimeError(2, "prop");
  }
  if (value == undefined) {
    Error.runtimeError(2, "value");
  }
  var matchFtn;

  all = !!all;

  if (value instanceof RegExp) {
    matchFtn = function(s1, re) { return s1.match(re) != null; };
  } else {
    matchFtn = function(s1, s2) { return s1 == s2; };
  }

  var obj = [];

  for (var i = 0; i < container.length; i++) {
    if (matchFtn(container[i][prop], value)) {
      if (!all) {
        return container[i];     // there can be only one!
      }
      obj.push(container[i]);    // add it to the list
    }
  }

  return all ? obj : undefined;
};

psx.determineFont = function(str) {
  return (psx.getByName(app.fonts, str) ||
          psx.getByProperty(app.fonts, 'postScriptName', str));
};


//
// Trim leading and trailing whitepace from a string
//
psx.trim = function(value) {
   return value.replace(/^[\s]+|[\s]+$/g, '');
};


psx.copyFromTo = function(from, to) {
  if (!from || !to) {
    return;
  }
  for (var idx in from) {
    var v = from[idx];
    if (typeof v == 'function') {
      continue;
    }
    if (v == 'typename'){
      continue;
    }

    to[idx] = v;
  }
};

psx.listProps = function(obj) {
  var s = '';
  var sep = (isBridge() ? "\r" : "\r\n");
  for (var x in obj) {
    s += x + ":\t";
    try {
      var o = obj[x];

      s += (typeof o == "function") ? "[function]" : o;
    } catch (e) {
    }
    s += sep;
  }
  return s;
};


//
//============================ Strings  Extensions ===========================
//

String.prototype.contains = function(sub) {
  return this.indexOf(sub) != -1;
};

String.prototype.containsWord = function(str) {
  return this.match(new RegExp("\\b" + str + "\\b")) != null;
};

String.prototype.endsWith = function(sub) {
  return this.length >= sub.length &&
    this.slice(this.length - sub.length) == sub;
};

String.prototype.reverse = function() {
  var ar = this.split('');
  ar.reverse();
  return ar.join('');
};

String.prototype.startsWith = function(sub) {
  return this.indexOf(sub) == 0;
};

String.prototype.trim = function() {
  return this.replace(/^[\s]+|[\s]+$/g, '');
};
String.prototype.ltrim = function() {
  return this.replace(/^[\s]+/g, '');
};
String.prototype.rtrim = function() {
  return this.replace(/[\s]+$/g, '');
};


//========================= String formatting ================================
//
// String.sprintf
//
// Documentation:
//   http://www.opengroup.org/onlinepubs/007908799/xsh/fprintf.html
//
// From these sites:
//   http://forums.devshed.com/html-programming-1/sprintf-39065.html
//   http://jan.moesen.nu/code/javascript/sprintf-and-printf-in-javascript/
//
String.prototype.sprintf = function() {
  var args = [this];
  for (var i = 0; i < arguments.length; i++) {
    args.push(arguments[i]);
  }
  return String.sprintf.apply(null, args);
};
String.sprintf = function() {
  function _sprintf() {
    if (!arguments || arguments.length < 1 || !RegExp)  {
      return "Error";
    }
    var str = arguments[0];
    var re = /([^%]*)%('.|0|\x20)?(-)?(\d+)?(\.\d+)?(%|b|c|d|u|f|o|s|x|X)/m;
            //') /* for xemacs auto-indent  */
    var a = b = [], numSubstitutions = 0, numMatches = 0;
    var result = '';

    while (a = re.exec(str)) {
      var leftpart = a[1], pPad = a[2], pJustify = a[3], pMinLength = a[4];
      var pPrecision = a[5], pType = a[6], rightPart = a[7];

      rightPart = str.slice(a[0].length);

      numMatches++;

      if (pType == '%') {
        subst = '%';
      } else {
        numSubstitutions++;
        if (numSubstitutions >= arguments.length) {
          alert('Error! Not enough function arguments (' +
                (arguments.length - 1)
                + ', excluding the string)\n'
                + 'for the number of substitution parameters in string ('
                + numSubstitutions + ' so far).');
        }
        var param = arguments[numSubstitutions];
        var pad = '';
        if (pPad && pPad.slice(0,1) == "'") {
          pad = leftpart.slice(1,2);
        } else if (pPad) {
          pad = pPad;
        }
        var justifyRight = true;
        if (pJustify && pJustify === "-") {
          justifyRight = false;
        }
        var minLength = -1;
        if (pMinLength) {
          minLength = toNumber(pMinLength);
        }
        var precision = -1;
        if (pPrecision && pType == 'f') {
          precision = toNumber(pPrecision.substring(1));
        }
        var subst = param;
        switch (pType) {
        case 'b':
          subst = toNumber(param).toString(2);
          break;
        case 'c':
          subst = String.fromCharCode(toNumber(param));
          break;
        case 'd':
          subst = toNumber(param) ? Math.round(toNumber(param)) : 0;
            break;
        case 'u':
          subst = Math.abs(Math.round(toNumber(param)));
          break;
        case 'f':
          if (precision == -1) {
            precision = 6;
          }
          subst = parseFloat(param).toFixed(Math.min(precision, 20));
//             ? Math.round(parseFloat(param) * Math.pow(10, precision))
//             / Math.pow(10, precision)
//             : ;
            break;
        case 'o':
          subst = toNumber(param).toString(8);
          break;
        case 's':
          subst = param;
          break;
        case 'x':
          subst = ('' + toNumber(param).toString(16)).toLowerCase();
          break;
        case 'X':
          subst = ('' + toNumber(param).toString(16)).toUpperCase();
          break;
        }
        var padLeft = minLength - subst.toString().length;
        if (padLeft > 0) {
          var arrTmp = new Array(padLeft+1);
          var padding = arrTmp.join(pad?pad:" ");
        } else {
          var padding = "";
        }
      }
      result += leftpart + padding + subst;
      str = rightPart;
    }
    result += str;
    return result;
  };

  return _sprintf.apply(null, arguments);
};


//========================= Date formatting ================================
//
// Date.strftime
//    This is a third generation implementation. This is a JavaScript
//    implementation of C the library function 'strftime'. It supports all
//    format specifiers except U, W, z, Z, G, g, O, E, and V.
//    For a full description of this function, go here:
//       http://www.opengroup.org/onlinepubs/007908799/xsh/strftime.html
//    Donating implementations can be found here:
//       http://redhanded.hobix.com/inspect/showingPerfectTime.html
//    and here:
//       http://wiki.osafoundation.org/bin/view/Documentation/JavaScriptStrftime
//
// Object Method
Date.prototype.strftime = function (fmt) {
  return Date.strftime(this, fmt);
};

// Class Function
Date.strftime = function(date, fmt) {
  var t = date;
  var cnvts = Date.prototype.strftime._cnvt;
  var str = fmt;
  var m;
  var rex = /([^%]*)%([%aAbBcCdDehHIjmMprRStTuwxXyYZ]{1})(.*)/;

  var result = '';
  while (m = rex.exec(str)) {
    var pre = m[1];
    var typ = m[2];
    var post = m[3];
    result += pre + cnvts[typ](t);
    str = post;
  }
  result += str;
  return result;
};

// the specifier conversion function table
Date.prototype.strftime._cnvt = {
  zeropad: function( n ){ return n>9 ? n : '0'+n; },
  spacepad: function( n ){ return n>9 ? n : ' '+n; },
  ytd: function(t) {
    var first = new Date(t.getFullYear(), 0, 1).getTime();
    var diff = t.getTime() - first;
    return parseInt(((((diff/1000)/60)/60)/24))+1;
  },
  a: function(t) {
    return ['Sun','Mon','Tue','Wed','Thu','Fri','Sat'][t.getDay()];
  },
  A: function(t) {
    return ['Sunday','Monday','Tuesdsay','Wednesday','Thursday','Friday',
            'Saturday'][t.getDay()];
  },
  b: function(t) {
    return ['Jan','Feb','Mar','Apr','May','Jun', 'Jul','Aug','Sep','Oct',
            'Nov','Dec'][t.getMonth()]; },
  B: function(t) {
    return ['January','February','March','April','May','June', 'July','August',
            'September','October','November','December'][t.getMonth()]; },
  c: function(t) {
    return (this.a(t) + ' ' + this.b(t) + ' ' + this.e(t) + ' ' +
            this.H(t) + ':' + this.M(t) + ':' + this.S(t) + ' ' + this.Y(t));
  },
  C: function(t) { return this.Y(t).slice(0, 2); },
  d: function(t) { return this.zeropad(t.getDate()); },
  D: function(t) { return this.m(t) + '/' + this.d(t) + '/' + this.y(t); },
  e: function(t) { return this.spacepad(t.getDate()); },
  // E: function(t) { return '-' },
  F: function(t) { return this.Y(t) + '-' + this.m(t) + '-' + this.d(t); },
  g: function(t) { return '-'; },
  G: function(t) { return '-'; },
  h: function(t) { return this.b(t); },
  H: function(t) { return this.zeropad(t.getHours()); },
  I: function(t) {
    var s = this.zeropad((t.getHours() + 12) % 12);
    return (s == "00") ? "12" : s;
  },
  j: function(t) { return this.ytd(t); },
  k: function(t) { return this.spacepad(t.getHours()); },
  l: function(t) {
    var s = this.spacepad((t.getHours() + 12) % 12);
    return (s == " 0") ? "12" : s;
  },
  m: function(t) { return this.zeropad(t.getMonth()+1); }, // month-1
  M: function(t) { return this.zeropad(t.getMinutes()); },
  n: function(t) { return '\n'; },
  // O: function(t) { return '-' },
  p: function(t) { return this.H(t) < 12 ? 'AM' : 'PM'; },
  r: function(t) {
    return this.I(t) + ':' + this.M(t) + ':' + this.S(t) + ' ' + this.p(t);
  },
  R: function(t) { return this.H(t) + ':' + this.M(t); },
  S: function(t) { return this.zeropad(t.getSeconds()); },
  t: function(t) { return '\t'; },
  T: function(t) {
    return this.H(t) + ':' + this.M(t) + ':' + this.S(t) + ' ' + this.p(t);
  },
  u: function(t) {return t.getDay() ? t.getDay()+1 : 7; },
  U: function(t) { return '-'; },
  w: function(t) { return t.getDay(); }, // 0..6 == sun..sat
  W: function(t) { return '-'; },       // not available
  x: function(t) { return this.D(t); },
  X: function(t) { return this.T(t); },
  y: function(t) { return this.zeropad(this.Y(t) % 100); },
  Y: function(t) { return t.getFullYear().toString(); },
  z: function(t) { return ''; },
  Z: function(t) { return ''; },
  '%': function(t) { return '%'; }
};

// this needs to be worked on...
function _weekNumber(date) {
  var ytd = toNumber(date.strftime("%j"));
  var week = Math.floor(ytd/7);
  if (new Date(date.getFullYear(), 0, 1).getDay() < 4) {
    week++;
  }
  return week;
};

//
// Format a Date object into a proper ISO 8601 date string
//
psx.toISODateString = function(date, timeDesignator, dateOnly, precision) {
  if (!date) date = new Date();
  var str = '';
  if (timeDesignator == undefined) { timeDesignator = 'T'; };
  function _zeroPad(val) { return (val < 10) ? '0' + val : val; }
  if (date instanceof Date) {
    str = (date.getFullYear() + '-' +
           _zeroPad(date.getMonth()+1,2) + '-' +
           _zeroPad(date.getDate(),2));
    if (!dateOnly) {
      str += (timeDesignator +
              _zeroPad(date.getHours(),2) + ':' +
              _zeroPad(date.getMinutes(),2) + ':' +
              _zeroPad(date.getSeconds(),2));
      if (precision && typeof(precision) == "number") {
        var ms = date.getMilliseconds();
        if (ms) {
          var millis = _zeroPad(ms.toString(),precision);
          var s = millis.slice(0, Math.min(precision, millis.length));
          str += "." + s;
        }
      }
    }
  }
  return str;
};

//
// Make it a Date object method
//
Date.prototype.toISODateString = function(timeDesignator, dateOnly, precision) {
  return psx.toISODateString(this, timeDesignator, dateOnly, precision);
};

// some ISO8601 formats
Date.strftime.iso8601_date = "%Y-%m-%d";
Date.strftime.iso8601_full = "%Y-%m-%dT%H:%M:%S";
Date.strftime.iso8601      = "%Y-%m-%d %H:%M:%S";
Date.strftime.iso8601_time = "%H:%M:%S";

Date.prototype.toISO = function() {
  return this.strftime(Date.strftime.iso8601);
};

Date.prototype.toISOString = Date.prototype.toISODateString;


//
//============================ Array  Extensions ===========================
//

Array.contains = function(ar, el) {
  for (var i = 0; i < ar.length; i++) {
    if (ar[i] == el) {
      return true;
    }
  }
  return false;
};
if (!Array.prototype.contains) {
  Array.prototype.contains = function(el) {
    for (var i = 0; i < this.length; i++) {
      if (this[i] == el) {
        return true;
      }
    }
    return false;
  };
}

if (!Array.prototype.indexOf) {
  Array.prototype.indexOf = function(el) {
    for (var i = 0; i < this.length; i++) {
      if (this[i] == el) {
        return i;
      }
    }
    return -1;
  };
}
if (!Array.prototype.lastIndexOf) {
  Array.prototype.indexOf = function(el) {
    for (var i = this.length-1; i >= 0; i--) {
      if (this[i] == el) {
        return i;
      }
    }
  return -1;
  };
}

// a simple timer...
Timer = function() {
  var self = this;
  self.startTime = 0;
  self.stopTime  = 0;
  self.elapsed = 0;
  self.cummulative = 0;
  self.count = 0;
};

Timer.prototype.start = function() {
  this.startTime = new Date().getTime();
};
Timer.prototype.stop = function() {
  var self = this;
  self.stopTime = new Date().getTime();
  self.elapsed = (self.stopTime - self.startTime)/1000.00;
  self.cummulative += self.elapsed;
  self.count++;
  self.per = self.cummulative/self.count;
};


//
//======================== File and Folder ===================================
//
File.prototype.toUIString = function() {
  return decodeURI(this.fsName);
};
Folder.prototype.toUIString = function() {
  return decodeURI(this.fsName);
};

//========================= Filename formatting ===============================
//
// File.strf(fmt [, fs])
// Folder.strf(fmt [, fs])
//   This is based of the file name formatting facility in exiftool. Part of
//   the description is copied directly from there. You can find exiftool at:
//      http://www.sno.phy.queensu.ca/~phil/exiftool/
//
// Description:
//   Format a file string using a printf-like format string
//
// fmt is a string where the following substitutions occur
//   %d - the directory name (no trailing /)
//   %f - the file name without the extension
//   %e - the file extension without the leading '.'
//   %p - the name of the parent folder
//   %% - the '%' character
//
// if fs is true the folder is in local file system format
//   (e.g. C:\images instead of /c/images)
//
// Examples:
//
// Reformat the file name:
// var f = new File("/c/work/test.jpg");
// f.strf("%d/%f_%e.txt") == "/c/work/test_jpg.txt"
//
// Change the file extension
// f.strf("%d/%f.psd") == "/c/work/test.psd"
//
// Convert to a file name in a subdirectory named after the extension
// f.strf("%d/%e/%f.%e") == "/c/work/jpg/test.jpg"
//
// Change the file extension and convert to a file name in a subdirectory named
//   after the new extension
// f.strf("%d/psd/%f.psd") == "/c/work/psd/test.psd"
//
// var f = new File("~/.bashrc");
// f.strf("%f") == ".bashrc"
// f.strf("%e") == ""
//
// Advanced Substitution
//   A substring of the original file name, directory or extension may be
//   taken by specifying a string length immediately following the % character.
//   If the length is negative, the substring is taken from the end. The
//   substring position (characters to ignore at the start or end of the
//   string) may be given by a second optional value after a decimal point.
// For example:
//
// var f = new File("Picture-123.jpg");
//
// f.strf("%7f.psd") == "Picture.psd"
// f.strf("%-.4f.psd") == "Picture.psd"
// f.strf("%7f.%-3f") == "Picture.123"
// f.strf("Meta%-3.1f.xmp") == "Meta12.xmp"
//
File.prototype.strf = function(fmt, fs) {
  var self = this;
  var name = decodeURI(self.name);
  //var name = (self.name);

  // get the portions of the full path name

  // extension
  var m = name.match(/.+\.([^\.\/]+)$/);
  var e = m ? m[1] : '';

  // basename
  m = name.match(/(.+)\.[^\.\/]+$/);
  var f = m ? m[1] : name;

  fs |= !($.os.match(/windows/i)); // fs only matters on Windows
  // fs |= isMac();

  // full path...
  var d = decodeURI((fs ? self.parent.fsName : self.parent.absoluteURI));

  // parent directory...
  var p = decodeURI(self.parent.name);

  //var d = ((fs ? self.parent.fsName : self.parent.toString()));

  var str = fmt;

  // a regexp for the format specifiers

  var rex = /([^%]*)%(-)?(\d+)?(\.\d+)?(%|d|e|f|p)(.*)/;

  var result = '';

  while (m = rex.exec(str)) {
    var pre = m[1];
    var sig = m[2];
    var len = m[3];
    var ign = m[4];
    var typ = m[5];
    var post = m[6];

    var subst = '';

    if (typ == '%') {
      subst = '%';
    } else {
      var s = '';
      switch (typ) {
        case 'd': s = d; break;
        case 'e': s = e; break;
        case 'f': s = f; break;
        case 'p': s = p; break;
        // default: s = "%" + typ; break; // let others pass through
      }

      var strlen = s.length;

      if (strlen && (len || ign)) {
        ign = (ign ? Number(ign.slice(1)) : 0);
        if (len) {
          len = Number(len);
          if (sig) {
            var _idx = strlen - len - ign;
            subst = s.slice(_idx, _idx+len);
          } else {
            subst = s.slice(ign, ign+len);
          }
        } else {
          if (sig) {
            subst = s.slice(0, strlen-ign);
          } else {
            subst = s.slice(ign);
          }
        }

      } else {
        subst = s;
      }
    }

    result += pre + subst;
    str = post;
  }

  result += str;

  return result;
};
Folder.prototype.strf = File.prototype.strf;


//=========================== PS Functions ===============================

psx.convertProfile = function(doc, profile) {
  profile = profile.replace(/\.icc$/i, '');

  function _ftn() {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();
    ref.putEnumerated( cTID('Dcmn'), cTID('Ordn'), cTID('Trgt') );
    desc.putReference( cTID('null'), ref);
    desc.putString( cTID('T   '), profile );
    desc.putEnumerated( cTID('Inte'), cTID('Inte'), cTID('Clrm') );
    desc.putBoolean( cTID('MpBl'), true );
    desc.putBoolean( cTID('Dthr'), false );
    desc.putInteger( cTID('sdwM'), -1 );
    executeAction( sTID('convertToProfile'), desc, DialogModes.NO );
  }

  _ftn();
};

psx.doEvent = function(doc, eid, interactive, noDesc) {
  var id;

  if (doc != undefined && eid == undefined) {
    if (doc.constructor == Number) {
      eid = doc.valueOf();
    } else if (doc.constructor == String) {
      eid = doc;
    }
    doc = undefined;
  }

  if (!eid) {
    Error.runtimeError(8600); // Event key is missing "No event id specified");
  }

  if (eid.constructor != Number) {
    if (eid.length < 4) {
      // "Event id must be at least 4 characters long"
      Error.runtimeError(19, "eventID");
    }

    if (eid.length == 4) {
      id = cTID(eid);
    } else {
      id = sTID(eid);
    }
  } else {
    id  = eid;
  }

  interactive = interactive == true;
  noDesc = noDesc == true;

  var dmode = (interactive ? DialogModes.ALL : DialogModes.NO);
  var desc = (noDesc ? undefined : new ActionDescriptor());
  return app.executeAction(id, desc, dmode);
};

psx.getDocumentDescriptor = function(doc) {
  var active = undefined;
  if (doc && doc != app.activeDocument) {
    active = app.activeDocument;
    app.activeDocument = doc;
  }
  var ref = new ActionReference();
  ref.putEnumerated( cTID("Dcmn"),
                     cTID("Ordn"),
                     cTID("Trgt") );  //activeDoc
  var desc = executeActionGet(ref);

  if (active) {
    app.activeDocument = active;
  }

  return desc;
};
psx.getDocumentIndex = function(doc) {
  var docs = app.documents;
  for (var i = 0; i < docs.length; i++) {
    if (docs[i] == doc) {
      return i+1;
    }
  }

  return -1;

//   return psx.getDocumentDescriptor(doc).getInteger(cTID('ItmI'));
};

psx.revertDocument = function(doc) {
  psx.doEvent(doc, "Rvrt");
};


// doing it this way avoids the side effect recomputing the histogram
psx.getDocumentName = function(doc) {
  function _ftn() {
    var ref = new ActionReference();
    ref.putProperty(cTID('Prpr'), cTID('FilR'));
    ref.putEnumerated(cTID('Dcmn'), cTID('Ordn'), cTID('Trgt'));
    var desc = executeActionGet(ref);
    return desc.hasKey(cTID('FilR')) ? desc.getPath(cTID('FilR')) : undefined;
  }
  return _ftn();
};

psx.copyLayerToDocument = function(doc, layer, otherDoc) {
  var desc = new ActionDescriptor();
  var fref = new ActionReference();
  fref.putEnumerated(cTID('Lyr '), cTID('Ordn'), cTID('Trgt'));
  desc.putReference(cTID('null'), fref);
  var tref = new ActionReference();
  tref.putIndex(cTID('Dcmn'), psx.getDocumentIndex(otherDoc));
  // tref.putName(cTID('Dcmn'), otherDoc.name);
  desc.putReference(cTID('T   '), tref);
  desc.putInteger(cTID('Vrsn'), 2 );
  executeAction(cTID('Dplc'), desc, DialogModes.NO);
};

psx.getLayerDescriptor = function(doc, layer) {
  var ref = new ActionReference();
  ref.putEnumerated(cTID("Lyr "), cTID("Ordn"), cTID("Trgt"));
  return executeActionGet(ref);
};

psx.createLayerMask = function(doc, layer, fromSelection) {
  var desc = new ActionDescriptor();
  desc.putClass(cTID("Nw  "), cTID("Chnl"));
  var ref = new ActionReference();
  ref.putEnumerated(cTID("Chnl"), cTID("Chnl"), cTID("Msk "));
  desc.putReference(cTID("At  "), ref);
  if (fromSelection == true) {
    desc.putEnumerated(cTID("Usng"), cTID("UsrM"), cTID("RvlS"));
  } else {
    desc.putEnumerated(cTID("Usng"), cTID("UsrM"), cTID("RvlA"));
  }
  executeAction(cTID("Mk  "), desc, DialogModes.NO);
};

psx.hasLayerMask = function(doc, layer) {
  return psx.getLayerDescriptor().hasKey(cTID("UsrM"));
};
psx.isLayerMaskEnabled = function(doc, layer) {
  var desc = psx.getLayerDescriptor(doc, layer);
  return (desc.hasKey(cTID("UsrM")) && desc.getBoolean(cTID("UsrM")));
};
psx.disableLayerMask = function(doc, layer) {
  psx.setLayerMaskEnabledState(doc, layer, false);
};
psx.enableLayerMask = function(doc, layer) {
  psx.setLayerMaskEnabledState(doc, layer, true);
};
psx.setLayerMaskEnabledState = function(doc, layer, state) {
  if (state == undefined) {
    state = false;
  }
  var desc = new ActionDescriptor();

  var ref = new ActionReference();
  ref.putEnumerated(cTID('Lyr '), cTID('Ordn'), cTID('Trgt'));
  desc.putReference(cTID('null'), ref );

  var tdesc = new ActionDescriptor();
  tdesc.putBoolean(cTID('UsrM'), state);
  desc.putObject(cTID('T   '), cTID('Lyr '), tdesc);

  executeAction(cTID('setd'), desc, DialogModes.NO );
};

psx.mergeVisible = function(doc) {
  psx.doEvent(doc, "MrgV");  // "MergeVisible"
};


// the layer bounds without the mask
psx.getLayerBounds = function(doc, layer) {
  var ru = app.preferences.rulerUnits;

  var reenable = false;
  var st;
  if (psx.hasLayerMask(doc, layer) &&
      psx.isLayerMaskEnabled(doc, layer)) {
      st = doc.activeHistoryState;
    psx.disableLayerMask(doc, layer);
    reenable = true;
  }

  var lbnds = layer.bounds;
  
  // fix this to modify the history state
  if (reenable) {
    psx.enableLayerMask(doc, layer);
  }
  for (var i = 0; i < 4; i++) {
    lbnds[i] = lbnds[i].as("px");
  }

  return lbnds;
};

psx.selectBounds = function(doc, b, type, feather, antialias) {
  if (feather == undefined) {
    feather = 0;
  }

  if (antialias == undefined) {
    antialias = false;
  }
  
  doc.selection.select([[ b[0], b[1] ],
                        [ b[2], b[1] ],
                        [ b[2], b[3] ],
                        [ b[0], b[3] ]],
                       type, feather, antialias);
};
psx.getSelectionBounds = function(doc) {
  var bnds = [];
  var sbnds = doc.selection.bounds;
  for (var i = 0; i < sbnds.length; i++) {
    bnds[i] = sbnds[i].as("px");
  }
  return bnds;
};

psx.hasSelection = function(doc) {
  var res = false;

  var as = doc.activeHistoryState;
  doc.selection.deselect();
  if (as != doc.activeHistoryState) {
    res = true;
    doc.activeHistoryState = as;
  }

  return res;
};

psx.rgbToString = function(c) {
  return "[" + c.rgb.red + "," + c.rgb.green + "," + c.rgb.blue + "]";
};
psx.rgbToArray = function(c) {
  return [c.rgb.red, c.rgb.green, c.rgb.blue];
};
psx.rgbFromString = function(str) {
  var rex = /([\d\.]+),([\d\.]+),([\d\.]+)/;
  var m = str.match(rex);
  if (m) {
    return psx.createRGBColor(Number(m[1]),
                              Number(m[2]),
                              Number(m[3]));
  }
  return undefined;
};
psx.createRGBColor = function(r, g, b) {
  var c = new RGBColor();
  if (r instanceof Array) {
    b = r[2]; g = r[1]; r = r[0];
  }
  c.red = parseInt(r); c.green = parseInt(g); c.blue = parseInt(b);
  var sc = new SolidColor();
  sc.rgb = c;
  return sc;
};

psx.COLOR_BLACK = psx.createRGBColor(0, 0, 0);
psx.COLOR_RED = psx.createRGBColor(255, 0, 0);
psx.COLOR_GREEN = psx.createRGBColor(0, 255, 0);
psx.COLOR_BLUE = psx.createRGBColor(0, 0, 255);
psx.COLOR_GRAY = psx.createRGBColor(128, 128, 128);
psx.COLOR_WHITE = psx.createRGBColor(255, 255, 255);

psx.colorFromString = function(str) {
  var c = psx.rgbFromString(str);
  if (!c) {
    str = str.toLowerCase();
    if (str == "black") {
      c = psx.COLOR_BLACK;
    } else if (str == "white") {
      c = psx.COLOR_WHITE;
    } else if (str == "foreground") {
      c = app.foregroundColor;
    } else if (str == "background") {
      c = app.backgroundColor;
    } else if (str == "gray" || str == "grey") {
      c = psx.COLOR_GRAY;
    } else if (str == "red") {
      c = psx.COLOR_RED;
    } else if (str == "green") {
      c = psx.COLOR_GREEN;
    } else if (str == "blue") {
      c = psx.COLOR_BLUE;
    }
  }
  return c;
};

psx.winFileSelection = function(f) {
	var suffix = f.name.match(/[.](\w+)$/);
	var t;
	
	if (suffix && suffix.length == 2)	{
		suffix = suffix[1].toUpperCase();
		for (t in app.windowsFileTypes) {
			if (suffix == app.windowsFileTypes[t]) {
				// Ignore mac-generated system thumbnails
				if (f.name.slice(0,2) != "._") {
					return true;
        }
			}
    }
	}
	return false;

};

psx.macFileSelection = function(f) {
	var t;
	for (t in app.macintoshFileTypes) {
		if (f.type == app.macintoshFileTypes[t]) {
			return true;
    }
  }
	
	// Also check windows suffixes...
	return winFileSelection( f );	
}


psx.isValidImageFile = function(f) {
  function _winCheck(f) {
    // skip mac system files
    if (f.name.startsWith("._")) {
      return false;
    }

    var ext = f.strf('%e').toUpperCase();
    return (ext.length > 0) && app.windowsFileTypes.contains(ext);
  }
  function _macCheck(f) {
    return app.macintoshFileTypes.contains(f.type) || _winCheck(f);
  }

  return ((f instanceof File) &&
          (((File.fs == "Macintosh") && _macCheck(f)) ||
           ((File.fs == "Windows") && _winCheck(f))));
};




//============================ Actions =====================================

psx.getActionSets = function() {
  var i = 1;
  var sets = [];

  while (true) {
    var ref = new ActionReference();
    ref.putIndex(cTID("ASet"), i);
    var desc;
    var lvl = $.level;
    $.level = 0;
    try {
      desc = executeActionGet(ref);
    } catch (e) {
      break;    // all done
    } finally {
      $.level = lvl;
    }
    if (desc.hasKey(cTID("Nm  "))) {
      var set = {};
      set.index = i;
      set.name = desc.getString(cTID("Nm  "));
      set.toString = function() { return this.name; };
      set.count = desc.getInteger(cTID("NmbC"));
      set.actions = [];
      for (var j = 1; j <= set.count; j++) {
        var ref = new ActionReference();
        ref.putIndex(cTID('Actn'), j);
        ref.putIndex(cTID('ASet'), set.index);
        var adesc = executeActionGet(ref);
        var actName = adesc.getString(cTID('Nm  '));
        set.actions.push(actName);
      }
      sets.push(set);
    }
    i++;
  }

  return sets;
};


//============================= ScriptUI stuff =============================

psxui = function() {}

psxui.numberKeystrokeFilter = function() {
  if (this.text.match(/[^\-\.\d]/)) {
    this.text = this.text.replace(/[^\-\.\d]/g, '');
  }
};
psxui.numericKeystrokeFilter = function() {
  if (this.text.match(/[^\d]/)) {
    this.text = this.text.replace(/[^\d]/g, '');
  }
};
psxui.unitValueKeystrokeFilter = function() {
  if (this.text.match(/[^(\w% \.)]/)) {
    this.text = this.text.toLowerCase().replace(/[^(\w% \.)]/g, '');
  }
};


psxui.setMenuSelection = function(menu, txt, def, ignoreCase) {
  var it = menu.find(txt);

  if (!it && ignoreCase) {
    var items = menu.items;
    txt = txt.toLowerCase();
    for (var i = 0; i < items.length; i++) {
      if (txt == items[i].text.toLowerCase()) {
        it = items[i];
        break;
      }
    }
  }

  if (!it) {
    if (def != undefined) {
      var n = toNumber(def);
      if (!isNaN(n)) {
        it = def;

      } else {
        it = menu.find(def);
      }
    }
  }

  if (it != undefined) {
    menu.selection = it;
  } else {
    // debug only...
    alert("DEBUG: " + txt + " not found in menu");
  }
};

//============================ File Save =====================================
//
// FileSave is only available in Photoshop
//
FileSaveOptions = function(obj) {
  var self = this;

  self.saveDocumentType = undefined; // SaveDocumentType
  self.fileType = "jpg";             // file extension

  self._saveOpts = undefined;

  self.saveForWeb = false; // gif, png, jpg

  self.flattenImage = false; // psd, tif

  self.bmpAlphaChannels = true;
  self.bmpDepth = BMPDepthType.TWENTYFOUR;
  self.bmpRLECompression = false;

  self.gifTransparency = true;
  self.gifInterlaced = false;
  self.gifColors = 256;

  self.jpgQuality = 10;
  self.jpgEmbedColorProfile = true;
  self.jpgFormat = FormatOptions.STANDARDBASELINE;
  self.jpgConvertToSRGB = false;          // requires code

  self.epsEncoding = SaveEncoding.BINARY;
  self.epsEmbedColorProfile = true;

  self.pdfEncoding = PDFEncoding.JPEG;
  self.pdfEmbedColorProfile = true;

  self.psdAlphaChannels = true;
  self.psdEmbedColorProfile = true;
  self.psdLayers = true;
  self.psdMaximizeCompatibility = true;           // requires code for prefs

  self.pngInterlaced = false;

  self.tgaAlphaChannels = true;
  self.tgaRLECompression = true;

  self.tiffEncoding = TIFFEncoding.NONE;
  self.tiffByteOrder = (isWindows() ? ByteOrder.IBM : ByteOrder.MACOS);
  self.tiffEmbedColorProfile = true;

  if (obj) {
    for (var idx in self) {
      if (idx in obj) {       // only copy in FSO settings
        self[idx] = obj[idx];
      }
    }
    if (!obj.fileType) {
      self.fileType = obj.fileSaveType;
      if (self.fileType == "tiff") {
        self.fileType = "tif";
      }
    }
  }
};
//FileSaveOptions.prototype.typename = "FileSaveOptions";
FileSaveOptions._enableDNG = false;

FileSaveOptions.convert = function(fsOpts) {
  var fsType = fsOpts.fileType;
  if (!fsType) {
    fsType = fsOpts.fileSaveType;
  }
  var fs = FileSaveOptionsTypes[fsType];
  if (fs == undefined) {
    return undefined;
  }
  if (!fs.optionsType) {
    return undefined;
  }
  var saveOpts = new fs.optionsType();

  switch (fsType) {
    case "bmp": {
      saveOpts.rleCompression = toBoolean(fsOpts.bmpRLECompression);

      var value = BMPDepthType.TWENTYFOUR;
      var str = fsOpts.bmpDepth.toString();
      if (str.match(/1[^6]|one/i)) {
        value = BMPDepthType.ONE;
      } else if (str.match(/24|twentyfour/i)) {
        // we have to match 24 before 4
        value = BMPDepthType.TWENTYFOUR;
      } else if (str.match(/4|four/i)) {
        value = BMPDepthType.FOUR;
      } else if (str.match(/8|eight/i)) {
        value = BMPDepthType.EIGHT;
      } else if (str.match(/16|sixteen/i)) {
        value = BMPDepthType.SIXTEEN;
      } else if (str.match(/32|thirtytwo/i)) {
        value = BMPDepthType.THIRTYTWO;
      }
      saveOpts.depth = value;
      saveOpts.alphaChannels = toBoolean(fsOpts.bmpAlphaChannels);

      saveOpts._flatten = true;
      saveOpts._8Bit = true; //XXX Should this be true?
      break;
    }
    case "gif": {
      saveOpts.transparency = toBoolean(fsOpts.gifTransparency);
      saveOpts.interlaced = toBoolean(fsOpts.gifInterlaced);
      saveOpts.colors = toNumber(fsOpts.gifColors);

      saveOpts._convertToIndexed = true;
      saveOpts._flatten = true;
      saveOpts._8Bit = true;
      saveOpts._saveForWeb = toBoolean(fsOpts.saveForWeb);
      break;
    }
    case "jpg": {
      saveOpts.quality = toNumber(fsOpts.jpgQuality);
      saveOpts.embedColorProfile = toBoolean(fsOpts.jpgEmbedColorProfile);
      var value = FormatOptions.STANDARDBASELINE;
      var str = fsOpts.jpgFormat.toString();
      if (str.match(/standard/i)) {
        value = FormatOptions.STANDARDBASELINE;
      } else if (str.match(/progressive/i)) {
        value = FormatOptions.PROGRESSIVE;
      } else if (str.match(/optimized/i)) {
        value = FormatOptions.OPTIMIZEDBASELINE;
      }
      saveOpts.formatOptions = value;

      saveOpts._convertToSRGB = toBoolean(fsOpts.jpgConvertToSRGB);
      saveOpts._flatten = true;
      saveOpts._8Bit = true;
      saveOpts._saveForWeb = toBoolean(fsOpts.saveForWeb);
      break;
    }
    case "psd": {
      saveOpts.alphaChannels = toBoolean(fsOpts.psdAlphaChannels);
      saveOpts.embedColorProfile = toBoolean(fsOpts.psdEmbedColorProfile);
      saveOpts.layers = toBoolean(fsOpts.psdLayers);
      saveOpts.maximizeCompatibility =
        toBoolean(fsOpts.psdMaximizeCompatibility);
      saveOpts.flattenImage = toBoolean(fsOpts.flattenImage);
      break;
    }
    case "eps": {
      var value = SaveEncoding.BINARY;
      var str = fsOpts.epsEncoding.toString();
      if (str.match(/ascii/i)) {
        value = SaveEncoding.ASCII;
      } else if (str.match(/binary/i)) {
        value = SaveEncoding.BINARY;
      } else if (str.match(/jpg|jpeg/i)) {
        if (str.match(/high/i)) {
          value = SaveEncoding.JPEGHIGH;
        } else if (str.match(/low/i)) {
          value = SaveEncoding.JPEGLOW;
        } else if (str.match(/max/i)) {
          value = SaveEncoding.JPEGMAXIMUM;
        } else if (str.match(/med/i)) {
          value = SaveEncoding.JPEGMEDIUM;
        }
      }
      saveOpts.encoding = value;
      saveOpts.embedColorProfile = toBoolean(fsOpts.epsEmbedColorProfile);

      saveOpts._flatten = true;
      break;
    }
    case "pdf": {
      saveOpts.embedColorProfile = toBoolean(fsOpts.pdfEmbedColorProfile);
      break;
    }
    case "png": {
      saveOpts.interlaced = toBoolean(fsOpts.pngInterlaced);

      saveOpts._flatten = true;
      saveOpts._saveForWeb = toBoolean(fsOpts.saveForWeb);
      break;
    }
    case "tga": {
      saveOpts.alphaChannels = toBoolean(fsOpts.tgaAlphaChannels);
      saveOpts.rleCompression = toBoolean(fsOpts.tgaRLECompression);

      saveOpts._flatten = true;
      break;
    }
    case "tif": {
      var value = (isWindows() ? ByteOrder.IBM : ByteOrder.MACOS);
      var str = fsOpts.tiffByteOrder.toString();
      if (str.match(/ibm|pc/i)) {
        value = ByteOrder.IBM;
      } else if (str.match(/mac/i)) {
        value = ByteOrder.MACOS;
      }
      saveOpts.byteOrder = value;

      var value = TIFFEncoding.NONE;
      var str = fsOpts.tiffEncoding.toString();
      if (str.match(/none/i)) {
        value = TIFFEncoding.NONE;
      } else if (str.match(/lzw/i)) {
        value = TIFFEncoding.TIFFLZW;
      } else if (str.match(/zip/i)) {
        value = TIFFEncoding.TIFFZIP;
      } else if (str.match(/jpg|jpeg/i)) {
        value = TIFFEncoding.JPEG;
      }
      saveOpts.imageCompression = value;

      saveOpts.embedColorProfile = toBoolean(fsOpts.tiffEmbedColorProfile);
      saveOpts.flattenImage = toBoolean(fsOpts.flattenImage);
      break;
    }
    case "dng": {
    }
    default: {
      Error.runtimeError(9001, "Internal Error: Unknown file type: " +
                         fs.fileType);
    }
  }

  return saveOpts;
};

FileSaveOptionsType = function(fileType, menu, saveType, optionsType) {
  var self = this;

  self.fileType = fileType;    // the file extension
  self.menu = menu;
  self.saveType = saveType;
  self.optionsType = optionsType;
};
FileSaveOptionsType.prototype.typename = "FileSaveOptionsType";

FileSaveOptionsTypes = [];
FileSaveOptionsTypes._add = function(fileType, menu, saveType, optionsType) {
  var fsot = new FileSaveOptionsType(fileType, menu, saveType, optionsType);
  FileSaveOptionsTypes.push(fsot);
  FileSaveOptionsTypes[fileType] = fsot;
};
FileSaveOptionsTypes._init = function() {
  if (!isPhotoshop()) {
    return;
  }
  FileSaveOptionsTypes._add("bmp", "Bitmap (BMP)", SaveDocumentType.BMP,
                            BMPSaveOptions);
  FileSaveOptionsTypes._add("gif", "GIF", SaveDocumentType.COMPUSERVEGIF,
                            GIFSaveOptions);
  FileSaveOptionsTypes._add("jpg", "JPEG", SaveDocumentType.JPEG,
                            JPEGSaveOptions);
  FileSaveOptionsTypes._add("psd", "Photoshop PSD", SaveDocumentType.PHOTOSHOP,
                            PhotoshopSaveOptions);
  FileSaveOptionsTypes._add("eps", "Photoshop EPS",
                            SaveDocumentType.PHOTOSHOPEPS, EPSSaveOptions);
  FileSaveOptionsTypes._add("pdf", "Photoshop PDF",
                            SaveDocumentType.PHOTOSHOPPDF, PDFSaveOptions);
  FileSaveOptionsTypes._add("png", "PNG", SaveDocumentType.PNG,
                            PNGSaveOptions);
  FileSaveOptionsTypes._add("tga", "Targa", SaveDocumentType.TARGA,
                            TargaSaveOptions);
  FileSaveOptionsTypes._add("tif", "TIFF", SaveDocumentType.TIFF,
                            TiffSaveOptions);

  if (FileSaveOptions._enableDNG) {
    FileSaveOptionsTypes._add("dng", "DNG", undefined, undefined);
  }
};
FileSaveOptionsTypes._init();

// XXX remove file types _before_ creating a FS panel!
FileSaveOptionsTypes.remove = function(ext) {
  var ar = FileSaveOptionsTypes;
  var fsot = ar[ext];
  if (fsot) {
    for (var i = 0; i < ar.length; i++) {
      if (ar[i] == fsot) {
        ar.splice(i, 1);
        break;
      }
    }
    delete ar[ext];
  }
};

FileSaveOptions.createFileSavePanel = function(pnl, ini) {
  var win = pnl.window;
  pnl.mgr = this;

  var menuElements = [];

  for (var i = 0; i < FileSaveOptionsTypes.length; i++) {
    menuElements.push(FileSaveOptionsTypes[i].menu);
  }

  var w = pnl.bounds[2] - pnl.bounds[0];
  var xofs = 0;
  var y = 0;

  var opts = new FileSaveOptions(ini);

  if (pnl.type == 'panel') {
    xofs += 5;
    y += 10;
  }
  pnl.text = "Save Options";

  var tOfs = 3;

  var x = xofs;
  pnl.add('statictext', [x,y+tOfs,x+55,y+22+tOfs], 'File Type:');
  x += 127;
  pnl.fileType = pnl.add('dropdownlist', [x,y,x+150,y+22], menuElements);

  var ftype = opts.fileType || opts.fileSaveType || "jpg";

  var ft = psx.getByProperty(FileSaveOptionsTypes,
                             "fileType",
                             ftype);
  pnl.fileType.selection = pnl.fileType.find(ft.menu);

  x += pnl.fileType.bounds.width + 10;
  pnl.saveForWeb = pnl.add('checkbox', [x,y,x+135,y+22], 'Save for Web');
  pnl.saveForWeb.visible = false;
  pnl.saveForWeb.value = false;

  pnl.flattenImage = pnl.add('checkbox', [x,y,x+135,y+22], 'Flatten Image');
  pnl.flattenImage.visible = false;
  pnl.flattenImage.value = false;


  y += 30;
  var yofs = y;

  x = xofs;

  //=============================== Bitmap ===============================
  if (FileSaveOptionsTypes["bmp"]) {
    pnl.bmpAlphaChannels = pnl.add('checkbox', [x,y,x+125,y+22],
                                   "Alpha Channels");

    x += 150;
    var bmpDepthMenu = ["1", "4", "8", "16", "24", "32"];
    pnl.bmpDepthLabel = pnl.add('statictext', [x,y+tOfs,x+60,y+22+tOfs],
                                'Bit Depth:');
    x += 65;
    pnl.bmpDepth = pnl.add('dropdownlist', [x,y,x+55,y+22], bmpDepthMenu);
    pnl.bmpDepth.selection = pnl.bmpDepth.find("24");

    pnl.bmpDepth.find("1")._value = BMPDepthType.ONE;
    pnl.bmpDepth.find("4")._value = BMPDepthType.FOUR;
    pnl.bmpDepth.find("8")._value = BMPDepthType.EIGHT;
    pnl.bmpDepth.find("16")._value = BMPDepthType.SIXTEEN;
    pnl.bmpDepth.find("24")._value = BMPDepthType.TWENTYFOUR;
    pnl.bmpDepth.find("32")._value = BMPDepthType.THIRTYTWO;

    x = xofs;
    y += 30;
    pnl.bmpRLECompression = pnl.add('checkbox', [x,y,x+145,y+22],
                                    "RLE Compression");

    pnl.bmp = ["bmpAlphaChannels", "bmpDepthLabel", "bmpDepth",
               "bmpRLECompression"];

    pnl.bmpAlphaChannels.value = toBoolean(opts.bmpAlphaChannels);
    var it = pnl.bmpDepth.find(opts.bmpDepth.toString());
    if (it) {
      pnl.bmpDepth.selection = it;
    }
    pnl.bmpRLECompression.value = toBoolean(opts.bmpRLECompression);

    y = yofs;
    x = xofs;
  }


  //=============================== GIF ===============================
  if (FileSaveOptionsTypes["gif"]) {
    pnl.gifTransparency = pnl.add('checkbox', [x,y,x+125,y+22],
                                  "Transparency");

    x += 125;
    pnl.gifInterlaced = pnl.add('checkbox', [x,y,x+125,y+22],
                                "Interlaced");

    x += 125;
    pnl.gifColorsLabel = pnl.add('statictext', [x,y+tOfs,x+55,y+22+tOfs],
                                  'Colors:');

    x += 60;
    pnl.gifColors = pnl.add('edittext', [x,y,x+55,y+22], "256");
    pnl.gifColors.onChanging = psx.numericKeystrokeFilter;
    pnl.gifColors.onChange = function() {
      var pnl = this.parent;
      var n = toNumber(pnl.gifColors.text || 256);
      if (n < 2)   { n = 2; }
      if (n > 256) { n = 256; }
      pnl.gifColors.text = n;
    }

    pnl.gif = ["gifTransparency", "gifInterlaced", "gifColors", "gifColorsLabel",
               "saveForWeb"];

    pnl.gifTransparency.value = toBoolean(opts.gifTransparency);
    pnl.gifInterlaced.value = toBoolean(opts.gifInterlaced);
    pnl.gifColors.text = toNumber(opts.gifColors || 256);

    pnl.saveForWeb.value = toBoolean(opts.saveForWeb);
    y = yofs;
    x = xofs;
  }


  //=============================== JPG ===============================
  if (FileSaveOptionsTypes["jpg"]) {
    pnl.jpgQualityLabel = pnl.add('statictext', [x,y+tOfs,x+55,y+22+tOfs],
                                  'Quality:');
    x += 60;
    var jpqQualityMenu = ["1","2","3","4","5","6","7","8","9","10","11","12"];
    pnl.jpgQuality = pnl.add('dropdownlist', [x,y,x+55,y+22], jpqQualityMenu);
    pnl.jpgQuality.selection = pnl.jpgQuality.find("10");

    y += 30;
    x = xofs;
    pnl.jpgEmbedColorProfile = pnl.add('checkbox', [x,y,x+155,y+22],
                                       "Embed Color Profile");

    y = yofs;
    x += 150;

    var jpgFormatMenu = ["Standard", "Progressive", "Optimized"];
    pnl.jpgFormatLabel = pnl.add('statictext', [x,y+tOfs,x+50,y+22+tOfs],
                                 'Format:');
    x += 55;
    pnl.jpgFormat = pnl.add('dropdownlist', [x,y,x+110,y+22], jpgFormatMenu);
    pnl.jpgFormat.selection = pnl.jpgFormat.find("Standard");

    pnl.jpgFormat.find("Standard")._value = FormatOptions.STANDARDBASELINE;
    pnl.jpgFormat.find("Progressive")._value = FormatOptions.PROGRESSIVE;
    pnl.jpgFormat.find("Optimized")._value = FormatOptions.OPTIMIZEDBASELINE;

    y += 30;
    x = xofs + 150;
    pnl.jpgConvertToSRGB = pnl.add('checkbox', [x,y,x+145,y+22],
                                   "Convert to sRGB");

    pnl.jpg = ["jpgQualityLabel", "jpgQuality", "jpgEmbedColorProfile",
               "jpgFormatLabel", "jpgFormat", "jpgConvertToSRGB", "saveForWeb" ];

    var it = pnl.jpgQuality.find(opts.jpgQuality.toString());
    if (it) {
      pnl.jpgQuality.selection = it;
    }
    pnl.jpgEmbedColorProfile.value = toBoolean(opts.jpgEmbedColorProfile);
    var it = pnl.jpgFormat.find(opts.jpgFormat);
    if (it) {
      pnl.jpgFormat.selection = it;
    }
    pnl.jpgConvertToSRGB.value = toBoolean(opts.jpgConvertToSRGB);

    pnl.saveForWeb.value = toBoolean(opts.saveForWeb);

    x = xofs;
    y = yofs;
  }


  //=============================== PSD ===============================
  if (FileSaveOptionsTypes["psd"]) {
    pnl.psdAlphaChannels = pnl.add('checkbox', [x,y,x+125,y+22],
                                   "Alpha Channels");

    y += 30;
    pnl.psdEmbedColorProfile = pnl.add('checkbox', [x,y,x+155,y+22],
                                       "Embed Color Profile");

    y = yofs;
    x = xofs + 150;

    pnl.psdLayers = pnl.add('checkbox', [x,y,x+125,y+22],
                          "Layers");

    y += 30;
    pnl.psdMaximizeCompatibility = pnl.add('checkbox', [x,y,x+175,y+22],
                                           "Maximize Compatibility");

    pnl.psd = ["psdAlphaChannels", "psdEmbedColorProfile",
               "psdLayers", "psdMaximizeCompatibility",
               "flattenImage"];

    pnl.psdAlphaChannels.value = toBoolean(opts.psdAlphaChannels);
    pnl.psdEmbedColorProfile.value = toBoolean(opts.psdEmbedColorProfile);
    pnl.psdLayers.value = toBoolean(opts.psdLayers);
    pnl.psdMaximizeCompatibility.value =
       toBoolean(opts.psdMaximizeCompatibility);

    pnl.flattenImage.value = toBoolean(opts.flattenImage);

    x = xofs;
    y = yofs;
  }

  //=============================== EPS ===============================
  if (FileSaveOptionsTypes["eps"]) {
    var epsEncodingMenu = ["ASCII", "Binary", "JPEG High", "JPEG Med",
                           "JPEG Low", "JPEG Max"];
    pnl.epsEncodingLabel = pnl.add('statictext', [x,y+tOfs,x+60,y+22+tOfs],
                                 'Encoding:');
    x += 65;
    pnl.epsEncoding = pnl.add('dropdownlist',
                              [x,y,x+100,y+22],
                              epsEncodingMenu);
    pnl.epsEncoding.selection = pnl.epsEncoding.find("Binary");

    pnl.epsEncoding.find("ASCII")._value = SaveEncoding.ASCII;
    pnl.epsEncoding.find("Binary")._value = SaveEncoding.BINARY;
    pnl.epsEncoding.find("JPEG High")._value = SaveEncoding.JPEGHIGH;
    pnl.epsEncoding.find("JPEG Low")._value = SaveEncoding.JPEGLOW;
    pnl.epsEncoding.find("JPEG Max")._value = SaveEncoding.JPEGMAXIMUM;
    pnl.epsEncoding.find("JPEG Med")._value = SaveEncoding.JPEGMEDIUM;

    x = xofs;
    y += 30;
    pnl.epsEmbedColorProfile = pnl.add('checkbox', [x,y,x+155,y+22],
                                       "Embed Color Profile");

    pnl.eps = ["epsEncodingLabel", "epsEncoding", "epsEmbedColorProfile"];

    var it = pnl.epsEncoding.find(opts.epsEncoding);
    if (it) {
      pnl.epsEncoding.selection = it;
    }
    pnl.epsEmbedColorProfile.value = toBoolean(opts.epsEmbedColorProfile);

    x = xofs;
    y = yofs;
  }


  //=============================== PDF ===============================
  if (FileSaveOptionsTypes["pdf"]) {
    pnl.pdf = ["pdfEmbedColorProfile"];

    x = xofs;
    y = yofs;

    x = xofs;
    y += 30;
    pnl.pdfEmbedColorProfile = pnl.add('checkbox', [x,y,x+155,y+22],
                                       "Embed Color Profile");
    pnl.pdfEmbedColorProfile.value = toBoolean(opts.pdfEmbedColorProfile);

    x = xofs;
    y = yofs;
  }


  //=============================== PNG ===============================
  if (FileSaveOptionsTypes["png"]) {
    pnl.pngInterlaced = pnl.add('checkbox', [x,y,x+125,y+22],
                                "Interlaced");

    pnl.png = ["pngInterlaced", "saveForWeb"];

    pnl.pngInterlaced.value = toBoolean(opts.pngInterlaced);

    pnl.saveForWeb.value = toBoolean(opts.saveForWeb);

    x = xofs;
    y = yofs;
  }


  //=============================== TGA ===============================
  if (FileSaveOptionsTypes["tga"]) {
    pnl.tgaAlphaChannels = pnl.add('checkbox', [x,y,x+125,y+22],
                                   "Alpha Channels");

    y += 30;

    pnl.tgaRLECompression = pnl.add('checkbox', [x,y,x+145,y+22],
                                    "RLE Compression");

    pnl.tga = ["tgaAlphaChannels", "tgaRLECompression"];

    pnl.tgaAlphaChannels.value = toBoolean(opts.tgaAlphaChannels);
    pnl.tgaRLECompression.value = toBoolean(opts.tgaRLECompression);

    x = xofs;
    y = yofs;
  }


  //=============================== TIFF ===============================
  if (FileSaveOptionsTypes["tif"]) {
    var tiffEncodingMenu = ["None", "LZW", "ZIP", "JPEG"];
    pnl.tiffEncodingLabel = pnl.add('statictext', [x,y+tOfs,x+60,y+22+tOfs],
                                    'Encoding:');
    x += 65;
    pnl.tiffEncoding = pnl.add('dropdownlist', [x,y,x+75,y+22],
                               tiffEncodingMenu);
    pnl.tiffEncoding.selection = pnl.tiffEncoding.find("None");

    pnl.tiffEncoding.find("None")._value = TIFFEncoding.NONE;
    pnl.tiffEncoding.find("LZW")._value = TIFFEncoding.TIFFLZW;
    pnl.tiffEncoding.find("ZIP")._value = TIFFEncoding.TIFFZIP;
    pnl.tiffEncoding.find("JPEG")._value = TIFFEncoding.JPEG;

    x += 90;

    var tiffByteOrderMenu = ["IBM", "MacOS"];
    pnl.tiffByteOrderLabel = pnl.add('statictext', [x,y+tOfs,x+65,y+22+tOfs],
                                     'ByteOrder:');
    x += 70;
    pnl.tiffByteOrder = pnl.add('dropdownlist', [x,y,x+85,y+22],
                                tiffByteOrderMenu);
    var bo = (isWindows() ? "IBM" : "MacOS");
    pnl.tiffByteOrder.selection = pnl.tiffByteOrder.find(bo);

    pnl.tiffByteOrder.find("IBM")._value = ByteOrder.IBM;
    pnl.tiffByteOrder.find("MacOS")._value = ByteOrder.MACOS;

    x = xofs;
    y += 30;
    pnl.tiffEmbedColorProfile = pnl.add('checkbox', [x,y,x+155,y+22],
                                        "Embed Color Profile");

    pnl.tif = ["tiffEncodingLabel", "tiffEncoding", "tiffByteOrderLabel",
               "tiffByteOrder", "tiffEmbedColorProfile", "flattenImage"];

    pnl.dng = [];

    var it = pnl.tiffEncoding.find(opts.tiffEncoding);
    if (it) {
      pnl.tiffEncoding.selection = it;
    }
    var it = pnl.tiffByteOrder.find(opts.tiffByteOrder);
    if (it) {
      pnl.tiffByteOrder.selection = it;
    }
    pnl.tiffEmbedColorProfile.value = toBoolean(opts.tiffEmbedColorProfile);

    pnl.flattenImage.value = toBoolean(opts.flattenImage);
  }
  
  pnl.fileType.onChange = function() {
    var pnl = this.parent;
    var ftsel = pnl.fileType.selection.index;
    var ft = FileSaveOptionsTypes[ftsel];

    for (var i = 0; i < FileSaveOptionsTypes.length; i++) {
      var fsType = FileSaveOptionsTypes[i];
      var parts = pnl[fsType.fileType];

      for (var j = 0; j < parts.length; j++) {
        var part = parts[j];
        pnl[part].visible = (fsType == ft);
      }
    }

    var fsType = ft.fileType;
    pnl.saveForWeb.visible = (pnl[fsType].contains("saveForWeb"));
    pnl.flattenImage.visible = (pnl[fsType].contains("flattenImage"));
    pnl._onChange();
  };

  pnl._onChange = function() {
    var self = this;
    if (self.onChange) {
      self.onChange();
    }
  };

  if (false) {
    y = yofs;
    x = 300;
    var btn = pnl.add('button', [x,y,x+50,y+22], "Test");
    btn.onClick = function() {
      try {
        var pnl = this.parent;
        var mgr = pnl.mgr;

        var opts = {};
        mgr.validateFileSavePanel(pnl, opts);
        alert(listProps(opts));
        alert(listProps(FileSaveOptions.convert(opts)));

      } catch (e) {
        var msg = psx.exceptionMessage(e);
        LogFile.write(msg);
        alert(msg);
      }
    };
  }

  pnl.fileType.onChange();

  pnl.getFileSaveType = function() {
    var pnl = this;
    var fstype = '';
    if (pnl.fileType.selection) {
      var fsSel = pnl.fileType.selection.index;
      var fs = FileSaveOptionsTypes[fsSel];
      fstype = fs.fileType;
    }
    return fstype;
  };

  pnl.updateSettings = function(ini) {
    var pnl = this;

    function _select(m, s, def) {
      var it = m.find(s.toString());
      if (!it && def != undefined) {
        it = m.items[def];
      }
      if (it) {
        m.selection = it;
      }
    }

    var opts = new FileSaveOptions(ini);
    var ftype = opts.fileType || opts.fileSaveType || "jpg";

    var ft = psx.getByProperty(FileSaveOptionsTypes,
                               "fileType",
                               ftype);
    pnl.fileType.selection = pnl.fileType.find(ft.menu);

    if (FileSaveOptionsTypes["bmp"]) {
      pnl.bmpAlphaChannels.value = toBoolean(opts.bmpAlphaChannels);
      _select(pnl.bmpDepth, opts.bmpDepth.toString(), 0);
      pnl.bmpRLECompression.value = toBoolean(opts.bmpRLECompression);
    }

    if (FileSaveOptionsTypes["gif"]) {
      pnl.gifTransparency.value = toBoolean(opts.gifTransparency);
      pnl.gifInterlaced.value = toBoolean(opts.gifInterlaced);
      pnl.gifColors.text = toNumber(opts.gifColors || 256);
      pnl.saveForWeb.value = toBoolean(opts.saveForWeb);
    }

    if (FileSaveOptionsTypes["jpg"]) {
      _select(pnl.jpgQuality, opts.jpgQuality.toString(), 0);
      pnl.jpgEmbedColorProfile.value = toBoolean(opts.jpgEmbedColorProfile);
      _select(pnl.jpgFormat, opts.jpgFormat, 0);
      pnl.jpgConvertToSRGB.value = toBoolean(opts.jpgConvertToSRGB);
      pnl.saveForWeb.value = toBoolean(opts.saveForWeb);
    }

    if (FileSaveOptionsTypes["psd"]) {
      pnl.psdAlphaChannels.value = toBoolean(opts.psdAlphaChannels);
      pnl.psdEmbedColorProfile.value = toBoolean(opts.psdEmbedColorProfile);
      pnl.psdLayers.value = toBoolean(opts.psdLayers);
      pnl.psdMaximizeCompatibility.value =
          toBoolean(opts.psdMaximizeCompatibility);
      pnl.flattenImage.value = toBoolean(opts.flattenImage);
    }
    
    if (FileSaveOptionsTypes["eps"]) {
      _select(pnl.epsEncoding, opts.epsEncoding, 0);
      pnl.epsEmbedColorProfile.value = toBoolean(opts.epsEmbedColorProfile);
    }
    
    if (FileSaveOptionsTypes["pdf"]) {
      pnl.pdfEmbedColorProfile.value = toBoolean(opts.pdfEmbedColorProfile);
    }
    
    if (FileSaveOptionsTypes["png"]) {
      pnl.pngInterlaced.value = toBoolean(opts.pngInterlaced);
      pnl.saveForWeb.value = toBoolean(opts.saveForWeb);
    }
    
    if (FileSaveOptionsTypes["tga"]) {
      pnl.tgaAlphaChannels.value = toBoolean(opts.tgaAlphaChannels);
      pnl.tgaRLECompression.value = toBoolean(opts.tgaRLECompression);
    }
    
    if (FileSaveOptionsTypes["tif"]) {
      _select(pnl.tiffEncoding, opts.tiffEncoding, 0);
      _select(pnl.tiffByteOrder, opts.tiffByteOrder, 0);
      pnl.tiffEmbedColorProfile.value = toBoolean(opts.tiffEmbedColorProfile);
      pnl.flattenImage.value = toBoolean(opts.flattenImage);
    }

    pnl.fileType.onChange();
  }

  return pnl;
};
FileSaveOptions.validateFileSavePanel = function(pnl, opts) {
  var win = pnl.window;

  // XXX This function needs to remove any prior file save
  // options and only set the ones needed for the
  // selected file type

  var fsOpts = new FileSaveOptions();
  for (var idx in fsOpts) {
    if (idx in opts) {
      delete opts[idx];
    }
  }

  var fsSel = pnl.fileType.selection.index;
  var fs = FileSaveOptionsTypes[fsSel];

  opts.fileSaveType = fs.fileType;
  opts._saveDocumentType = fs.saveType;

  if (!fs.optionsType) {
    opts._saveOpts = undefined;
    return;
  }

  var saveOpts = new fs.optionsType();

  switch (fs.fileType) {
    case "bmp": {
      saveOpts.rleCompression = pnl.bmpRLECompression.value;
      saveOpts.depth = pnl.bmpDepth.selection._value;
      saveOpts.alphaChannels = pnl.bmpAlphaChannels.value;

      opts.bmpRLECompression = pnl.bmpRLECompression.value;
      opts.bmpDepth = Number(pnl.bmpDepth.selection.text);
      opts.bmpAlphaChannels = pnl.bmpAlphaChannels.value;
      break;
    }
    case "gif": {
      saveOpts.transparency = pnl.gifTransparency.value;
      saveOpts.interlaced = pnl.gifInterlaced.value;
      var colors = toNumber(pnl.gifColors.text || 256);
      if (colors < 2)   { colors = 2; }
      if (colors > 256) { colors = 256; }
      saveOpts.colors = colors; 
      saveOpts._saveForWeb = pnl.saveForWeb.value;

      opts.gifTransparency = pnl.gifTransparency.value;
      opts.gifInterlaced = pnl.gifInterlaced.value;
      opts.gifColors = colors;
      opts.saveForWeb = pnl.saveForWeb.value;
      break;
    }
    case "jpg": {
      saveOpts.quality = Number(pnl.jpgQuality.selection.text);
      saveOpts.embedColorProfile = pnl.jpgEmbedColorProfile.value;
      saveOpts.formatOptions = pnl.jpgFormat.selection._value;
      saveOpts._convertToSRGB = pnl.jpgConvertToSRGB.value;
      saveOpts._saveForWeb = pnl.saveForWeb.value;

      opts.jpgQuality = Number(pnl.jpgQuality.selection.text);
      opts.jpgEmbedColorProfile = pnl.jpgEmbedColorProfile.value;
      opts.jpgFormat = pnl.jpgFormat.selection.text;
      opts.jpgConvertToSRGB = pnl.jpgConvertToSRGB.value;
      opts.saveForWeb = pnl.saveForWeb.value;
      break;
    }
    case "psd": {
      saveOpts.alphaChannels = pnl.psdAlphaChannels.value;
      saveOpts.embedColorProfile = pnl.psdEmbedColorProfile.value;
      saveOpts.layers = pnl.psdLayers.value;
      saveOpts.maximizeCompatibility = pnl.psdMaximizeCompatibility.value;

      opts.psdAlphaChannels = pnl.psdAlphaChannels.value;
      opts.psdEmbedColorProfile = pnl.psdEmbedColorProfile.value;
      opts.psdLayers = pnl.psdLayers.value;
      opts.psdMaximizeCompatibility = pnl.psdMaximizeCompatibility.value;
      opts.flattenImage = pnl.flattenImage.value;
      break;
    }
    case "eps": {
      saveOpts.encoding = pnl.epsEncoding.selection._value;
      saveOpts.embedColorProfile = pnl.epsEmbedColorProfile.value;

      opts.epsEncoding = pnl.epsEncoding.selection.text;
      opts.epsEmbedColorProfile = pnl.epsEmbedColorProfile.value;
      break;
    }
    case "pdf": {
      saveOpts.embedColorProfile = pnl.pdfEmbedColorProfile.value;

      opts.pdfEmbedColorProfile = pnl.pdfEmbedColorProfile.value;
      break;
    }
    case "png": {
      saveOpts.interlaced = pnl.pngInterlaced.value;
      saveOpts._saveForWeb = pnl.saveForWeb.value;

      opts.pngInterlaced = pnl.pngInterlaced.value;
      opts.saveForWeb = pnl.saveForWeb.value;
      break;
    }
    case "tga": {
      saveOpts.alphaChannels = pnl.tgaAlphaChannels.value;
      saveOpts.rleCompression = pnl.tgaRLECompression.value;

      opts.tgaAlphaChannels = pnl.tgaAlphaChannels.value;
      opts.tgaRLECompression = pnl.tgaRLECompression.value;
      break;
    }
    case "tif": {
      saveOpts.byteOrder = pnl.tiffByteOrder.selection._value;
      saveOpts.imageCompression = pnl.tiffEncoding.selection._value;
      saveOpts.embedColorProfile = pnl.tiffEmbedColorProfile.value;

      opts.tiffByteOrder = pnl.tiffByteOrder.selection.text;
      opts.tiffEncoding = pnl.tiffEncoding.selection.text;
      opts.tiffEmbedColorProfile = pnl.tiffEmbedColorProfile.value;
      opts.flattenImage = pnl.flattenImage.value;
      break;
    }
    default:
      Error.runtimeError(9001, "Internal Error: Unknown file type: " +
                         fs.fileType);
  }

  opts._saveOpts = saveOpts;

  return;
};

//============================= FileNaming ====================================
//
// FileNaming is only available in PS at present
//
FileNamingOptions = function(obj, prefix) {
  var self = this;

  self.fileNaming = [];      // array of FileNamingType and/or String
  self.startingSerial = 1;
  self.windowsCompatible = isWindows();
  self.macintoshCompatible = isMac();
  self.unixCompatible = true;

  if (obj) {
    if (prefix == undefined) {
      prefix = '';
    }
    var props = FileNamingOptions.props;
    for (var i = 0; i < props.length; i++) {
      var name = props[i];
      var oname = prefix + name;
      if (oname in obj) {
        self[name] = obj[oname];
      }
    }

    if (self.fileNaming.constructor == String) {
      self.fileNaming = self.fileNaming.split(',');

      // remove "'s from around custom text
    }
  }
};
FileNamingOptions.prototype.typename = FileNamingOptions;
FileNamingOptions.props = ["fileNaming", "startingSerial", "windowsCompatible",
                           "macintoshCompatible", "unixCompatible"];

FileNamingOptions.prototype.format = function(file, cdate) {
  var self = this;
  var str  = '';

  file = psx.convertFptr(file);

  if (!cdate) {
    cdate = file.created || new Date();
  }

  var fname = file.strf("%f");
  var ext = file.strf("%e");

  var parts = self.fileNaming;

  if (parts.constructor == String) {
    parts = parts.split(',');
  }

  var serial = self.startingSerial;
  var aCode = 'a'.charCodeAt(0);
  var ACode = 'A'.charCodeAt(0);

  for (var i = 0; i < parts.length; i++) {
    var p = parts[i];
    var fnel = FileNamingElements.getByName(p);

    if (!fnel) {
      if (p == '--') {
        p = '-';
      }
      // remove "'s from around custom text
      str += p;
      continue;
    }

    var s = '';
    switch (fnel.type) {
    case FileNamingType.DOCUMENTNAMEMIXED: s = fname; break;
    case FileNamingType.DOCUMENTNAMELOWER: s = fname.toLowerCase(); break;
    case FileNamingType.DOCUMENTNAMEUPPER: s = fname.toUpperCase(); break;
    case FileNamingType.SERIALNUMBER1:     s = "%d".sprintf(serial++); break;
    case FileNamingType.SERIALNUMBER2:     s = "%02d".sprintf(serial++); break;
    case FileNamingType.SERIALNUMBER3:     s = "%03d".sprintf(serial++); break;
    case FileNamingType.SERIALNUMBER4:     s = "%04d".sprintf(serial++); break;
    case FileNamingElement.SERIALNUMBER5:  s = "%05d".sprintf(serial++); break;
    case FileNamingType.EXTENSIONLOWER:    s = '.' + ext.toLowerCase(); break;
    case FileNamingType.EXTENSIONUPPER:    s = '.' + ext.toUpperCase(); break;
    case FileNamingType.SERIALLETTERLOWER:
      s = String.fromCharCode(aCode + (serial++)); break;
    case FileNamingType.SERIALLETTERUPPER:
      s = String.fromCharCode(ACode + (serial++)); break;
    }

    if (s) {
      str += s;
      continue;
    }

    var fmt = '';
    switch (fnel.type) {
    case FileNamingType.MMDDYY:   fmt = "%m%d%y"; break;
    case FileNamingType.MMDD:     fmt = "%m%d"; break;
    case FileNamingType.YYYYMMDD: fmt = "%Y%m%d"; break;
    case FileNamingType.YYMMDD:   fmt = "%y%m%d"; break;
    case FileNamingType.YYDDMM:   fmt = "%y%d%m"; break;
    case FileNamingType.DDMMYY:   fmt = "%d%m%y"; break;
    case FileNamingType.DDMM:     fmt = "%d%m"; break;
    }

    if (fmt) {
      str += cdate.strftime(fmt);
      continue;
    }
  }

  self._serial = serial;

  return str;
};

FileNamingOptions.prototype.copyTo = function(opts, prefix) {
  var self = this;
  var props = FileNamingOptions.props;

  for (var i = 0; i < props.length; i++) {
    var name = props[i];
    var oname = prefix + name;
    opts[oname] = self[name];
    if (name == 'fileNaming' && self[name] instanceof Array) {
      opts[oname] = self[name].join(',');
    } else {
      opts[oname] = self[name];
    }
  }
};


// this array is folder into FileNamingElement
FileNamingOptions._examples =
  [ "",
    "Document",
    "document",
    "DOCUMENT",
    "1",
    "01",
    "001",
    "0001",
    "a",
    "A",
    "103107",
    "1031",
    "20071031",
    "071031",
    "073110",
    "311007",
    "3110",
    ".psd",
    ".PSD"
    ];

FileNamingOptions.prototype.getExample = function() {
  var self = this;
  var str = '';
  return str;
};

FileNamingElement = function(name, menu, type, sm, example) {
  var self = this;
  self.name = name;
  self.menu = menu;
  self.type = type;
  self.smallMenu = sm;
  self.example = (example || '');
};
FileNamingElement.prototype.typename = FileNamingElement;

FileNamingElements = [];
FileNamingElements._add = function(name, menu, type, sm, ex) {
  FileNamingElements.push(new FileNamingElement(name, menu, type, sm, ex));
}

FileNamingElement.NONE = "(None)";

FileNamingElement.SERIALNUMBER5 = {
  toString: function() { return "FileNamingElement.SERIALNUMBER5"; }
};

FileNamingElements._init = function() {

  FileNamingElements._add("", "", "", "", "");

  try {
    FileNamingType;
  } catch (e) {
    return;
  }

  // the names here correspond to the sTID symbols used when making
  // a Batch request via the ActionManager interface. Except for "Name",
  // which should be "Nm  ".
  // the names should be the values used when serializing to and from
  // an INI file.
  // A FileNamingOptions object needs to be defined.
  FileNamingElements._add("Name", psx.DocumentName,
                          FileNamingType.DOCUMENTNAMEMIXED,
                          "Name", "Document");
  FileNamingElements._add("lowerCase", psx.LCDocumentName,
                          FileNamingType.DOCUMENTNAMELOWER,
                          "name", "document");
  FileNamingElements._add("upperCase", psx.UCDocumentName,
                          FileNamingType.DOCUMENTNAMEUPPER,
                          "NAME", "DOCUMENT");
  FileNamingElements._add("oneDigit", psx.FN1Digit,
                          FileNamingType.SERIALNUMBER1,
                          "Serial #", "1");
  FileNamingElements._add("twoDigit", psx.FN2Digit,
                          FileNamingType.SERIALNUMBER2,
                          "Serial ##", "01");
  FileNamingElements._add("threeDigit", psx.FN3Digit,
                          FileNamingType.SERIALNUMBER3,
                          "Serial ###", "001");
  FileNamingElements._add("fourDigit", psx.FN4Digit,
                          FileNamingType.SERIALNUMBER4,
                          "Serial ####", "0001");
  FileNamingElements._add("fiveDigit", psx.FN5Digit,
                          FileNamingElement.SERIALNUMBER5,
                          "Serial #####", "00001");
  FileNamingElements._add("lowerCaseSerial", psx.LCSerial,
                          FileNamingType.SERIALLETTERLOWER,
                          "Serial a", "a");
  FileNamingElements._add("upperCaseSerial", psx.UCSerial,
                          FileNamingType.SERIALLETTERUPPER,
                          "Serial A", "A");
  FileNamingElements._add("mmddyy", psx.Date_mmddyy,
                          FileNamingType.MMDDYY,
                          "mmddyy", "103107");
  FileNamingElements._add("mmdd", psx.Date_mmdd,
                          FileNamingType.MMDD,
                          "mmdd", "1031");
  FileNamingElements._add("yyyymmdd", psx.Date_yyyymmdd,
                          FileNamingType.YYYYMMDD,
                          "yyyymmdd", "20071031");
  FileNamingElements._add("yymmdd", psx.Date_yymmdd,
                          FileNamingType.YYMMDD,
                          "yymmdd", "071031");
  FileNamingElements._add("yyddmm", psx.Date_yyddmm,
                          FileNamingType.YYDDMM,
                          "yyddmm", "073110");
  FileNamingElements._add("ddmmyy", psx.Date_ddmmyy,
                          FileNamingType.DDMMYY,
                          "ddmmyy", "311007");
  FileNamingElements._add("ddmm", psx.Date_ddmm,
                          FileNamingType.DDMM,
                          "ddmm", "3110");
  FileNamingElements._add("lowerCaseExtension", psx.LCExtension,
                          FileNamingType.EXTENSIONLOWER,
                          "ext", ".psd");
  FileNamingElements._add("upperCaseExtension", psx.UCExtension,
                          FileNamingType.EXTENSIONUPPER,
                          "EXT", ".PSD");
};
FileNamingElements._init();
FileNamingElements.getByName = function(name) {
  return psx.getByName(FileNamingElements, name);
};

FileNamingOptions.createFileNamingPanel = function(pnl, ini,
                                                   prefix,
                                                   useSerial,
                                                   useCompatibility,
                                                   columns) {
  var win = pnl.window;
  if (useSerial == undefined) {
    useSerial = false;
  }
  if (useCompatibility == undefined) {
    useCompatibility = false;
  }
  if (columns == undefined) {
    columns = 3;
  } else {
    if (columns != 2 && columns != 3) {
      Error.runtimeError(9001, "Internal Error: Bad column spec for " +
                         "FileNaming panel");
    }
  }

  pnl.fnmenuElements = [];
  for (var i = 0; i < FileNamingElements.length; i++) {
    var fnel = FileNamingElements[i];
    pnl.fnmenuElements.push(fnel.menu);
  }
  var extrasMenuEls = [
    "-",
    psx.CreateCustomText,
    psx.EditCustomText,
    psx.DeleteCustomText,
    "-",
    FileNamingElement.NONE,
    ];
  for (var i = 0; i < extrasMenuEls.length; i++) {
    pnl.fnmenuElements.push(extrasMenuEls[i]);
  }

  pnl.win = win;
  if (prefix == undefined) {
    prefix = '';
  }
  pnl.prefix = prefix;

  var w = pnl.bounds[2] - pnl.bounds[0];
  var xofs = 0;
  var y = 0;

  if (pnl.type == 'panel') {
    xofs += 5;
    y += 10;
  }
  pnl.text = psx.FileNaming;

  var tOfs = 3;

  if (columns == 2) {
    var menuW = (w - 50)/2;

  } else {
    var menuW = (w - 65)/3;
  }

  var opts = new FileNamingOptions(ini, pnl.prefix);

  x = xofs;

  pnl.exampleLabel = pnl.add('statictext', [x,y+tOfs,x+70,y+22+tOfs],
                             psx.ExampleLabel);
  x += 70;
  pnl.example = pnl.add('statictext', [x,y+tOfs,x+250,y+22+tOfs], '');
  y += 30;
  x = xofs;

  pnl.menus = [];

  pnl.menus[0]  = pnl.add('dropdownlist', [x,y,x+menuW,y+22],
                          pnl.fnmenuElements);
  x += menuW + 5;
  pnl.add('statictext', [x,y+tOfs,x+10,y+22+tOfs], '+');

  x += 15;

  pnl.menus[1]  = pnl.add('dropdownlist', [x,y,x+menuW,y+22],
                          pnl.fnmenuElements);
  x += menuW + 5;
  pnl.add('statictext', [x,y+tOfs,x+10,y+22+tOfs], '+');

  if (columns == 2) {
    y += 30;
    x = xofs;
  } else {
    x += 15;
  }

  pnl.menus[2]  = pnl.add('dropdownlist', [x,y,x+menuW,y+22],
                          pnl.fnmenuElements);
  x += menuW + 5;
  pnl.add('statictext', [x,y+tOfs,x+10,y+22+tOfs], '+');

  if (columns == 3) {
    y += 30;
    x = xofs;

  } else {
    x += 15;
  }

  pnl.menus[3]  = pnl.add('dropdownlist', [x,y,x+menuW,y+22],
                          pnl.fnmenuElements);
  x += menuW + 5;
  pnl.add('statictext', [x,y+tOfs,x+10,y+22+tOfs], '+');

  if (columns == 2) {
    y += 30;
    x = xofs;

  } else {
    x += 15;
  }

  pnl.menus[4]  = pnl.add('dropdownlist', [x,y,x+menuW,y+22],
                          pnl.fnmenuElements);
  x += menuW + 5;
  pnl.add('statictext', [x,y+tOfs,x+10,y+22+tOfs], '+');

  x += 15;

  pnl.menus[5]  = pnl.add('dropdownlist', [x,y,x+menuW,y+22],
                          pnl.fnmenuElements);
  y += 30;
  x = xofs;

  pnl.addMenuElement = function(text) {
    var pnl = this;
    for (var i = 0; i < 6; i++) {
      var vmenu = pnl.menus[i];
      vmenu.add('item', text);
    }
  }

  pnl.useSerial = useSerial;
  if (useSerial) {
    pnl.startingSerialLbl = pnl.add('statictext', [x,y+tOfs,x+80,y+22+tOfs],
                                    psx.StartingSerialNumber);
    x += 90;
    pnl.startingSerial = pnl.add('edittext', [x,y,x+50,y+22],
                                 opts.startingSerial);
    y += 30;
    x = xofs;
    pnl.startingSerial.onChanging = psx.numberKeystrokeFilter;
    pnl.startingSerial.onChange = function() {
      var pnl = this.parent;
    }
  }

  pnl.useCompatibility = useCompatibility;
  if (useCompatibility) {
    pnl.add('statictext', [x,y+tOfs,x+80,y+22+tOfs], psx.CompatibilityPrompt);
    x += 90;
    pnl.compatWindows = pnl.add('checkbox', [x,y,x+70,y+22], psx.Windows);
    x += 80;
    pnl.compatMac = pnl.add('checkbox', [x,y,x+70,y+22], psx.MacOS);
    x += 80;
    pnl.compatUnix = pnl.add('checkbox', [x,y,x+70,y+22], psx.Unix);

    pnl.compatWindows.value = opts.windowsCompatible;
    pnl.compatMac.value = opts.macintoshCompatible;
    pnl.compatUnix.value = opts.unixCompatible;
  }

  function menuOnChange() {
    var pnl = this.parent;
    var win = pnl.window;
    if (pnl.processing) {
      return;
    }
    pnl.processing = true;
    try {
      var menu = this;
      if (!menu.selection) {
        return;
      }

      var currentSelection = menu.selection.index;
      var lastSelection = menu.lastMenuSelection;

      menu.lastMenuSelection = menu.selection.index;

      var lastWasCustomText = (lastSelection >= pnl.fnmenuElements.length);

      var sel = menu.selection.text;
      if (sel == FileNamingElement.NONE) {
        menu.selection = menu.items[0];
        sel = menu.selection.text;
      }

      if (sel == psx.CreateCustomText) {
        var text = FileNamingOptions.createCustomTextDialog(win,
                                                    psx.CreateCustomText,
                                                    "new");
        if (text) {
          if (text.match(/^\-+$/)) {
            text += '-';
          }
          if (!menu.find(text)) {
            pnl.addMenuElement(text);
          }

          var it = menu.find(text);
          menu.selection = it;
          menu.lastMenuSelection = it.index;

        } else {
          if (lastSelection >= 0) {
            menu.selection = menu.items[lastSelection];
            menu.lastMenuSelection = lastSelection;

          } else {
            menu.selection = menu.items[0];
          }
        }

      } else if (lastWasCustomText) {
        if (sel == psx.DeleteCustomText) {
          var lastText = menu.items[lastSelection].text;
          var text = FileNamingOptions.createCustomTextDialog(win,
                                                      "Edit Custom Text",
                                                      "edit",
                                                      lastText);
          if (text) {
            for (var i = 0; i < 6; i++) {
              var vmenu = pnl.menus[i];
              var it = vmenu.add('item', text);

              if (vmenu.selection &&
                  vmenu.selection.index == lastSelection) {

                // if a menu already has the previous version of this edited
                // entry, we have to remove the old one before setting the
                // new one or else the menu selection gets lost
                vmenu.remove(lastSelection);
                vmenu.selection = it;

              } else {
                var it = vmenu.selection;
                vmenu.remove(lastSelection);
                vmenu.selection = it;
              }
            }

            var it = menu.find(text);
            menu.selection = it;
            pnl.lastMenuSelection = it.index;

          } else {
            if (lastSelection >= 0) {
              menu.selection = menu.items[lastSelection];
              menu.lastMenuSelection = lastSelection;

            } else {
              menu.selection = menu.items[0];
            }
          }

        } else if (sel == psx.DeleteCustomText) {
          var lastText = menu.items[lastSelection].text;
          if (confirm(psx.DeleteCustomTextPrompt.sprintf(lastText))) {
            for (var i = 0; i < 6; i++) {
              var vmenu = pnl.menus[i];
              vmenu.remove(lastSelection);
            }
            menu.selection = menu.items[0];

          } else {
            menu.selection = menu.items[lastSelection];
            menu.lastMenuSelection = lastSelection;
          }

        } else {
          //alert("Internal error, Custom Text request");
        }

      } else {
        if (lastSelection >= 0 && (sel == psx.EditCustomText ||
                                   sel == psx.DeleteCustomText)) {
          menu.selection = menu.items[lastSelection];
          menu.lastMenuSelection = lastSelection;
        }
      }

      var example = '';
      var format = [];

      for (var i = 0; i < 6; i++) {
        var vmenu = pnl.menus[i];
        if (vmenu.selection) {
          var fmt = '';
          var text = vmenu.selection.text;
          var fne = psx.getByProperty(FileNamingElements, "menu", text);
          if (fne) {
            text = fne.example;
            fmt = fne.name;
          } else {
            fmt = text;
          }

          if (text) {
            if (text.match(/^\-+$/)) {
              text = text.substr(1);
            }
            example += text;
          }

          if (fmt) {
            if (fmt.match(/^\-+$/)) {
              fmt = fmt.substr(1);
            }
            format.push(fmt);
          }
        }
      }
      if (pnl.example) {
        pnl.example.text = example;
      }
      format = format.join(",");
      var win = pnl.window;
      if (win.mgr.updateNamingFormat) {
        win.mgr.updateNamingFormat(format, example);
      }

    } finally {
      pnl.processing = false;
    }

    if (pnl.onChange) {
      pnl.onChange();
    }
  }

  // default all slots to ''
  for (var i = 0; i < 6; i++) {
    var menu = pnl.menus[i];
    menu.selection = menu.items[0];
    menu.lastMenuSelection = 0;
  }

  for (var i = 0; i < 6; i++) {
    var name = opts.fileNaming[i];
    if (name) {
      var fne = FileNamingElements.getByName(name);
      var it;

      if (!fne) {
        if (name.match(/^\-+$/)) {
          name += '-';
        }
        it = pnl.menus[i].find(name);
        if (!it) {
          pnl.addMenuElement(name);
          it = pnl.menus[i].find(name);
        }
      } else {
        it = pnl.menus[i].find(fne.menu);
      }
      pnl.menus[i].selection = it;
    }
  }

//   pnl.menus[0].selection = pnl.menus[0].find("document name");
//   pnl.menus[0].lastMenuSelection = pnl.menus[0].selection.index;
//   pnl.menus[1].selection = pnl.menus[1].find("extension");
//   pnl.menus[1].lastMenuSelection = pnl.menus[1].selection.index;

  for (var i = 0; i < 6; i++) {
    var menu = pnl.menus[i];
    menu.onChange = menuOnChange;
  }

  pnl.getFileNamingOptions = function(ini) {
    var pnl = this;
    var fileNaming = [];

    for (var i = 0; i < 6; i++) {
      var menu = pnl.menus[i];

      if (menu.selection) {
        var idx = menu.selection.index;

        if (idx) {
          // [0] is the "" item so we ignore it
          var fnel = FileNamingElements[idx];
          if (fnel) {
            fileNaming.push(fnel.name);

          } else {
            // its a custom naming option
            var txt = menu.selection.text;
            if (txt.match(/^\-+$/)) {
              txt = txt.substr(1);
            }

            // txt = '"' + text + '"';
            fileNaming.push(txt);
          }
        }
      }
    }

    var prefix = pnl.prefix;
    var opts = new FileNamingOptions(ini, prefix);
    opts.fileNaming = fileNaming;

    if (pnl.startingSerial) {
      opts.startingSerial = Number(pnl.startingSerial.text);
    }
    if (pnl.compatWindows) {
      opts.windowsCompatible = pnl.compatWindows.value;
    }
    if (pnl.compatMac) {
      opts.macintoshCompatible = pnl.compatMac.value;
    }
    if (pnl.compatUnix) {
      opts.unixCompatible = pnl.compatUnix.value;
    }
    return opts;
  }
  pnl.getFilenamingOptions = pnl.getFileNamingOptions;

  pnl.updateSettings = function(ini) {
    var pnl = this;

    var opts = new FileNamingOptions(ini, pnl.prefix);

    if (pnl.useSerial) {
      pnl.startingSerial.text = opts.startingSerial;
    }

    if (pnl.useCompatibility) {
      pnl.compatWindows.value = opts.windowsCompatible;
      pnl.compatMac.value = opts.macintoshCompatible;
      pnl.compatUnix.value = opts.unixCompatible;
    }

    // default all slots to ''
    for (var i = 0; i < 6; i++) {
      var menu = pnl.menus[i];
      menu.selection = menu.items[0];
      menu.lastMenuSelection = 0;
    }

    for (var i = 0; i < 6; i++) {
      var name = opts.fileNaming[i];
      if (name) {
        var fne = FileNamingElements.getByName(name);
        var it;

        if (!fne) {
          if (name.match(/^\-+$/)) {
            name += '-';
          }
          it = pnl.menus[i].find(name);
          if (!it) {
            pnl.addMenuElement(name);
            it = pnl.menus[i].find(name);
          }
        } else {
          it = pnl.menus[i].find(fne.menu);
        }
        pnl.menus[i].selection = it;
      }
    }

    for (var i = 0; i < 6; i++) {
      var menu = pnl.menus[i];
      menu.onChange = menuOnChange;
    }

    pnl.menus[0].onChange();

    if (pnl.onChange) {
      pnl.onChange();
    }
  }

  pnl.menus[0].onChange();

  if (pnl.onChange) {
    pnl.onChange();
  }

  return pnl;
};
FileNamingOptions.createCustomTextDialog = function(win, title, mode, init) {
  var rect = {
    x: 200,
    y: 200,
    w: 350,
    h: 150
  };

  function rectToBounds(r) {
    return[r.x, r.y, r.x+r.w, r.y+r.h];
  };

  var cwin = new Window('dialog', title || psx.CustomTextEditor,
                        rectToBounds(rect));

  cwin.text = title || psx.CustomTextEditor;
  if (win) {
    cwin.center(win);
  }

  var xofs = 10;
  var y = 10;
  var x = xofs;

  var tOfs = 3;

  cwin.add('statictext', [x,y+tOfs,x+300,y+22+tOfs], psx.CustomTextPrompt);

  y += 30;
  cwin.customText = cwin.add('edittext', [x,y,x+330,y+22]);

  cwin.customText.onChanging = function() {
    cwin = this.parent;
    var text = cwin.customText.text;

    if (cwin.initText) {
      cwin.saveBtn.enabled = (text.length > 0) && (text != cwin.initText);
    } else {
      cwin.saveBtn.enabled = (text.length > 0);
    }
  }

  if (init) {
    cwin.customText.text = init;
    cwin.initText = init;
  }

  y += 50;
  x += 100;
  cwin.saveBtn = cwin.add('button', [x,y,x+70,y+22], psx.Save);
  cwin.saveBtn.enabled = false;

  x += 100;
  cwin.cancelBtn = cwin.add('button', [x,y,x+70,y+22], psx.Cancel);

  cwin.defaultElement = cwin.saveBtn;

  var res = cwin.show();
  return (res == 1) ? cwin.customText.text : undefined;
};

FileNamingOptions.validateFileNamingPanel = function(pnl, opts) {
  var self = this;
  var win = pnl.window;
  var fopts = pnl.getFileNamingOptions(opts);

  if (fopts.fileNaming.length == 0) {
    return self.errorPrompt("You must specify a name for the files.");
  }

  fopts.copyTo(opts, pnl.prefix);

  return opts;
};


//======================== Font Panel =================================
psxui.createFontPanel = function(pnl, ini, label, lwidth) {
  var win = pnl.window;

  pnl.win = win;

  var w = pnl.bounds[2] - pnl.bounds[0];
  var xofs = 0;
  var y = 0;

  if (pnl.type == 'panel') {
    xofs += 5;
    y += 5;
  }

  var tOfs = 3;

  var x = xofs;
  if (label == undefined) {
    label = psx.FontLabel;
    lwidth = 40;
  }

  if (label != '') {
    pnl.label = pnl.add('statictext', [x,y+tOfs,x+lwidth,y+22+tOfs], label);
    x += lwidth;
  }
  pnl.family = pnl.add('dropdownlist', [x,y,x+180,y+22]);
  x += 185;
  pnl.style  = pnl.add('dropdownlist', [x,y,x+110,y+22]);
  x += 115;
  pnl.fontSize  = pnl.add('edittext', [x,y,x+30,y+22], "12");
  x += 32;
  pnl.sizeLabel = pnl.add('statictext', [x,y+tOfs,x+15,y+22+tOfs],
                          psx.UnitsPT);

  pnl.fontTable = psxui._getFontTable();
  var names = [];
  for (var idx in pnl.fontTable) {
    names.push(idx);
  }
  names.sort();
  for (var i = 0; i < names.length; i++) {
    pnl.family.add('item', names[i]);
  }
  pnl.family.onChange = function() {
    var pnl = this.parent;
    var sel = pnl.family.selection.text;
    var family = pnl.fontTable[sel];

    pnl.style.removeAll();

    var styles = family.styles;

    for (var i = 0; i < styles.length; i++) {
      var it = pnl.style.add('item', styles[i].style);
      it.font = styles[i].font;
    }
    if (pnl._defaultStyle) {
      var it = pnl.style.find(pnl._defaultStyle);
      pnl._defaultStyle = undefined;
      if (it) {
        it.selected = true;
      } else {
        pnl.style.items[0].selected = true;
      }
    } else {
      pnl.style.items[0].selected = true;
    }
  };
  pnl.family.items[0].selected = true;

  pnl.fontSize.onChanging = psxui.numberKeystrokeFilter;

  pnl.setFont = function(str, size) {
    var pnl = this;
    if (!str) {
      return;
    }
    var font = (str.typename == "TextFont") ? str : psx.determineFont(str);
    if (font) {
      var it = pnl.family.find(font.family);
      if (it) {
        it.selected = true;
        pnl._defaultStyle = font.style;
      }
    }
    pnl.fontSize.text = size;
    pnl.family.onChange();
  };
  pnl.getFont = function() {
    var pnl = this;
    var font = pnl.style.selection.font;
    return { font: font.postScriptName, size: Number(pnl.fontSize.text) };

    var fsel = pnl.family.selection.text;
    var ssel = pnl.style.selection.text;
    var family = pnl.fontTable[sel];
    var styles = familyStyles;
    var font = undefined;

    for (var i = 0; i < styles.length && font == undefined; i++) {
      if (styles[i].style == ssel) {
        font = styles[i].font;
      }
    }
    return { font: font, size: Number(font.fontSize) };
  }

  return pnl;
};
psxui._getFontTable = function() {
  var fonts = app.fonts;
  var fontTable = {};
  for (var i = 0; i < fonts.length; i++) {
    var font = fonts[i];
    var entry = fontTable[font.family];
    if (!entry) {
      entry = { family: font.family, styles: [] };
      fontTable[font.family] = entry;
    }
    entry.styles.push({ style: font.style, font: font });
  }
  return fontTable;
};

psxui._getFontArray = function() {
  var fontTable = psxui._getFontTable();
  var fonts = [];
  for (var idx in fontTable) {
    var f = fontTable[idx];
    fonts.push(f);
  }
  return fonts;
};

//
// createProgressPalette
//   title     the window title
//   min       the minimum value for the progress bar
//   max       the maximum value for the progress bar
//   parent    the parent ScriptUI window (opt)
//   useCancel flag for having a Cancel button (opt)
//   msg       a message that can be displayed (and changed) in the palette (opt)
//
//   onCancel  This method will be called when the Cancel button is pressed.
//             This method should return 'true' to close the progress window
//
psxui.createProgressPalette = function(title, min, max,
                                       parent, useCancel, msg) {
  var opts = {
    closeButton: false,
    maximizeButton: false,
    minimizeButton: false
  };
  var win = new Window('palette', title, undefined, opts);
  win.bar = win.add('progressbar', undefined, min, max);
  if (msg) {
    win.msg = win.add('statictext');
    win.msg.text = msg;
  }
  win.bar.preferredSize = [500, 20];

  win.parentWin = undefined;
  win.recenter = false;
  win.isDone = false;

  if (parent) {
    if (parent instanceof Window) {
      win.parentWin = parent;
    } else if (useCancel == undefined) {
      useCancel = !!parent;
    }
  }

  if (useCancel) {
    win.onCancel = function() {
      this.isDone = true;
      return true;  // return 'true' to close the window
    };

    win.cancel = win.add('button', undefined, psx.Cancel);

    win.cancel.onClick = function() {
      var win = this.parent;
      try {
        win.isDone = true;
        if (win.onCancel) {
          var rc = win.onCancel();
          if (rc != false) {
            if (!win.onClose || win.onClose()) {
              win.close();
            }
          }
        } else {
          if (!win.onClose || win.onClose()) {
            win.close();
          }
        }
      } catch (e) {
        LogFile.logException(e, '', true);
      }
    };
  }

  win.onClose = function() {
    this.isDone = true;
    return true;
  };

  win.updateProgress = function(val) {
    var win = this;

    if (val != undefined) {
      win.bar.value = val;
    }
//     else {
//       win.bar.value++;
//     }

    if (win.recenter) {
      win.center(win.parentWin);
    }

    win.update();
    win.show();
    // win.hide();
    // win.show();
  };

  win.recenter = true;
  win.center(win.parent);

  return win;
};


"psx.jsx";
// EOF
//

//app.bringToFront();
$.localize = true;

//
// Strings will be where we keep strings that need to be localized.
// This will be fully implemented at a later date.
//
Strings = {};

Strings.ImageProcessorProTitle = 
  localize("$$$/JavaScripts/ImageProcessor/ImageProcessorProTitle=Image Processor Pro");

Strings.AfterImageResize =
  localize("$$$/JavaScripts/ImageProcessor/AfterImageResize=After Image Resize");

Strings.BeforeImageResize =
  localize("$$$/JavaScripts/ImageProcessor/BeforeImageResize=Before Image Resize");

Strings.SpecifySource =
  localize("$$$/JavaScripts/ImageProcessor/SpecifySource=Please specify a source folder.");

Strings.SpecifyDest =
  localize("$$$/JavaScripts/ImageProcessor/SpecifyDest=Please specify a destination folder.");

Strings.UseOpenImages =
  localize("$$$/JavaScripts/ImageProcessor/UseOpenImages=Use Open &Images");

Strings.UseOpenImagesTip =
  localize("$$$/JavaScripts/ImageProcessor/UseOpenImagesTip=Use all open images");

Strings.IncludeSubFolders =
  localize("$$$/JavaScripts/ImageProcessor/IncludSubFolders=Include All sub-folders");

Strings.ProcessAllFoldersTip =
  localize("$$$/JavaScripts/ImageProcessor/ProcessAllFoldersTip=Process all the folders within the source folder");

Strings.ProcessFilesFromBridgeFmt =
  localize("$$$/JavaScripts/ImageProcessor/ProcessFilesFromBridgeFmt=Process files from Bridge only (%d)");

Strings.SelectedFilesFromBridge =
  localize("$$$/JavaScripts/ImageProcessor/SelectedFilesFromBridge=Selected files from Bridge will be processed");

Strings.SelectImages =
  localize("$$$/JavaScripts/ImageProcessor/SelectImages=Select the images to process");

Strings.NoImagesSelected =
  localize("$$$/JavaScripts/ImageProcessor/NoImagesSelected=No images have been selected");

Strings.NoFilesProcessed =
  localize("$$$/JavaScripts/ImageProcessor/NoFilesProcessed=No files were processed. Possible empty folder?");

Strings.NoSaveSelected =
  localize("$$$/JavaScripts/ImageProcessor/NoSaveSelected=Please select one of the SAVE check boxes to process the targeted images in a set. None of the SAVE check boxes is selected at this time");

Strings.CouldNotProcess =
  localize("$$$/JavaScripts/ImageProcessor/CouldNotProcessSkipped=Sorry, the following files could not be processed and were skipped:\r");

Strings.SelectSaveLocation =
  localize("$$$/JavaScripts/ImageProcessor/SelectSaveLocation=Select location to save processed images");

Strings.NoFolderSelected =
  localize("$$$/JavaScripts/ImageProcessor/NoFolderSelected=No folder has been selected");

Strings.SaveInSubFolder =
  localize("$$$/JavaScripts/ImageProcessor/SaveInSubFolder=Save in sub-folder");

Strings.KeepFolderStructure =
  localize("$$$/JavaScripts/ImageProcessor/KeepFolderStructure=Keep Folder Structure");

Strings.SelectFolder =
  localize("$$$/JavaScripts/ImageProcessor/SelectFolder=Select Folder...");

Strings.LocationOfFilesToProcessTip =
  localize("$$$/JavaScripts/ImageProcessor/LocationOfFilesToProcessTip=Location of files process");

Strings.SaveInSameLocation =
  localize("$$$/JavaScripts/ImageProcessor/SaveInSameLocation=S&ave in same location");

Strings.FollowingNotSaved =
  localize("$$$/JavaScripts/ImageProcessor/FollowingNotSaved=The following files will not be saved.");

Strings.FileTypes =
  localize("$$$/JavaScripts/ImageProcessor/FileTypes=File Types");

Strings.Preferences =
  localize("$$$/JavaScripts/ImageProcessor/Preferences=Preferences");

Strings.MustSaveOpen =
  localize("$$$/JavaScripts/ImageProcessor/MustSaveOpen=Open files must be saved before they can be used by the Image Processor.");

Strings.Sorry =
  localize("$$$/JavaScripts/ImageProcessor/Sorry=Sorry, something major happened and I can't continue! Would you like to see more info?");

Strings.MoreInfo =
  localize("$$$/JavaScripts/ImageProcessor/MoreInfo=For more information, refer to the log file.");

Strings.WidthAndHeightErr =
  localize("$$$/JavaScripts/ImageProcessor/WidthAndHeightErr=Width and Height must be defined to use FitImage function!");

Strings.RunBtn =
  localize("$$$/JavaScripts/ImageProcessor/RunBtn=Run");

Strings.CancelBtn =
  localize("$$$/JavaScripts/ImageProcessor/CancelBtn=Cancel");

Strings.LoadBtn =
  localize("$$$/JavaScripts/ImageProcessor/LoadBtn=Load...");

Strings.SaveBtn =
  localize("$$$/JavaScripts/ImageProcessor/SaveBtn=Save...");

Strings.ResetBtn =
  localize("$$$/JavaScripts/ImageProcessor/ResetBtn=Reset...");

Strings.Save =
  localize("$$$/JavaScripts/ImageProcessor/Save=Save");

Strings.SubFolderNameLbl =
  localize("$$$/JavaScripts/ImageProcessor/SubFolderNameLbl=Sub-folder name: ");

Strings.OutputProfileLbl =
  localize("$$$/JavaScripts/ImageProcessor/OutputProfileLbl=Output Profile: ");

Strings.BitDepthLbl =
  localize("$$$/JavaScripts/ImageProcessor/BitDepthLbl=Bit Depth: ");

Strings.RunAction =
  localize("$$$/JavaScripts/ImageProcessor/RunAction=Run Action");

Strings.ActionLbl =
  localize("$$$/JavaScripts/ImageProcessor/ActionLbl=Action: ");

Strings.ResizeToFit =
  localize("$$$/JavaScripts/ImageProcessor/ResizeToFit=Resize to Fit");

Strings.WidthLbl =
  localize("$$$/JavaScripts/ImageProcessor/WidthLbl=Width:");

Strings.HeightLbl =
  localize("$$$/JavaScripts/ImageProcessor/HeightLbl=Height:");

Strings.ResolutionLbl =
  localize("$$$/JavaScripts/ImageProcessor/ResolutionLbl=Resolution:");

Strings.ScaleStyles =
  localize("$$$/JavaScripts/ImageProcessor/ScaleStyles=Scale Styles");

Strings.WidthValueErr =
  localize("$$$/JavaScripts/ImageProcessor/WidthValueErr=Bad value for resize width");

Strings.HeightValueErr =
  localize("$$$/JavaScripts/ImageProcessor/HeightValueErr=Bad value for resize height");

Strings.WidthAndOrHeightErr =
  localize("$$$/JavaScripts/ImageProcessor/WidthAndOrHeight=Width and/or Height must be specified");

Strings.WidthAndHeightErr =
  localize("$$$/JavaScripts/ImageProcessor/WidthAndHeightErr=Width and Height must be specified");

Strings.WidthOrHeightErr =
  localize("$$$/JavaScripts/ImageProcessor/WidthOrHeightErr=Width or Height must be specified");

Strings.ResolutionErr =
  localize("$$$/JavaScripts/ImageProcessor/ResolutionErr=Bad value for resolution");

Strings.CopyrightInfoLbl =
  localize("$$$/JavaScripts/ImageProcessor/CopyrightInfoLbl=Copyright Info: ");

Strings.PickXMLFileLoad =
  localize("$$$/JavaScripts/ImageProcessor/PickXMLFileLoad=Pick an XML file to load");

Strings.PickXMLFileSave =
  localize("$$$/JavaScripts/ImageProcessor/PickXMLFileSave=Pick an XML file to save");

Strings.XMLFileDlgPattern =
  localize("$$$/JavaScripts/ImageProcessor/XMLFileDlgPattern=XML File: *.xml");

Strings.SettingsFileErr =
  localize("$$$/JavaScripts/ImageProcessor/SettingsFileErr=Error reading Image Processor settings");

Strings.NoSourceFolder =
  localize("$$$/JavaScripts/ImageProcessor/NoSourceFolder=Source folder does not exist");

Strings.SaveForWebNotice = 
  localize("$$$/JavaScripts/ImageProcessor/SaveForWebNotice=Save for Web will reduce your file size by removing the preview and some metadata from your images. This option will automatically set the resolution to the default value of 72 pixels/inch.");

Strings.RemovePreviewAndMetadata = 
  localize("$$$/JavaScripts/ImageProcessor/RemovePreviewAndMetadata=Remove preview and metadata for reduced file size");

Strings.UnableToOpenErr =
  localize("$$$/JavaScripts/ImageProcessor/UnableToOpenErr=Unable to open image file.");

Strings.ConfirmReset =
  localize("$$$/JavaScripts/ImageProcessor/ConfirmReset=Restore default settings?");

Strings.DefaultSettingsMissingErr =
  localize("$$$/JavaScripts/ImageProcessor/DefaultSettingsMissingErr=The default settings file is missing");

Strings.PSVersionError =
  localize("$$$/JavaScripts/ImageProcessor/PSVersionError=Image Processor Pro does not work with this version of Photoshop");

//------------------------ ImageProcessorNG --------------------------

function ImageProcessorOptions() {
};
ImageProcessorOptions.prototype.typename = "ImageProcessorOptions";

ImageProcessorOptions.getUserOptionsFile = function() {
  return File(Folder.userData + '/' + ImageProcessor.TITLE_UI + ".xml");
};

ImageProcessorOptions.getDefaultOptionsFile = function() {
  var f = File($.fileName);

  if (f.exists) {
    f = File(f.parent + '/' + ImageProcessor.TITLE_UI + ".xml");
  } 

  if (!f.exists) {
    var strPresets = localize ("$$$/ApplicationPresetsFolder/Presets=Presets");
    var strScripts = localize ("$$$/PSBI/Automate/ImageProcessor/Photoshop/Scripts=Scripts");
    var strProcessXML = ImageProcessor.TITLE_UI + ".xml";
    f = new File (app.path + "/" + strPresets + "/" + strScripts +
                  "/" + strProcessXML);
  }

  return f;
};

ImageProcessorOptions.DEFAULT_XML = new XML("<ImageProcessorProSettings/>");

ImageProcessorOptions.loadOptions = function(file, opts) {
  if (opts == undefined) {
    opts = ImageProcessorOptions.DEFAULT_XML.copy();
  }

  var xml = psx.readXMLFile(file);
  // reconcile defaults here

  return xml;
};

function ImageProcessor() {
  var self = this;

  self.actionSetNames = [];
  ImageProcessor.actionSets = psx.getActionSets();
  for (var i = 0; i < ImageProcessor.actionSets.length; i++) {
    self.actionSetNames[i] = ImageProcessor.actionSets[i].name;
  }

  self.init();
};

ImageProcessor.prototype.typename = "ImageProcessor";
ImageProcessor.VERSION = "2.1.8";

ImageProcessor.REQUIRED_PS_VERSION = 12;

ImageProcessor.SCRIPT_PATH = File($.fileName);
ImageProcessor.ICON_FOLDER = Folder(psx.SCRIPTS_FOLDER + '/icons');
// ImageProcessor.ICON_FOLDER = Folder(ImageProcessor.SCRIPT_PATH.parent + '/icons');
ImageProcessor.TITLE_UI = Strings.ImageProcessorProTitle;
ImageProcessor.VTITLE_UI = (ImageProcessor.TITLE_UI + ' ' +
                            ImageProcessor.VERSION)
ImageProcessor.TITLE = ImageProcessor.TITLE_UI.replace(/\s/g, '');

ImageProcessor.BAD_CHARS = /[\/\\:\*\?"<>\|]/;
ImageProcessor.BAD_CHARS_REX = /[\/\\:\*\?"<>\|]/g;

// localize???
ImageProcessor.UNTAGGED_RGB = 'Untagged RGB';
ImageProcessor.SAME_AS_SOURCE = 'Same as Source';
ImageProcessor.PROFILES = 
  [ImageProcessor.UNTAGGED_RGB, ImageProcessor.SAME_AS_SOURCE, 'Working RGB',
    'Working CMYK', 'sRGB IEC61966-2.1', 'Adobe RGB (1998)',
    'ProPhoto RGB', 'ColorMatch RGB' ];

ImageProcessor.AFTER_IMAGE_RESIZE = Strings.AfterImageResize;
ImageProcessor.BEFORE_IMAGE_RESIZE = Strings.BeforeImageResize;

ImageProcessor.ACTION_MENU =
  [ ImageProcessor.AFTER_IMAGE_RESIZE, ImageProcessor.BEFORE_IMAGE_RESIZE ];

ImageProcessor.FILES_TO_SKIP =
  [ "db", "xmp", "thm", "txt", "doc", "md0", "tb0",
    "adobebridgedb", "adobebridgedbt", "bc", "bct", "atn" ];

ImageProcessor.CAMERA_RAW_FILES = 
  [ "tif", "crw", "nef", "raf", "orf", "mrw", "dcr", "mos",
    "srf", "pef", "dcr", "cr2", "dng", "erf", "x3f", "raw" ];

// UI text edit limit
ImageProcessor.SHORT_FNAME_LEN_WIN = 360;
ImageProcessor.SHORT_FNAME_LEN_MAC = ImageProcessor.SHORT_FNAME_LEN_WIN - 4;
ImageProcessor.SHORT_FNAME_LEN = ImageProcessor.SHORT_FNAME_LEN_MAC;
ImageProcessor.LOG_FILE = Folder.userData + '/' + ImageProcessor.TITLE_UI + ".log";

ImageProcessor.kFilesList = sTID('filesList');


ImageProcessor.globalInit = function() {
  // Try to locate the default settings xml file
  var file = ImageProcessorOptions.getDefaultOptionsFile();
  var rc = false;

//   if (file.exists) {
//     try {
//       ImageProcessorOptions.DEFAULT_XML = psx.readXMLFile(file);
//       rc = true;
//     } catch (e) {
//       var msg = psx.exceptionMessage(e);
//       alert(msg);
//     }
//   } else {
// //     alert("Houston, we have a problem: Missing default XML file");
//   }

  if (!rc) {
    ImageProcessorOptions.defaultXML = ImageProcessorOptions.DEFAULT_XML.copy();
  }

  LogFile.setFilename(ImageProcessor.LOG_FILE);
  LogFile.write("Start TutorialBuilder.jsx");
  LogFile.write("Revision: $Revision: 1.50 $");
  LogFile.write("App: " + app.name);
  LogFile.write("App Version: " + app.version);
  LogFile.write("OS: " + $.os);
  LogFile.write("Version: " + ImageProcessor.VERSION);

  // remember the dialog modes
  ImageProcessor.dialogMode = app.displayDialogs;
  app.displayDialogs = DialogModes.NO;

  // remember the units
  ImageProcessor.rulerUnits = app.preferences.rulerUnits;
  app.preferences.rulerUnits = Units.PIXELS;
  
  // remember the number of history states
  ImageProcessor.numberOfHistoryStates = app.preferences.numberOfHistoryStates;
  app.preferences.numberOfHistoryStates = 40;

  return rc;
};

ImageProcessor.globalCleanup = function() {
  app.preferences.rulerUnits = ImageProcessor.rulerUnits;
  app.preferences.numberOfHistoryStates = ImageProcessor.numberOfHistoryStates;
  app.displayDialogs = ImageProcessor.dialogMode;
};


ImageProcessor.getIconPath = function(fname) {
  return File(ImageProcessor.ICON_FOLDER + '/' + fname);
};


ImageProcessor.setIcon = function(ctrl, fname) {
  var file = ImageProcessor.getIconPath(fname);
  if (file.exists) {
    ctrl.icon = file;
  }
};

ImageProcessor.prototype.errorPrompt = function(str) {
  return confirm(str + "\r\rDo you wish to continue?");
};

ImageProcessor.getBridgeFiles = function() {
  var fileList;
  if ( BridgeTalk.isRunning( "bridge" ) ) {
    var bt = new BridgeTalk();
    bt.target = "bridge";
    bt.body = "var theFiles = photoshop.getBridgeFileListForAutomateCommand();theFiles.toSource();";
    bt.onResult = function( inBT ) { fileList = eval( inBT.body ); }
    bt.onError = function( inBT ) { fileList = new Array(); }
    bt.send();
    bt.pump();
    $.sleep( 100 );
    var timeOutAt = ( new Date() ).getTime() + 5000;
    var currentTime = ( new Date() ).getTime();
    while ( ( currentTime < timeOutAt ) && ( undefined == fileList ) ) {
      bt.pump();
      $.sleep( 100 );
      currentTime = ( new Date() ).getTime();
    }
  }
  if ( undefined == fileList ) {
    fileList = new Array();
  }
  return fileList; 
};

ImageProcessor.prototype.init = function() {
  var self = this;

  if (typeof(gFilesFromBridge) == "undefined") {
    self.runningFromBridge = false;
    self.filesFromBridge = undefined;

  } else {
    self.filesFromBridge = gFilesFromBridge;
    if (self.filesFromBridge.length > 0) {
      self.runningFromBridge = true;
    } else {
      self.runningFromBridge = false;
    }
  }

  self.bridgeIsRunning = BridgeTalk.isRunning("bridge");
  self.fnOpts = [];
};

ImageProcessor.prototype.createInputPanel = function(pnl) {
  var self = this;

  var lineH = UIC.lineH;

  pnl.img = pnl.add('image', [0, 0, 30, 30], undefined, { name : 'img'} );
  ImageProcessor.setIcon(pnl.img, "one.png");
  pnl.img.helpTip = Strings.SelectImages;

  var len = (self.filesFromBridge ? self.filesFromBridge.length : 0);
  var str = Strings.ProcessFilesFromBridgeFmt.sprintf(len);

  pnl.bridgeLbl = pnl.add('statictext', [30, 8, 300, lineH],
                          str, { name: "bridgeLbl"} );
  pnl.bridgeLbl.helpTip = Strings.SelectedFilesFromBridge;

  pnl.lbl = pnl.add('statictext', [30, 8, 300, lineH], Strings.SelectImages);
  pnl.lbl.helpTip = Strings.SelectImages;

  pnl.folder = pnl.add('image', [0, 0, 100, 120], 'SourceFolderIcon');

  var xx = UIC.col1X;
  var yy = lineH;

  pnl.useOpenImages = pnl.add('radiobutton',
                              [xx, yy, xx+UIC.col1W, yy+lineH],
                              Strings.UseOpenImages, {name: "useOpenImages"});

  pnl.useOpenImages.helpTip = Strings.UseOpenImagesTip;

  yy += lineH;

  pnl.useFolder = pnl.add('radiobutton',
                          [xx, yy, xx+lineH-7, yy+lineH],
                          undefined, {name: "useFolder"});
  yy -= lineH;
  xx += UIC.col1W + UIC.gPad;

  pnl.includeSubFolders = pnl.add('checkbox',
                                  [xx, yy, xx+300, yy+lineH],
                                  Strings.IncludeSubFolders,
                                  {name: "includeSubFolders"});
  pnl.includeSubFolders.helpTip = Strings.ProcessAllFoldersTip;

  yy += lineH;
  xx = UIC.col1X + lineH - 7;

  pnl.sourceBrowse = pnl.add('button', [xx, yy, xx+UIC.col1W-lineH,
                                        yy+UIC.btnH],
                             Strings.SelectFolder);

  pnl.sourceBrowse.helpTip = Strings.LocationOfFilesToProcessTip;

  xx = UIC.col2X;
  pnl.source = pnl.add('statictext', [xx, yy+UIC.txtOfs, xx+500, yy+lineH],
                       Strings.NoImagesSelected, {name: "source"});

  pnl.useFolder.value = true;

  pnl.useOpenImages.onClick = pnl.useFolder.onClick = function() {
    var pnl = this.parent;
    pnl.includeSubFolders.enabled = pnl.sourceBrowse.enabled =
      pnl.source.enabled = pnl.useFolder.value;
    // try {
    //   pnl.window.processor.widgets.keepFolderStructure.enabled = ...
    // } catch (e) {
    // }
  }
  pnl.useOpenImages.onClick();

  pnl.sourceBrowse.onClick = function() {
    var pnl = this.parent;

    try {
      var txt = pnl.source.text || Strings.NoImagesSelected;
      var pnl = this.parent;
      var def = (txt != Strings.NoImagesSelectedStr ?
                 new Folder(txt) : Folder.desktop);
      var f = psx.selectFolder(Strings.SelectFolder, def);
      if (f) {
        pnl.source.text = decodeURI(f.fsName);
      }
    } catch (e) {
      LogFile.logException(e, "sourceBrowse", true);
    }
  }

  var childs = pnl.children;
  for (var i = 0; i < childs.length; i++) {
    var child = childs[i];
    if (child.properties) {
      if (self.runningFromBridge) {
        var nm = child.properties.name;
        child.visible = (nm == "bridgeLbl" || nm == "img");
      } else {
        child.visible = child.properties.name != "bridgeLbl";
      }
    } else {
      child.visible = !self.runningFromBridge;
    }
  }

  return pnl;
};

ImageProcessor.prototype.createOutputPanel = function(pnl) {
  var self = this;
  var lineH = UIC.lineH;

  pnl.img = pnl.add('image', [0, 0, 30, 30]);
  ImageProcessor.setIcon(pnl.img, "two.png");
  pnl.img.helpTip = Strings.SelectSaveLocation;

  pnl.lbl = pnl.add('statictext', [30, 8, 300, lineH], Strings.SelectSaveLocation);
  pnl.lbl.helpTip = Strings.SelectSaveLocation;

  pnl.folder = pnl.add('image', [0, 0, 100, 120], 'SourceFolderIcon');

  var xx = UIC.col1X;
  var yy = lineH;
  var wideCol1 = UIC.col1W + 20;

  pnl.sameLocation = pnl.add('radiobutton',
                             [xx, yy, xx+wideCol1, yy+lineH],
                             Strings.SaveInSameLocation, {name: "sameLocation"});

  yy += lineH;

  pnl.useFolder = pnl.add('radiobutton',
                          [xx, yy, xx+lineH-7, yy+lineH],
                          undefined, {name: "useFolder"});

  yy -= lineH;
  xx += wideCol1 + UIC.gPad;

  var csfWidth = 150;
  pnl.createSubFolder = pnl.add('checkbox',
                                [xx, yy, xx+csfWidth, yy+lineH],
                                Strings.SaveInSubFolder,
                                {name: "createSubFolder"});

  pnl.createSubFolder.onClick = function() {
    var pnl = this.parent;
    pnl.keepFolderStructure.value = !pnl.createSubFolder.value;
    pnl.window.processor.setFolderNameState(pnl.createSubFolder.value);
  }

  xx += csfWidth;
  pnl.keepFolderStructure = pnl.add('checkbox',
                                    [xx, yy, xx+csfWidth+20, yy+lineH],
                                    Strings.KeepFolderStructure,
                                    {name: "keepFolderStructure"});

  pnl.keepFolderStructure.onClick = function() {
    var pnl = this.parent;
    pnl.createSubFolder.value = !pnl.keepFolderStructure.value;
    pnl.window.processor.setFolderNameState(pnl.createSubFolder.value);
  }

  yy += lineH;
  xx = UIC.col1X + lineH - 7;

  pnl.destBrowse = pnl.add('button', [xx, yy, xx+UIC.col1W-lineH,
                                        yy+UIC.btnH],
                           Strings.SelectFolder);

  xx = UIC.col2X;
  pnl.dest = pnl.add('statictext', [xx, yy+UIC.txtOfs, xx+500, yy+lineH],
                     Strings.NoFolderSelected, {name: "dest"});

  pnl.sameLocation.value = true;
  pnl.sameLocation.onClick = pnl.useFolder.onClick = function() {
    var pnl = this.parent;
    pnl.keepFolderStructure.enabled = pnl.destBrowse.enabled = 
    pnl.dest.enabled = pnl.useFolder.value;
  }
  pnl.sameLocation.onClick();

  pnl.destBrowse.onClick = function() {
    var pnl = this.parent;

    try {
      var txt = pnl.dest.text || Strings.NoFolderSelected;
      var pnl = this.parent;
      var def = (txt != Strings.NoFolderSelected ?
                 new Folder(txt) : Folder.desktop);
      var f = psx.selectFolder(Strings.SelectFolder, def);
      if (f) {
        pnl.dest.text = decodeURI(f.fsName);
      }
    } catch (e) {
      LogFile.logException(e, "destBrowse", true);
    }
  }

  return pnl;
};

ImageProcessor.prototype.createCtrlPanel = function(pnl) {
  var self = this;
  var lineH = UIC.lineH;

  var w = pnl.bounds.width;
  var btnW = w - 10;
  var btnH = UIC.btnH;
  var xx = 10;
  var yy = 10;
  
  pnl.runBtn = pnl.add('button', [xx,yy,xx+btnW,yy+btnH], Strings.RunBtn);
  yy += btnH + 5;
  pnl.cancelBtn = pnl.add('button', [xx,yy,xx+btnW,yy+btnH], Strings.CancelBtn);
  yy += btnH + 25;
  pnl.loadBtn = pnl.add('button', [xx,yy,xx+btnW,yy+btnH], Strings.LoadBtn);
  yy += btnH + 5;
  pnl.saveBtn = pnl.add('button', [xx,yy,xx+btnW,yy+btnH], Strings.SaveBtn);
  yy += btnH + 5;
  pnl.resetBtn = pnl.add('button', [xx,yy,xx+btnW,yy+btnH], Strings.ResetBtn);

  pnl.runBtn.onClick = function() {
    this.window.processor.run();
  }
  // pnl.cancelBtn.onClick = function() {
  //   this.window.processor.cancel();
  // }
  pnl.loadBtn.onClick = function() {
    this.window.processor.load();
  }
  pnl.saveBtn.onClick = function() {
    this.window.processor.save();
  }
  pnl.resetBtn.onClick = function() {
    this.window.processor.reset();
  }

  return pnl;
};


ImageProcessor.prototype.setFolderNameState = function(enabled) {
  try {
    var self = this;
    var tabs = self.tabPanel.children;
    for (var i = 0; i < tabs.length; i++) {
      var tab = tabs[i];
      tab.subfolderName.enabled = enabled;
    }
  } catch (e) {
  }
};

ImageProcessor.prototype.createFileSavePanel = FileSaveOptions.createFileSavePanel;
ImageProcessor.prototype.validateFileSavePanel = FileSaveOptions.validateFileSavePanel;

ImageProcessor.prototype.createFileTypesPanel = function(pnl) {
  var self = this;

  var lineH = UIC.lineH;

  pnl.img = pnl.add('image', [0, 0, 30, 30]);
  ImageProcessor.setIcon(pnl.img, "three.png");
  pnl.img.helpTip = Strings.FileTypes;

  pnl.lbl = pnl.add('statictext', [30, 8, 300, lineH], Strings.FileTypes);
  pnl.lbl.helpTip = Strings.FileTypes;

  var btnW = 30;
  var btnX = UIC.col1X - btnW - 10;
  var yy = lineH*2;

  pnl.addBtn = pnl.add('button', [btnX,yy,btnX+btnW,yy+UIC.btnH], '+');
  yy += lineH;
  pnl.removeBtn = pnl.add('button', [btnX,yy,btnX+btnW,yy+UIC.btnH], '-');
  pnl.removeBtn.enabled = false;

  pnl.updateState = function() {
    var pnl = this;
    pnl.removeBtn.enabled = pnl.tabPnl.children.length > 1;
  }

  pnl.addBtn.onClick = function() {
    try {
      var pnl = this.parent;
      var processor = pnl.window.processor;
      var xml = self.readTaskSettings(pnl.tabPnl.selection);
      
      var tab = processor.createFileTypeTab("jpg");
      var nm = tab.subfolderName.text;
      pnl.tabPnl.selection = tab;
      self.writeTaskSettings(tab, xml);
      tab.subfolderName.text = nm;
      tab.updateTabName();
      
      if (pnl.onChange) {
        pnl.onChange();
      }
      
      pnl.updateState();
      
    } catch (e) {
      LogFile.logException(e, "add", true);
    }
  }
  pnl.removeBtn.onClick = function() {
    var pnl = this.parent;
    pnl.tabPnl.remove(pnl.tabPnl.selection);
    pnl.removeBtn.enabled = pnl.tabPnl.children.length > 1;

    if (pnl.onChange) {
      pnl.onChange();
    }
  }

  pnl.tabPnl =  pnl.add('tabbedpanel', [UIC.col1X, lineH,
                                        pnl.bounds.width-10,
                                        pnl.bounds.height-10]);
  self.tabPanel = pnl.tabPnl;

  try {
    self.createFileTypeTab("jpg");
  } catch (e) {
    LogFile.logException(e, "Failed creating default FileType tab", true);
    return undefined;
  }

  pnl.onChange = function() {
    var pnl = this;
    var processor = pnl.window.processor;
    processor.findAllWidgets();

    pnl.updateState();
  }

  pnl.updateState();

  return pnl;
};

ImageProcessor.prototype.createFileNamingPanel = FileNamingOptions.createFileNamingPanel;

ImageProcessor.prototype.createFileTypeTab = function(type) {
  var self = this;

  if (!type) {
    type = "jpg";
  }
  var idx = self.tabPanel.children.length + 1;
  var name = "Set " + idx;
  var pnl = self.tabPanel.add('tab', undefined, name);

  pnl.mgr = self;
  
  var xOfs = 10;
  var xx = xOfs;
  var yy = 10;
  var lineH = UIC.lineH;

  pnl.isEnabled = pnl.add('checkbox', [xx,yy,xx+80,yy+UIC.textH], Strings.Save,
                        { name: "isEnabled" });
  pnl.isEnabled.value = true;

  pnl.isEnabled.onClick = function() {
    var pnl = this.parent;
    pnl.updateTabName();
  }
  
  xx = 139;
  pnl.subfolderNameLbl = pnl.add('statictext', [xx,yy+3,xx+120,yy+lineH],
                                 Strings.SubFolderNameLbl);
  xx += pnl.subfolderNameLbl.bounds.width+5;
  pnl.subfolderName = pnl.add('edittext', [xx,yy,xx+UIC.folderW,yy+UIC.textH],
                              name, { name: "subfolderName" });

  pnl.subfolderName.onChanging = function() {
    var pnl = this.parent;
    if (pnl.subfolderName.text.match(RegExp(ImageProcessor.BAD_CHARS))) {
      pnl.subfolderName.text = 
        pnl.subfolderName.text.replace(ImageProcessor.BAD_CHARS_REX, '');
    }
    pnl.updateTabName();
  }
  // this is a little awkward...
  pnl.subfolderName.enabled = pnl.window.outputPanel.createSubFolder.value;

  pnl.updateTabName = function() {
    var pnl = this;
    var name = pnl.subfolderName.text;

    // awkward...
    var filetype = pnl.fileSavePanel.fileType.selection.text;
    var ar = filetype.split(' ');
    filetype = ar[ar.length-1].replace(/\W/g, '');

    pnl.text = (!pnl.isEnabled.value ? "*" : "") + name + ' - ' + filetype;
  }
 
  yy += lineH + 5;
  xx = xOfs;

  // Output Format
  pnl.fileSavePanel = pnl.add('group', [xx,yy,xx+400,yy+95],
                              { name: "fileSavePanel" });
  self.createFileSavePanel(pnl.fileSavePanel, { fileType: type});

  // remove the Convert to sRGB button
  var idx = pnl.fileSavePanel.jpg.indexOf("jpgConvertToSRGB");
  pnl.fileSavePanel.jpg.splice(idx, 1);
  pnl.fileSavePanel.jpgConvertToSRGB.visible = false;
  pnl.fileSavePanel.jpgConvertToSRGB.enabled = false;
  pnl.fileSavePanel.jpgConvertToSRGB.value = false;

  pnl.fileSavePanel.saveForWeb.helpTip = Strings.RemovePreviewAndMetadata;

  pnl.fileSavePanel.onChange = function() {
    var pnl = this.parent;

    pnl.updateTabName();

    var opts = {};
    pnl.mgr.validateFileSavePanel(pnl.fileSavePanel, opts);
    var outFile = File(Folder.temp + '/Document.' + opts.fileSaveType);
    var fnp = pnl.fileNamingPanel.getFileNamingOptions();
    var example = fnp.format(outFile);
    pnl.fileNamingPanel.example.text = example;

    var type = opts.fileSaveType;
    if (type == "bmp" || type == "gif" || type == "jpg" ||
        type == "tga" || type == "eps") {
      pnl.setBitDepthState(false);
    } else {
      pnl.setBitDepthState(true);
    }
  }

  yy += 105;

  // Output Profile
  pnl.add('statictext', [xx,yy+3,xx+UIC.col1W,yy+lineH],
          Strings.OutputProfileLbl);
  xx += UIC.col1W - 23;

  pnl.colorProfile = pnl.add('dropdownlist', [xx, yy, xx+UIC.col1W, yy+25],
                             ImageProcessor.PROFILES,
                             { name: "colorProfile" } );
  pnl.colorProfile.items[1].selected = true;

 
  xx += UIC.col1W + 20;

  // Bit Depth
  pnl.bitDepthEnabled = pnl.add('checkbox', [xx,yy,xx+90,yy+lineH],
                                Strings.BitDepthLbl,
                                { name: "bitDepthEnabled" });

  pnl.bitDepthEnabled.onClick = function() {
    var pnl = this.parent;
    if (pnl.bitDepthEnabled.enabled) {
      pnl.bitDepth.enabled = pnl.bitDepthEnabled.value;
    } else {
      pnl.bitDepth.enabled = false;
    }
  }

  xx += pnl.bitDepthEnabled.bounds.width + 3;

  pnl.bitDepth = pnl.add('dropdownlist', [xx, yy, xx+40, yy+23],
                         ["8", "16"], { name: "bitDepth" } );
  pnl.bitDepth.items[0].selected = true;

  pnl.bitDepthEnabled.onClick();

  pnl.setBitDepthState = function(st) {
    var pnl = this;
    
    pnl.bitDepthEnabled.enabled = st;
    pnl.bitDepthEnabled.onClick();
  }

  pnl.setBitDepthState(false);

  
  yy += lineH;
  xx = xOfs;

  // Run Action
  pnl.runAction = pnl.add('checkbox', [xx,yy,xx+UIC.col1W,yy+UIC.textH],
                          Strings.RunAction,
                          { name: "runAction" });
  pnl.runAction.value = false;
  pnl.runAction.onClick = function() {
    var pnl = this.parent;
    var on = this.value;
    pnl.runActionWhen.enabled = pnl.actionLbl.enabled =
    pnl.actionSets.enabled = pnl.actions.enabled = on;
  }
  
  xx += UIC.col1W - 23;

  pnl.runActionWhen = pnl.add('dropdownlist', [xx,yy,xx+UIC.col1W,yy+25],
                              ImageProcessor.ACTION_MENU,
                              { name: "runActionWhen" });
  pnl.runActionWhen.items[0].selected = true;

//   yy += lineH;
//   xx = xOfs;
  xx += UIC.col1W + 20;

  // Action Selector
  pnl.actionLbl = pnl.add('statictext', [xx,yy+3,xx+UIC.col1W,yy+lineH],
                          Strings.ActionLbl);
  xx += 45;

  pnl.actionSets = pnl.add('dropdownlist', [xx,yy,xx+UIC.col1W,yy+25],
                              self.actionSetNames,
                              { name: "actionSets" });
  pnl.actionSets.items[0].selected = true;

  xx += UIC.col1W + 5;

  pnl.actions = pnl.add('dropdownlist', [xx,yy,xx+UIC.col1W,yy+25],
                       [], { name: "actions" });

  pnl.actionSets.onChange = function() {
    var pnl = this.parent;
    pnl.actions.removeAll();
    var acts = ImageProcessor.actionSets[this.selection.index].actions;
    for (var i = 0; i < acts.length; i++) {
      pnl.actions.add("item", acts[i]);
    }
    if (acts.length) {
      pnl.actions.items[0].selected = true;
    }
  }
  pnl.actionSets.onChange();
  pnl.runAction.onClick();

  xx = xOfs;
  yy += lineH;

  var useSerial = true;

  // Filenaming
  pnl.fileNamingPanel = pnl.add('panel',
                                [xx,yy,xx+550,yy+110],
                                '',
                                { name: "fileNamingPanel" });

  var fn = "Name,lowerCaseExtension";

  var op = { fileNaming: fn};
  self.createFileNamingPanel(pnl.fileNamingPanel, op, '', useSerial);

//   $.level = 1; debugger;

  var w = pnl.fileNamingPanel.example;
  var x = w.bounds.x + 295;
  var y = w.bounds.y;
  var lbl = pnl.fileNamingPanel.startingSerialLbl;
  lbl.bounds = [x,y+3,x+100,y+22+3];
  x += 105;
  var txt = pnl.fileNamingPanel.startingSerial;
  txt.bounds = [x,y,x+40,y+22];

  yy = 5;

  xx = 455; //pnl.parent.bounds.width-200;


  // Resize Panel
  pnl.resizePanel = pnl.add('panel', [xx, yy, xx+ResizePanel.DEFAULT_WIDTH,
                                      yy+ResizePanel.DEFAULT_HEIGHT],
                            '',
                            { name: "resizePanel" } );

  ResizePanel.createPanel(pnl.resizePanel, { width: 480, height: 640 }, "");

  pnl.saveForWebNotice = false;

  // this bit of code forces the resolution to 72ppi when SfW is selected
  pnl.fileSavePanel.saveForWeb.onClick = function() {
    var pnl = this.parent.parent;
    if (pnl.fileSavePanel.saveForWeb.value) {
      var proc = pnl.window.processor;
      if (!proc.saveForWebNotice) {
        alert(Strings.SaveForWebNotice);
        proc.saveForWebNotice = true;
      }
      if (pnl.resizePanel.resolution.text != 72) {
        pnl.resizePanel.resolution.text = 72;
      }
      var resUnits = pnl.resizePanel.resolutionUnits;
      if (resUnits.selection.text != ResizePanel.PPI) {
        resUnits.selection = resUnits.find(ResizePanel.PPI);
      }

      pnl.setBitDepthState(false);

    } else {
      pnl.fileSavePanel.onChange();
    }
  }

  pnl.runAction.onClick();

  return pnl;
};

ResizeOptions = function(obj, prefix) {
  var self = this;

  self.enabled = false;
  self.dontEnlarge = false;
  self.width = 1024;
  self.widthUnits = "px";
  self.height = 1024;
  self.heightUnits = "px";
  self.scale = true;  // styles
  self.resample = true;
  self.resampleMethod = ResampleMethod.BICUBIC;

  self._fitImage = false;

  if (obj) {
    if (prefix == undefined) {
      prefix = '';
    }
    var props = ResizeOptions.properties;
    for (var i = 0; i < props.length; i++) {
      var name = props[i];
      var oname = prefix + name;
      if (oname in obj) {
        self[name] = obj[oname];
      } else if (name == 'width' || name == 'height') {
        self[name] = '';
      }
    }
  }
};

ResizeOptions.properties = ["enabled", "dontEnlarge",
                            "width", "widthUnits",
                            "height", "heightUnits",
                            "resolution", "resolutionUnits",
                            "scale", "resample", "resampleMethod"];

ResizeOptions.resizeImage = function(doc, opts, p) {
  p = p || '';

  if (!toBoolean(opts[p + 'enabled'])) {
    return;
  }

  var dontEnlarge = toBoolean(opts[p + 'dontEnlarge']);

  var width = toNumber(opts[p + 'width']);
  var height = toNumber(opts[p + 'height']);
  
  if (!width || !height) {
    Error.runtimeError(9001, Strings.WidthAndHeightErr);
  }

  var oldPref = app.preferences.rulerUnits;
  app.preferences.rulerUnits = Units.PIXELS; // save old preferences

  var rez = doc.resolution;

  var docWidth = (1.0 * doc.width.as('px') * rez) / 72.0;
  var docHeight = (1.0 * doc.height.as('px') * rez) / 72.0;
  
  var docRatio = docWidth / docHeight; // decimal ratio of original width/height
  
  var newWidth = width;
  var newHeight = ((1.0 * width) / docRatio); // decimal calc
  
  if (dontEnlarge) {
    if (newWidth > docWidth ||
        newHeight > docHeight) {
      return;
    }
  }

  if (newHeight > height) {
    // newWidth = Math.floor(docRatio * height); // decimal calc
    newWidth = undefined;
    newHeight = height;

  } else {
    newHeight = undefined;
  }

  var desc = new ActionDescriptor();
  if (newWidth != undefined) {
    desc.putUnitDouble(cTID('Wdth'), cTID('#Pxl'), newWidth);
  }
  if (newHeight != undefined) {
    desc.putUnitDouble(cTID('Hght'), cTID('#Pxl'), newHeight);
  }

  // We always constrain proportions
  desc.putBoolean( cTID('CnsP'), true );

  var scaleStyles = toBoolean(opts[p + 'scaleStyles']);
  desc.putBoolean(sTID('scaleStyles'), scaleStyles);
                  
  var id = ResizePanel.typeIdFromResampleMethod(opts[p + 'resampleMethod']);
  desc.putEnumerated(cTID('Intr'), cTID('Intp'), id);

  executeAction(cTID('ImgS'), desc, DialogModes.NO);
};


//
// ResizePanel
// 
ResizePanel = function() {};

ResizePanel.DEFAULT_WIDTH = 250;
ResizePanel.DEFAULT_HEIGHT = 160;

ResizePanel.METHOD_LABELS = ["Bicubic", "BicubicSharper","BicubicSmoother",
                            "None", "Bilinear", "NearestNeighbor"];

ResizePanel.UNITS = ["pixels", "percent", "inches",
                     "cm", "mm", "points", "picas"];

ResizePanel.PPI = "pixels/inch";
ResizePanel.PPCM = "pixels/cm";
ResizePanel.RES_UNITS = [ResizePanel.PPI, ResizePanel.PPCM];

ResizePanel.createPanel = function(pnl, ini, prefix) {
  var self = this;

  var xofs = 0;
  var yofs = 0;
  var tOfs = ((CSVersion() >= 3) ? 3 : 0);
  var deltaY = 23;

  if (pnl.type == 'panel') {
    xofs += 5;
    yofs += 5;
  }

  pnl.prefix = prefix || '';

  var xx = xofs;
  var yy = yofs;

  var opts = new ResizeOptions(ini, pnl.prefix);

//   alert(listProps(ini));
//   alert(listProps(opts));

  //
  // Enabled
  //
  pnl.resizeEnabled = pnl.add('checkbox', [xx,yy,xx+100,yy+25],
                              Strings.ResizeToFit);
  pnl.resizeEnabled.value = toBoolean(opts.enabled);

  pnl.resizeEnabled.onClick = function() {
    var pnl = this.parent;
    var st = pnl.resizeEnabled.value;
    var props = ["resizeWidthLabel", "resizeWidth", "resizeWidthUnits",
                 "resizeHeightLabel", "resizeHeight", "resizeHeightUnits",
                 "resolutionLabel", "resolution", "resolutionUnits",
                 "resizeScale", "resampleMethod","resizeReset",
                 "resizeDontEnlarge"
                 ];
    for (var i = 0; i < props.length; i++) {
      var w = props[i];
      pnl[w].enabled = st;
    }

    pnl.resampleMethod.enabled = st;
  }

  
  xx += 128;

  pnl.resizeDontEnlarge = pnl.add('checkbox', [xx,yy,xx+120,yy+25],
                                  "Don't Enlarge");
  pnl.resizeDontEnlarge.value = toBoolean(opts.dontEnlarge);


  // Reset - probably not needed here
  pnl.resizeReset = pnl.add('button', [xx,yy,xx+80,yy+20], 'Reset...');
  pnl.resizeReset.visible = false;
  pnl.resizeReset.onClick = function() {
    var pnl = this.parent;
    if (pnl._width) {
      pnl.resizeWidth.text = pnl._width;
    }
    if (pnl._height) {
      pnl.resizeHeight.text = pnl._height;
    }
  }

  yy += deltaY + 5;
  xx = xofs;


  var units = ResizePanel.UNITS;
  var resUnits = ResizePanel.RES_UNITS;

  var col1 = 73;

  var menuWidth = 100;

  //
  // Width
  //
  pnl.resizeWidthLabel = pnl.add('statictext',
                                 [xx,yy+tOfs,xx+col1,yy+tOfs+23],
                                 Strings.WidthLbl);
  xx += col1;
  pnl.resizeWidth = pnl.add('edittext', [xx,yy,xx+50,yy+20], 1024);
  var w = toNumber(opts.width) || '';
  pnl._width = w;
  pnl.resizeWidth.text = w;
  xx += 55;
  pnl.resizeWidthUnits = pnl.add('dropdownlist',
                                 [xx,yy,xx+menuWidth,yy+22], units);

  psxui.setMenuSelection(pnl.resizeWidthUnits, opts.resizeWidthUnits || '', 0);

  yy += deltaY;
  xx = xofs;

  // Height
  pnl.resizeHeightLabel = pnl.add('statictext',
                                 [xx,yy+tOfs,xx+col1,yy+tOfs+23],
                                  Strings.HeightLbl);
  xx += col1;
  pnl.resizeHeight = pnl.add('edittext', [xx,yy,xx+50,yy+20], 1024);
  var h = toNumber(opts.height) || '';
  pnl._height = h;
  pnl.resizeHeight.text = h;
  xx += 55;
  pnl.resizeHeightUnits = pnl.add('dropdownlist',
                               [xx,yy,xx+menuWidth,yy+22], units);

  psxui.setMenuSelection(pnl.resizeHeightUnits,
                         opts.resizeHeightUnits || '', 0);

  yy += deltaY;
  xx = xofs;

  // Resolution
  pnl.resolutionLabel = pnl.add('statictext',
                                [xx,yy+tOfs,xx+col1,yy+tOfs+23],
                                Strings.ResolutionLbl);
  xx += col1;
  pnl.resolution = pnl.add('edittext', [xx,yy,xx+50,yy+20], 1024);
  var h = toNumber(opts.resolution) || 72;
  pnl.resolution.text = h;
  xx += 55;
  pnl.resolutionUnits = pnl.add('dropdownlist',
                               [xx,yy,xx+menuWidth,yy+22], resUnits);


  psxui.setMenuSelection(pnl.resolutionUnits, opts.resolutionUnits || '', 0);

  pnl.resizeWidth.onChanging = pnl.resizeHeight.onChanging =
  pnl.resolution.onChanging = function() {
    var pnl = this.parent;
    psxui.numberKeystrokeFilter.call(this);
  }

  pnl.resolutionUnits.onChange = function() {
    var pnl = this.parent;
    if (pnl.resolution.text) {
      var txt = pnl.resolutionUnits.selection.text;
      if (txt == ResizePanel.PPI) {
        pnl.resolution.text = toNumber(pnl.resolution.text) * 2.54;
      } else {
        pnl.resolution.text = toNumber(pnl.resolution.text) / 2.54;
      }
    }
  }

  yy += deltaY;
  xx = xofs + col1;


  // Scale
  pnl.resizeScale = pnl.add('checkbox', [xx,yy,xx+180,yy+23],
                            Strings.ScaleStyles);
  pnl.resizeScale.value = toBoolean(opts.scale);

  yy += deltaY;
  xx = xofs + col1;

  var methods = ResizePanel.METHOD_LABELS;
  var rsm = opts.resampleMethod;

  pnl.resampleMethod = pnl.add('dropdownlist', [xx,yy,xx+150,yy+22], methods);

  var it = pnl.resampleMethod[0];
  var items = pnl.resampleMethod.items;
  for (var i = 0; i < items.length; i++) {
    if (rsm == items[i].text.toLowerCase()) {
      it = items[i];
      break;
    }
  }
  pnl.resampleMethod.selection = it;

  yy += deltaY;
  xx = xofs;

  pnl.updateSettings = function(ini) {
    var pnl = this;

    var opts = new ResizeOptions(ini, pnl.prefix);
    pnl.resizeEnabled.value = toBoolean(opts.enabled);

    pnl.resizeDontEnlarge.value = toBoolean(opts.dontEnlarge);

    var w = toNumber(opts.width) || '';
    pnl._width = w;
    pnl.resizeWidth.text = w;
    psxui.setMenuSelection(pnl.resizeWidthUnits, opts.widthUnits || '', 0);

    var h = toNumber(opts.height) || '';
    pnl._height = h;
    pnl.resizeHeight.text = h;
    psxui.setMenuSelection(pnl.resizeHeightUnits, opts.heightUnits || '', 0);

    psxui.setMenuSelection(pnl.resolutionUnits, opts.resolutionUnits || '', 0);

    pnl.resolution.text = toNumber(opts.resolution) || 72;

    pnl.resizeScale.value = toBoolean(opts.scale);

    var rsm = opts.resampleMethod;

    var it = pnl.resampleMethod[0];
    var items = pnl.resampleMethod.items;
    for (var i = 0; i < items.length; i++) {
      if (rsm == items[i].text.toLowerCase()) {
        it = items[i];
        break;
      }
    }
    pnl.resampleMethod.selection = it;
    pnl.resizeEnabled.onClick();
  }

  pnl.resizeEnabled.onClick();
  
  return pnl;
};

ImageProcessor.prototype.validateResizePanel = function(pnl, opts) {
  var self = this;

  var p = pnl.prefix;

  var st = pnl.resizeEnabled.value;
  opts[p + 'enabled'] = st;

  if (!st) {
    return opts;
  }

  var st = pnl.resizeDontEnlarge.value;
  opts[p + 'dontEnlarge'] = st;

  var w = 0;
  if (pnl.resizeWidth.text.trim() != '') {
    var n = toNumber(pnl.resizeWidth.text);
    if (isNaN(n) || n < 1) {
      return self.errorPrompt(Strings.WidthValueErr);
    }
    w = n;
  }
  opts[p + 'width'] = w;
  opts[p + 'widthUnits'] = pnl.resizeWidthUnits.selection.text;

  var h = 0;
  if (pnl.resizeHeight.text.trim() != '') {
    n = toNumber(pnl.resizeHeight.text);
    if (isNaN(n) || n < 1) {
      return self.errorPrompt(Strings.HeightValueErr);
    }
    h = n;
  }
  opts[p + 'height']  = h;
  opts[p + 'heightUnits'] = pnl.resizeHeightUnits.selection.text;

  if (!h && !w) {
    // return self.errorPrompt(Strings.WidthAndOrHeightErr);
  } else {
    if (!h) {
      h = w;
      opts[p + 'height']  = h;
      opts[p + 'heightUnits'] = opts[p + 'widthUnits'] ;
    } 
    if (!w) {
      w = h;
      opts[p + 'width']  = w;
      opts[p + 'widthUnits'] = opts[p + 'heightUnits'] ;
    }
  }

  var r = '';
  if (pnl.resolution.text.trim() != '') {
    n = toNumber(pnl.resolution.text);
    if (isNaN(n) || n < 1) {
      return self.errorPrompt(Strings.ResolutionErr);
    }
    r = n;
  }

  opts[p + 'resolution']  = r;
  opts[p + 'resolutionUnits'] = pnl.resolutionUnits.selection.text;


  opts[p + 'scale'] = pnl.resizeScale.value;

  var str = pnl.resampleMethod.selection.text;
  opts[p + 'resampleMethod'] = str.toLowerCase();

  return opts;
};

ResizePanel.refreshPanel = function(pnl, opts) {
  var self = this;

  if (opts.width) {
    pnl._width = toNumber(opts.width);
  }

  if (opts.height) {
    pnl.height = toNumber(opts.height);
  }

  pnl.resizeWidth.onChanging();
  pnl.resizeHeight.onChanging();
};

ResizePanel.strToResampleMethod = function(s) {
  s = s.toString();
  var str = s.replace(/(ResampleMethod\.)|(\s+)/, '').toLowerCase();
  var methods = ["bicubic", "bicubicsharper","bicubicsmoother",
    "none", "bilinear", "nearestneighbor"];

  if (methods.contains(str)) {
    return ResampleMethod[str.toUpperCase()];
  }

  return undefined;
};

ResizePanel.strFromResampleMethod = function(rsm) {
  var str = rsm.toString();

  return str.replace(/ResampleMethod\./, '').toLowerCase();
};
ResizePanel.typeIdFromResampleMethod = function(rsm) {
  var str = (rsm.constructor == String ?
             rsm.toLowerCase() : ResizePanel.strFromResampleMethod(rsm));

  if (str == 'bicubic') {
    return sTID(str);
  }
  if (str == 'bicubicsmoother') {
    return sTID('bicubicSmoother');
  }
  if (str == 'bicubicsharper') {
    return sTID('bicubicSharper');
  }
  if (str == 'none') {
    return sTID('none');
  }
  if (str == 'bilinear') {
    return sTID('bilinear');
  }
  if (str == 'nearestneighbor') {
    return sTID('nearestNeighbor');
  }

  return 0;
};

ImageProcessor.prototype.createPreferencesPanel = function(pnl) {
  var self = this;
  var lineH = UIC.lineH;

  pnl.img = pnl.add('image', [0, 0, 30, 30]);
  ImageProcessor.setIcon(pnl.img, "four.png");
  pnl.img.helpTip = Strings.Preferences;

  pnl.lbl = pnl.add('statictext', [30, 8, 300, lineH], Strings.Preferences);
  pnl.lbl.helpTip = Strings.Preferences;

  var xx = UIC.col1X;
  var yy = lineH;
  var width = UIC.col1W;

  pnl.copyrightInfoLbl = pnl.add('statictext',
                                 [xx,yy+UIC.txtOfs,xx+width,yy+UIC.textH],
                                 Strings.CopyrightInfoLbl);
  
  xx += width;
  pnl.copyrightInfo = pnl.add('edittext',
                              [xx,yy+3,xx+UIC.folderW*2,yy+UIC.textH],
                              "", { name: "copyrightInfo"});
  return pnl;
};


// User Interface Layout constants...
UIC = {
  lineH: 28,
  textH: 23,
  btnH: 25,
  margin: 15,
  sizeW: 40,
  folderW: 150,
  inputH: 85,
  outputH: 85,
  ctrlPnlW: 100,
  ctrlBtnW: 80,
  fileTypesH: 390,
  preferencesH: 60,
  col1X: 80,
  col1W: 150,
  col2W: 150,
  // col2X: col1X + col1W + gPad
  gPad: 7,
  txtOfs: 7
};
UIC._init = function() {
  UIC.col2X = UIC.col1X + UIC.col1W + UIC.gPad;
};
UIC._init();

ImageProcessor.prototype.createDialog = function() {
  var self = this;

  var win = new Window('dialog', ImageProcessor.VTITLE_UI,
                       [200, 200, 1040, 880]);

  win.mgr = self;
  win.processor = self;
  self.window = win;

  var margin = UIC.margin;
  var lmargin = margin;
  var rmargin = win.bounds.width-margin;
  var tmargin = margin;
  var bmargin = win.bounds.height-margin;

  var ptype = 'group'; //'panel'; // for layout debugging, set to panel

  var yy = margin;
  var xx = margin;

  var edgeR = rmargin - UIC.ctrlPnlW - margin;

  try {
  // Input panel
  win.inputPanel = win.add(ptype, [lmargin, yy, edgeR, yy+UIC.inputH]);
  if (!self.createInputPanel(win.inputPanel)) {
    Error.runtimeError(9005, "panel creation failure");
  }
  } catch (e) {
    LogFile.logException(e, "Failed creating Input panel", true);
    return undefined;
  }

  // divider
  yy += win.inputPanel.bounds.height + 5;
  win.add('panel', [xx, yy, edgeR, yy+2], undefined, { borderStyle: 'sunken'} );
  yy += 7;

  try {
  // Output Panel
  win.outputPanel = win.add(ptype, [lmargin, yy, edgeR, yy+UIC.outputH]);
  if (!self.createOutputPanel(win.outputPanel))  {
    Error.runtimeError(9005, "panel creation failure");
  }
  } catch (e) {
    LogFile.logException(e, "Failed creating Output panel", true);
    return undefined;
  }

  yy += win.outputPanel.bounds.height;

  try {
  // Control Panel
  win.ctrlPanel = win.add(ptype, [rmargin-UIC.ctrlPnlW, tmargin, rmargin, yy]);
  if (!self.createCtrlPanel(win.ctrlPanel)) {
    Error.runtimeError(9005, "panel creation failure");
  }
  } catch (e) {
    LogFile.logException(e, "Failed creating Control panel", true);
    return undefined;
  }

  // divider
  yy += 5;
  win.add('panel', [xx, yy, rmargin, yy+2], undefined,
          { borderStyle: 'sunken'} );
  yy += 7;

  try {
  // File Types Panel
  win.fileTypesPanel = win.add(ptype,
                               [lmargin, yy, rmargin, yy+UIC.fileTypesH]);
  if (!self.createFileTypesPanel(win.fileTypesPanel))  {
    Error.runtimeError(9005, "panel creation failure");
  }
  } catch (e) {
    LogFile.logException(e, "Failed creating File Types panel", true);
    return undefined;
  }

  // divider
  yy += win.fileTypesPanel.bounds.height + 5;
  win.add('panel', [xx, yy, rmargin, yy+2], undefined,
          { borderStyle: 'sunken'} );
  yy += 7;

  try {
  // PreferencesPanel
  win.preferencesPanel = win.add(ptype,
                                 [lmargin, yy, rmargin, yy+UIC.preferencesH]);
  if (!self.createPreferencesPanel(win.preferencesPanel))  {
    Error.runtimeError(9005, "panel creation failure");
  }
  } catch (e) {
    LogFile.logException(e, "Failed creating Preferences panel", true);
    return undefined;
  }

  return win;
};

//
// read settings from the UI
//
ImageProcessor.prototype.readSettings = function() {
  var self = this;
  var settings = ImageProcessorOptions.DEFAULT_XML.copy();

  settings.input = self.readInputSettings();
  settings.output = self.readOutputSettings();
  settings.taskList = self.readFileTypeSettings();
  settings.preferences = self.readPreferencesSettings();

  return settings;
};

//
// write settings to the UI
//
ImageProcessor.prototype.writeSettings = function(settings) {
  var self = this;

  self.writeInputSettings(settings.input);
  self.writeOutputSettings(settings.output);
  self.writeFileTypeSettings(settings.taskList);
  self.writePreferencesSettings(settings.preferences);
};


// Input Settings
ImageProcessor.prototype.readInputSettings = function() {
  var self = this;
  var widgets = ImageProcessor.findWidgets(self.window.inputPanel);
  var settings = new XML("<input/>");

  if (self.runningFromBridge) {
    settings.@source = "bridge";

  } else if (widgets.useOpenImages.value) {
    settings.@source = "openImages";

  } else {
    settings.@source = "folder";
    settings.@includeSubFolders = widgets.includeSubFolders.value;

    var fileStr = widgets.source.text;

    if (fileStr == Strings.NoImagesSelected) {
      settings.@path = '';

    } else {
      var folder = Folder(fileStr);
      if (folder.exists) {
        settings.@path = decodeURI(folder.absoluteURI);
      } else {
        settings.@path = fileStr;
      }
    }
  } 

  return settings;
};

ImageProcessor.prototype.writeInputSettings = function(settings) {
  var self = this;
  var widgets = ImageProcessor.findWidgets(self.window.inputPanel);

  var src = settings.@source.toString();
  widgets.useOpenImages.value = (src == "openImages");

  widgets.useFolder.value = !widgets.useOpenImages.value;

  widgets.includeSubFolders.value = toBoolean(settings.@includeSubFolders);

  if (src == "folder") {
    var path = settings.@path.toString() || Strings.NoImagesSelected;
    widgets.source.text = path;
  }

  if (app.documents.length == 0) {
    widgets.useOpenImages.enabled = false;
    widgets.useFolder.value = true;
  }

  widgets.useOpenImages.onClick();
};


// Output Settings
ImageProcessor.prototype.readOutputSettings = function() {
  var self = this;    var doc;

  var widgets = ImageProcessor.findWidgets(self.window.outputPanel);
  var settings = new XML("<output/>");

  if (widgets.sameLocation.value) {
    settings.@path = "same";

  } else {
    var fileStr = widgets.dest.text;
    if (fileStr == Strings.NoFolderSelected) {
      settings.@path = '';

    } else {
      var file = File(fileStr);
      if (file.exists) {
        settings.@path = decodeURI(file.absoluteURI);
      } else {
        settings.@path = fileStr;
      }
    }
  }

  settings.@subfolder = widgets.createSubFolder.value;
  settings.@keepStructure = widgets.keepFolderStructure.value;

  return settings;
};

ImageProcessor.prototype.writeOutputSettings = function(settings) {
  var self = this;
  var widgets = ImageProcessor.findWidgets(self.window.outputPanel);

  var path = settings.@path.toString();
  widgets.sameLocation.value = (path == "same");

  widgets.useFolder.value = !widgets.sameLocation.value;

  if (path != "same") {
    widgets.dest.text = path;
  }

  widgets.createSubFolder.value = toBoolean(settings.@subfolder);
  widgets.keepFolderStructure.value = toBoolean(settings.@keepStructure);

  widgets.useFolder.onClick();
};

// File Type Settings
ImageProcessor.prototype.readFileTypeSettings = function() {
  var self = this;
  var settings = new XML("<taskList/>");

  var tabs = self.tabPanel.children;
  for (var i = 0; i < tabs.length; i++) {
    var tab = tabs[i];
    var xml = self.readTaskSettings(tab);
    settings.appendChild(xml);
  }

  return settings;
};

ImageProcessor.prototype.writeFileTypeSettings = function(settings) {
  var self = this;
  var subs = self.tabPanel;

  while (subs.children.length > 0) {
    subs.remove(0);
  }

  var tasks = settings.task;
  var len = tasks.length();
  if (len > 0) {
    for (var i = 0; i < len; i++) {
      var task = tasks[i];
      try {
        if (!self.createFileTypeTab("jpg")) {
          Error.runtimeError(9005, "Failed creating FileType tab");
        }
      } catch (e) {
        Error.runtimeError(9005, "Failed creating FileType tab: " +
                           psx.exceptionMessage(e));
      }
      self.writeTaskSettings(self.tabPanel.children[i], task);
    }
  } else {
    try {
      if (!self.createFileTypeTab("jpg")) {
        Error.runtimeError(9005, "Failed creating FileType tab");
      }
    } catch (e) {
      Error.runtimeError(9005, "Failed creating FileType tab: " +
                         psx.exceptionMessage(e));
    }
  }

  self.window.fileTypesPanel.updateState();
};

// Task Settings
ImageProcessor.prototype.readTaskSettings = function(tab) {
  var self = this;
  var settings = new XML("<task/>");
  var widgets = ImageProcessor.findWidgets(tab);

  settings.@enabled = widgets.isEnabled.value;
  settings.@subfolderName = widgets.subfolderName.text;
  settings.@colorProfile = widgets.colorProfile.selection.text;

  if (widgets.bitDepthEnabled.enabled && widgets.bitDepthEnabled.value) {
    if (widgets.bitDepth.enabled) {
      settings.@bitDepth = toNumber(widgets.bitDepth.selection.text);
    }
  }

  var ini = {};
  self.validateFileSavePanel(widgets.fileSavePanel, ini);

  var saveOpts = <saveOptions/>;
  for (var idx in ini) {
    if (!idx.startsWith('_')) {
      eval('saveOpts.@' + idx + '= "' + ini[idx] + '"');
    } else {
      self[idx] = ini[idx];
    }
  }

  settings.saveOptions = saveOpts;

  var ini = {};
  self.validateResizePanel(widgets.resizePanel, ini);

  var resizeOpts = <resizeOpts/>;
  for (var idx in ini) {
    if (!idx.startsWith('_')) {
      eval('resizeOpts.@' + idx + '= "' + ini[idx] + '"');
    } else {
      self[idx] = ini[idx];
    }
  }

  settings.resizeOptions = resizeOpts;

  var action = <action/>;
  action.@enabled = widgets.runAction.value;
  action.@when = widgets.runActionWhen.selection.text;
  action.@set = widgets.actionSets.selection.text;
  action.@name = widgets.actions.selection.text;

  settings.action = action;

  var opts = widgets.fileNamingPanel.getFileNamingOptions();

  settings.namingOptions = opts.fileNaming.toString();
  settings.namingOptions.@startingSerial = opts.startingSerial;

  return settings;
};

ImageProcessor.prototype.writeTaskSettings = function(tab, settings) {
  var self = this;
  var widgets = ImageProcessor.findWidgets(tab);

  widgets.isEnabled.value = toBoolean(settings.@enabled);
  widgets.subfolderName.text = settings.@subfolderName.toString();
  widgets.subfolderName.onChanging();

  var profile = settings.@colorProfile.toString();
  if (!profile) {
    widgets.colorProfile.items[1].selected = true;
  } else {
    var it = (widgets.colorProfile.find(profile) ||
              widgets.colorProfile.items[1]);
    it.selected = true;
  }

  var bpc = settings.@bitDepth.toString();
  if (bpc != "") {
    var it = widgets.bitDepth.find(bpc) || widgets.bitDepth.items[0];
    it.selected = true;
    tab.setBitDepthState(true);
    widgets.bitDepthEnabled.value = true;
  } else {
    tab.setBitDepthState(false);
  }
  widgets.bitDepthEnabled.onClick();

  // save options
  var ini = ImageProcessor.attrsToIni(settings.saveOptions);
  widgets.fileSavePanel.updateSettings(ini);


  // resize options
  var ini = ImageProcessor.attrsToIni(settings.resizeOpts);
  widgets.resizePanel.updateSettings(ini);

  // action settings
  var action = settings.action;
  widgets.runAction.value = toBoolean(action.@enabled);

  psxui.setMenuSelection(widgets.runActionWhen, action.@when, 0);
  psxui.setMenuSelection(widgets.actionSets, action.@set, 0);
  psxui.setMenuSelection(widgets.actions, action.@name, 0);

  // naming options
  var str = settings.namingOptions.toString() || "Name,lowerCaseExtension";
  var ini = { fileNaming: str };
  ini.startingSerial = settings.namingOptions.@startingSerial.toString() || "1";
  widgets.fileNamingPanel.updateSettings(ini);

  widgets.fileSavePanel.onChange();
  widgets.runAction.onClick();
};


// Preferences Settings
ImageProcessor.prototype.readPreferencesSettings = function() {
  var self = this;
  var widgets = ImageProcessor.findWidgets(self.window.preferencesPanel);
  var settings = new XML("<preferences/>");

  if (widgets.copyrightInfo.text) {
    settings.copyrightInfo = widgets.copyrightInfo.text;
  }

  return settings;
};

ImageProcessor.prototype.writePreferencesSettings = function(settings) {
  var self = this;
  var widgets = ImageProcessor.findWidgets(self.window.preferencesPanel);

  if (settings.copyrightInfo != undefined) {
    widgets.copyrightInfo.text = settings.copyrightInfo.toString();
  } else {
    widgets.copyrightInfo.text = '';
  }
};


// Find Widgets
ImageProcessor.isContainer = function(o) {
  return (o.type == 'dialog' || o.type == 'group'
          || o.type == 'panel' || o.type == 'tab');
};

ImageProcessor.findWidgets = function(c, o, recurse) {
  if (o == undefined) {
    o = {};
  }
  if (ImageProcessor.isContainer(c)) {
    if (recurse == undefined) {
      recurse = true;
    }

    var children = c.children;

    if (children == undefined || children.length == 0) {
      return;
    }

    var len = children.length;
    
    for (var i = 0; i < len; i++) {
      var p = children[i];
      if (p == undefined) {
        continue;
      }
      
      if (ImageProcessor.isContainer(p) && recurse == true) {
        ImageProcessor.findWidgets(p, o, recurse);
      }
      
      if (p.properties != undefined && p.properties.name != undefined) {
        o[p.properties.name] = p;
      }
    }
  }

  return o;
};
  
ImageProcessor.prototype.findAllWidgets = function() {
  var self = this;

  self.widgets = {};
  self.fileTypeWidgets = [];

  var w = self.window;
  ImageProcessor.findWidgets(w.inputPanel, self.widgets, false);
  ImageProcessor.findWidgets(w.outputPanel, self.widgets, false);
  ImageProcessor.findWidgets(w.preferencesPanel, self.widgets, false);
  
  var ftPanels = self.tabPanel.children;

  for (var i = 0; i < ftPanels.length; i++) {
    var pnl = ftPanels[i];
    var obj = {};
    ImageProcessor.findWidgets(pnl, obj, true);
    self.fileTypeWidgets.push(obj);
  }
};


ImageProcessor.prototype.getFiles = function(input) {
  var self = this;
  var src = input.@source.toString().toLowerCase();
  var files = [];

  if (src == "openimages") {
    var unsavedDocs = [];

    for (var i = 0; i < app.documents.length; i++) {
      var doc = app.documents[i];
      try {
        var temp = doc.fullName;
        files.push(doc);

      } catch (e) {
        if (e.number == 8103) {
          unsavedDocs.push(doc.name);
        } else {
          throw e;
        }
      }
    }

    if (unsavedDocs.length > 0) {
      alert(Strings.MustSaveOpen + "\r" + Strings.FollowingNotSaved + "\r( " +
            unsavedDocs.join(", ") + " )" );
    }

  } else if (src == "folder") {
    var recurse = toBoolean(input.@includeSubFolders);
    var folder = Folder(input.@path.toString());

    if (!folder.exists) {
      Error.runtimeError(48, folder.toUIString());
    }

    if (recurse) {
      files = psx.findFiles(folder);
    } else {
      files = psx.getFiles(folder);
    }

  } else if (src == "bridge") {
    files = ImageProcessor.getImageFilesFromBridge();
  }

  return files;
};

ImageProcessor.prototype.openDocument = function(file) {
  var self = this;
  var settings = self.settings;
  var mode = DialogModes.NO;
  var ext = file.strf("%e").toLowerCase();
  var isRaw = ImageProcessor.CAMERA_RAW_FILES.contains(ext);

  if (isRaw) {
  }

  var currentDoc = (app.documents.length > 0) ? app.activeDocument : undefined;

  var desc = new ActionDescriptor();
  desc.putPath(cTID('null'), file);
  var rdesc = executeAction(cTID('Opn '), desc, mode);

  // we could also check rdesc...
  if (app.documents.length == 0 || app.activeDocument == currentDoc) {
    Error.runtimeError(9002, Strings.UnableToOpenErr);
  }

  var doc = app.activeDocument;

//   if (rdesc.hasKey(cTID('As  '))) {
//     if (rdesc.hasKey(cTID('null'))) {
//       var path = rdesc.getPath(cTID('null'));
//     }
//   }

  $.gc();
  return doc;
};


ImageProcessor.prototype.saveDocument = function(doc, file, task) {
  var self = this;
  var sRGB = "sRGB IEC61966-2.1";
  var settings = self.settings;
  var input = settings.input;
  var output = settings.output;

  var historyState = doc.activeHistoryState;

  // Save Options
  var ini = ImageProcessor.attrsToIni(task.saveOptions);
  var saveOpts = FileSaveOptions.convert(ini);
  var ext = ini.fileSaveType;
  saveOpts._ext = ext;

  // Force a color profile if one is not present
  if (doc.colorProfileType == ColorProfile.NONE) {
    doc.colorProfileName = sRGB;
  }

  // Pre-resize Action
  var action = task.action;
  if (toBoolean(action.@enabled) &&
      action.@when == ImageProcessor.BEFORE_IMAGE_RESIZE) {
    app.doAction(action.@name.toString(), action.@set.toString());
  }

  if (saveOpts.flattenImage) {
    // doc.flatten();
    try { psx.mergeVisible(doc); } catch (e) {}
  }

  if (saveOpts._flatten) {
    // doc.flatten();
    try { psx.mergeVisible(doc); } catch (e) {}
  }

  if (saveOpts._8Bit) {
    var bpc = doc.bitsPerChannel;
    if (bpc != BitsPerChannelType.ONE && bpc != BitsPerChannelType.EIGHT) {
      doc.bitsPerChannel = BitsPerChannelType.EIGHT;
    }
  }

  // Bit Depth
  var bd = toNumber(task.@bitDepth) || 0;
  if (bd) {
    var bpc = doc.bitsPerChannel;
    try {
      if (bd == 8) {
        doc.bitsPerChannel = BitsPerChannelType.EIGHT;
      } else if (bd == 16) {
        doc.bitsPerChannel = BitsPerChannelType.SIXTEEN;
      }
    } catch (e) { 
      LogFile.logException(e, "Error selecting bit depth " + bd);
    }
  }

  // remove alpha channels
  ImageProcessor.removeAlphaChannels(doc);

  // convert profile
  var profile = task.@colorProfile.toString();
  if (profile != ImageProcessor.UNTAGGED_RGB &&
      profile != ImageProcessor.SAME_AS_SOURCE) {

    try {
      // doc.flatten();
      try { psx.mergeVisible(doc); } catch (e) {}
      doc.convertProfile(profile, Intent.RELATIVECOLORIMETRIC, true, true);

    } catch(e) {
      // $.level = 1; debugger;
      // do nothing, if you convert to "Working RGB" and working rgb
      // is the same as the current profile
      // you will get an error, this will catch the error and continue on
    }
  }

  // resize/fit image
  var resizeOpts = task.resizeOpts;

  if (toBoolean(saveOpts.@saveForWeb)) {
    resizeOpts.@resolution = 72;
    resizeOpts.@resolutionUnits = ResizePanel.PPI;
  }

  if (toBoolean(resizeOpts.@enabled)) {
    var res = toNumber(resizeOpts.@resolution);
    if (resizeOpts.@resolutionUnits != ResizePanel.PPI) {
      res *= 2.54;
    }
    if (res == 0 || isNaN(res)) {
      res = doc.resolution;
    }
    if (doc.resolution != res) {
      doc.resizeImage(undefined, undefined, res, ResampleMethod.NONE);
    }

    var width = toNumber(resizeOpts.@width);
    var height = toNumber(resizeOpts.@height);
    if (width == 0 || isNaN(width)) {
      width = height;
    }
    if (height == 0 || isNaN(height)) {
      height = width;
    }

    if (!width && !height) {
      // resolution change only
      // Error.runtimeError(9005, "Bad resize width and height values specified");
    } else {
      var ini = {};
      ini.width = ImageProcessor.unitsToPixels(width,
                                               resizeOpts.@widthUnits,
                                               res, doc.width.as('px'));
      ini.height = ImageProcessor.unitsToPixels(height,
                                                resizeOpts.@heightUnits,
                                              res, doc.height.as('px'));

      ini.resampleMethod = resizeOpts.@resampleMethod.toString();
      ini.scaleStyles = toBoolean(resizeOpts.@scale);
      ini.enabled = true;
      ini.dontEnlarge = toBoolean(resizeOpts.@dontEnlarge);
      
      ResizeOptions.resizeImage(doc, ini);
    }
  }

  // Post-resize Action
  if (toBoolean(action.@enabled) &&
      action.@when == ImageProcessor.AFTER_IMAGE_RESIZE) {
    app.doAction(action.@name.toString(), action.@set.toString());
  }

  if (saveOpts._convertToIndexed) {
//     LogFile.write("Converting to Indexed");

    if (doc.mode != DocumentMode.INDEXEDCOLOR) {
      if (doc.mode != DocumentMode.RGB) {
        doc.changeMode(ChangeMode.RGB);
      }

      var cnvtOpts = new IndexedConversionOptions();
      doc.changeMode(ChangeMode.INDEXEDCOLOR, cnvtOpts);
    }
  }

  // This is a JDI for the common case of converting to jpg
  // files. Change the document mode to something that works.
  if (ext == "jpg") {
    if (doc.mode == DocumentMode.MULTICHANNEL) {
      doc.changeMode(ChangeMode.RGB);
    }

    if (doc.mode == DocumentMode.DUOTONE) {
      doc.changeMode(ChangeMode.RGB);
    }
  
    if (doc.mode == DocumentMode.INDEXEDCOLOR) {
      doc.changeMode(ChangeMode.RGB);
    }
  
    if (doc.mode == DocumentMode.BITMAP) {
      doc.changeMode(ChangeMode.GRAYSCALE);
    }
  }

  // Determine the destination path
  var folderName;

  var openImages = (input.@source.toString().toLowerCase() == "openimages");
  var saveInSame = output.@path == "same";

  if (saveInSame) {
    folderName = file.parent.absoluteURI;
  } else {
    folderName = output.@path.toString();
  }

  if (toBoolean(output.@subfolder)) {
    folderName += '/' + task.@subfolderName.toString();
  }

  var isBridge = self.runningFromBridge;
  if (!isBridge && !openImages && toBoolean(output.@keepStructure)
      && !saveInSame) {
    folderName = file.parent.absoluteURI;
    // XXX copied from old script
    folderName = folderName.replace(File(input.@path.toString()).absoluteURI, 
                          File(output.@path.toString()).absoluteURI);
  }

  Folder(folderName).create();

  var fname = file.strf("%d/%f.") + ext;

  // Determine output filename
  var fnOpts = self.fnOpts[task];

  if (fnOpts == undefined) {
    var fn = task.namingOptions.toString();
    var ini = {fileNaming: fn};
    ini.startingSerial = toNumber(task.namingOptions.@startingSerial);
    fnOpts = new FileNamingOptions(ini);
    self.fnOpts[task] = fnOpts;

  } else {
    if (fnOpts._serial) {
      fnOpts.startingSerial = fnOpts._serial;
    }
  }

  // XXX should this be the file-created or the file-modified date???
  var cdate = (file.exists ? file.created : new Date());
  var nm = fnOpts.format(File(fname), cdate);
  var outfile = File(folderName + '/' + nm);

  LogFile.write("saving " + file.toUIString() + " as " + outfile.toUIString());

  var extType = undefined;
  if (nm.match(/\.[A-Z]+/)) {
    extType = Extension.UPPERCASE;

  } else if (nm.match(/\.[a-z]+/)) { 
    extType = Extension.LOWERCASE;
  }

  // $.level = 1; debugger;
  outfile = ImageProcessor.createUniqueFileName(outfile, saveOpts._saveForWeb);

//   $.writeln(outfile.toUIString());

  // Save file
  if (saveOpts._saveForWeb) {
    self.saveForWeb(doc, outfile, saveOpts);

  } else {
    doc.saveAs(outfile, saveOpts, true, extType);
  }

  doc.activeHistoryState = historyState;
//   $.writeln("history state reset");
};

ImageProcessor.prototype.saveForWeb = function(doc, outfile, saveOpts) {
  var self = this;
  var settings = self.settings;
  var ext = outfile.strf("%e").toLowerCase();

  if (outfile.exists) {
    outfile.remove();
  }

  // pngs are easy to handle
  if (ext == "png") {
    var sfwOptns = new ExportOptionsSaveForWeb();

    sfwOptns.format = SaveDocumentType.PNG;
    sfwOptns.PNG8 = false;
    sfwOptns.transparency = true;
    sfwOptns.interlaced = toBoolean(saveOpts.interlaced);

    doc.exportDocument(outfile, ExportType.SAVEFORWEB, sfwOptns);

    return;
  }


  // this code was largely copied from the old script

  // now we handle gif and jpg

  if (ext == '') {
    ext = saveOpts._ext || "jpg";
  }

  var inFormat = undefined;
  if (ext == "jpg") {
    inFormat = "JPEG";
  } else if (ext == "gif") {
    inFormat = "GIFf";
  } else {
    Error.runtimeError(9002, "Cannot Save " + ext + " for Web");
  }

  try {
    var id124 = cTID( "Expr" );
    var desc24 = new ActionDescriptor();
    var id125 = cTID( "Usng" );
    var desc25 = new ActionDescriptor();
    var id126 = cTID( "Op  " );
    var id127 = cTID( "SWOp" );
    var id128 = cTID( "OpSa" );
    desc25.putEnumerated( id126, id127, id128 );
    var id129 = cTID( "Fmt " );
    var id130 = cTID( "IRFm" );
    var id131 = cTID( inFormat ); // "GIFf" or "JPEG" goes here
    desc25.putEnumerated( id129, id130, id131 );
    var id132 = cTID( "Intr" );
    desc25.putBoolean( id132, inFormat == "GIFf" ); // true for GIFf false for JPEG
  
    if ( inFormat == "GIFf" ) { // only for GIF
      var id133 = cTID( "RedA" );
      var id134 = cTID( "IRRd" );
      var id135 = cTID( "Sltv" );
      desc25.putEnumerated( id133, id134, id135 );
      var id136 = cTID( "RChT" );
      desc25.putBoolean( id136, false );
      var id137 = cTID( "RChV" );
      desc25.putBoolean( id137, false );
      var id138 = cTID( "AuRd" );
      desc25.putBoolean( id138, false );
      var id139 = cTID( "NCol" ); // this is the number of colors
      desc25.putInteger( id139, toNumber(saveOpts.colors));
      var id140 = cTID( "Dthr" );
      var id141 = cTID( "IRDt" );
      var id142 = cTID( "None" );
      desc25.putEnumerated( id140, id141, id142 );
      var id143 = cTID( "DthA" );
      desc25.putInteger( id143, 100 );
      var id144 = cTID( "DChS" );
      desc25.putInteger( id144, 0 );
      var id145 = cTID( "DCUI" );
      desc25.putInteger( id145, 0 );
      var id146 = cTID( "DChT" );
      desc25.putBoolean( id146, false );
      var id147 = cTID( "DChV" );
      desc25.putBoolean( id147, false );
      var id148 = cTID( "WebS" );
      desc25.putInteger( id148, 0 );
      var id149 = cTID( "TDth" );
      var id150 = cTID( "IRDt" );
      var id151 = cTID( "None" );
      desc25.putEnumerated( id149, id150, id151 );
      var id152 = cTID( "TDtA" );
      desc25.putInteger( id152, 100 );
      var id153 = cTID( "Loss" );
      desc25.putInteger( id153, 0 );
      var id154 = cTID( "LChS" );
      desc25.putInteger( id154, 0 );
      var id155 = cTID( "LCUI" );
      desc25.putInteger( id155, 100 );
      var id156 = cTID( "LChT" );
      desc25.putBoolean( id156, false );
      var id157 = cTID( "LChV" );
      desc25.putBoolean( id157, false );
      var id158 = cTID( "Trns" );
      desc25.putBoolean( id158, true );

    } else { // only for JPEG
      var id75 = cTID( "Qlty" );
      // we use the photoshop 0 to 12, this thing uses 0 to 100
      desc25.putInteger( id75, Math.round(toNumber(saveOpts.quality) / 12 * 100));
      var id76 = cTID( "QChS" );
      desc25.putInteger( id76, 0 );
      var id77 = cTID( "QCUI" );
      desc25.putInteger( id77, 0 );
      var id78 = cTID( "QChT" );
      desc25.putBoolean( id78, false );
      var id79 = cTID( "QChV" );
      desc25.putBoolean( id79, false );
      var id80 = cTID( "Optm" );
      desc25.putBoolean( id80, true );
      var id81 = cTID( "Pass" );
      desc25.putInteger( id81, 1 );
      var id82 = cTID( "blur" );
      desc25.putDouble( id82, 0.000000 );
      var id83 = cTID( "EICC" );
      desc25.putBoolean( id83, toBoolean(saveOpts.embedColorProfile));
    } // end only for GIF or JPEG

    var id159 = cTID( "Mtt " );
    desc25.putBoolean( id159, true );
    var id160 = cTID( "MttR" );
    desc25.putInteger( id160, 255 );
    var id161 = cTID( "MttG" );
    desc25.putInteger( id161, 255 );
    var id162 = cTID( "MttB" );
    desc25.putInteger( id162, 255 );
    var id163 = cTID( "SHTM" );
    desc25.putBoolean( id163, false );
    var id164 = cTID( "SImg" );
    desc25.putBoolean( id164, true );
    var id165 = cTID( "SSSO" );
    desc25.putBoolean( id165, false );
    var id166 = cTID( "SSLt" );
    var list3 = new ActionList();
    desc25.putList( id166, list3 );
    var id167 = cTID( "DIDr" );
    desc25.putBoolean( id167, false );
    var id168 = cTID( "In  " );
    desc25.putPath( id168, outfile ); // here goes the file name
    var id169 = sTID( "SaveForWeb" );
    desc24.putObject( id125, id169, desc25 );
    executeAction( id124, desc24, DialogModes.NO );

  } catch(e) {
    // XXX This is a hard error that we should probably let propagate up
    // this just displays an alert like the old script
    LogFile.logException(e, "Save for Web problems", true);
  }
};

ImageProcessor.prototype.adjustDocument = function(doc) {
  var self = this;
  var settings = self.settings;
  var ci = settings.preferences.copyrightInfo;

  if (ci != undefined && ci.toString() != '') {
    doc.info.copyrightNotice = ci.toString();
    doc.info.copyrighted = CopyrightedType.COPYRIGHTEDWORK;
  }
};


ImageProcessor.prototype.processDocument = function(doc, file) {
  var self = this;
  var settings = self.settings;

  try {
    LogFile.write("Processing: " + doc.name);
  } catch (e) {
//     $.level = 1; debugger;
  }

  self.adjustDocument(doc);

  var taskList = settings.taskList;
  var len = taskList.task.length();

  for (var i = 0; i < len; i++) {
    var task = taskList.task[i];

    if (toBoolean(task.@enabled)) {
      self.saveDocument(doc, file, task);
    }
  }
};

ImageProcessor.findOpenDocument = function(file) {
  function getDocumentName(idx) {
    var ref = new ActionReference();
    ref.putProperty(cTID('Prpr'), cTID('FilR'));
    ref.putIndex(cTID('Dcmn'), idx);
    var desc = executeActionGet(ref);
    return desc.hasKey(cTID('FilR')) ? desc.getPath(cTID('FilR')) : undefined;
  };

  var docs = app.documents;
  var fstr = file.absoluteURI;

  for (var i = 0; i < docs.length; i++) {
    var nm = getDocumentName(i+1);
    if (nm != undefined && nm.absoluteURI == fstr) {
      return docs[i];
    }
  }
  return undefined;
};

ImageProcessor.prototype.processFile = function(file) {
  var self = this;
  var settings = self.settings;
  var doc;

  if (file instanceof String) {
    file = File(file);
    if (!file.exists) {
      return false;
    }
  }

  if (file instanceof File) {
    if (file.hidden) {
      return false;
    }

    doc = ImageProcessor.findOpenDocument(file);

    if (doc) {
      app.activeDocument = doc;
      doc = app.activeDocument.duplicate();

    } else {
      doc = self.openDocument(file);
    }

    if (!doc) {
      return false;
    }

  } else if (file instanceof Document) {
    app.activeDocument = file;
    file = app.activeDocument.fullName;
    doc = app.activeDocument.duplicate();
  }

  try {
    self.processDocument(doc, file);

  } finally {
    doc.close(SaveOptions.DONOTSAVECHANGES);
  }
  
  return true;
};

ImageProcessor.prototype.process = function() {
  var self = this;
  var settings = self.settings;

  var input = settings.input;
  var files = self.getFiles(settings.input);
  var failedFiles = [];
  var filesProcessed = 0;

  var tasks = settings.taskList.task;
  var len = tasks.length();
  var active = 0;
  for (var i = 0; i < len; i++) {
    var task = tasks[i];
    if (toBoolean(task.@enabled)) {
      active++;
    }
  }
  
  if (active == 0) {
    return;
  }


  function skipFile(f) {
    return !ImageProcessor.isValidImageFile(f) || f.hidden;
  }

  for (var i = 0; i < files.length; i++) {
    var file = files[i];

    if (file instanceof Folder) {
      continue;
    }

    try {
      if (file.typename != "Document" && skipFile(file)) {
        continue;
      }

      var rc = self.processFile(file);

      if (rc) {
        filesProcessed++;
      }
    } catch (e) {
      if (e.number != 8007) {  // if not User Cancelled Operation
        LogFile.logException(e);
        failedFiles.push(file);
      }
    }
  }

  if (filesProcessed == 0 && failedFiles.length == 0) {
    LogFile.write(Strings.NoFilesProcessed);
    alert(Strings.NoFilesProcessed);
  }

  if (failedFiles.length > 0) {
    var msg = Strings.CouldNotProcess;
    for (var i = 0; i < failedFiles.length; i++) {
      var f = failedFiles[i];
      msg += "\r" + decodeURI(f.name);
    }

    msg += "\r\r" + Strings.MoreInfo;
    msg += "\r" + File(ImageProcessor.LOG_FILE).toUIString();
    LogFile.write(msg);
    alert(msg);
  }
};


ImageProcessor.prototype.run = function() {
  var self = this;

  LogFile.write("ImageProcessor.run()");

  try {
    // sanity test of settings
    var xml = self.readSettings();
    
    if (xml.input.@source == "openImages" &&
       app.documents.length == 0) {
      alert(Strings.SelectImages);
      return;
    }

    if (xml.input.@source == "folder" &&
        xml.input.@path == '') {
      alert(Strings.SpecifySource);
      return;
    }

    if (xml.output.@path.toString() == '') {
      alert(Strings.SpecifyDest);
      return;
    }

    if (xml.input.@source == "folder") {
      var files = self.getFiles(xml.input);
      if (files.length == 0) {
        alert(Strings.SelectImages);
        return;
      }
    }
    
    var tasks = xml.taskList.task;
    var len = tasks.length();
    var active = 0;
    for (var i = 0; i < len; i++) {
      var task = tasks[i];
      if (toBoolean(task.@enabled)) {
        active++;
      }
    }

    if (active == 0) {
      alert(Strings.NoSaveSelected);
      return;
    }

  } catch (e) {
    LogFile.logException(e, Strings.SettingsFileErr + ": " + e.message, true);
    return;
  }

  // do validation of settings
 
  self.window.close(1);
};

ImageProcessor.prototype.cancel = function() {
  var self = this;

  LogFile.write("ImageProcessor.cancel()");
  self.window.close(2);
};

ImageProcessor.prototype.load = function() {
  var self = this;

  LogFile.write("ImageProcessor.load()");

  try {
    var def = (self.lastSettingsFile ?
               self.lastSettingsFile :
               ImageProcessorOptions.getUserOptionsFile());
    var file = psx.selectFileOpen(Strings.PickXMLFileLoad,
                                  Strings.XMLFileDlgPattern,
                                  def);
    if (file) {
      var xml = psx.readXMLFile(file);
      self.writeSettings(xml);

      self.lastSettingsFile = file;
    }

  } catch (e) {
    LogFile.logException(e, "load settings", true);
  } 
};

ImageProcessor.prototype.save = function() {
  var self = this;

  LogFile.write("ImageProcessor.save()");

  try {
    var def = (self.lastSettingsFile ?
               self.lastSettingsFile :
               ImageProcessorOptions.getUserOptionsFile());
    var file = psx.selectFileSave(Strings.PickXMLFileSave,
                                  Strings.XMLFileDlgPattern,
                                  def);
    
    if (file) {
      var xml = self.readSettings();
      xml.date = new Date().toISOString();
      xml.version = ImageProcessor.VERSION;
      xml.uiPrefs.lastSettingsFile = file.toUIString();
      psx.writeXMLFile(file, xml);

      self.lastSettingsFile = file;
    }
  
  } catch (e) {
    LogFile.logException(e, "save settings", true);
  }
};

ImageProcessor.prototype.reset = function() {
  var self = this;

  LogFile.write("ImageProcessor.reset()");

  try {
    if (confirm(Strings.ConfirmReset)) {
      var f = ImageProcessorOptions.getDefaultOptionsFile();

      if (!f.exists) {
        alert(Strings.DefaultSettingsMissingErr);
        return;
      }
      
      var xml = psx.readXMLFile(f);
      self.writeSettings(xml);
      self.saveDefaultUserOptions(xml);
    }

  } catch (e) {
    LogFile.logException(e, "reset settings", true);
  }
};

ImageProcessor.prototype.loadDefaultUserOptions = function() {
  var self = this;
  var xml = undefined;
  var xfile = ImageProcessorOptions.getUserOptionsFile();

  if (!xfile.exists) {
    xfile = ImageProcessorOptions.getDefaultOptionsFile();
  }

  if (xfile.exists) {
    try {
      xml = psx.readXMLFile(xfile);
      self.writeSettings(xml);

    } catch (e) {
      LogFile.logException(e, "loadDefaultUserOptions", true);
    }
  }

  return xml;
};

ImageProcessor.prototype.saveDefaultUserOptions = function(xml) {
  var self = this;
  var xfile = ImageProcessorOptions.getUserOptionsFile();
  xml.date = new Date().toISOString(); 
  xml.version = ImageProcessor.VERSION;
  psx.writeXMLFile(xfile, xml);
};

///////////////////////////////////////////////////////////////////////////////
// Function: UnitsToPixels
// Usage: convert a number in the given units to pixels
// Input: value in the current units
//        units of the value to convert
//        resolution needed for certain conversions
//        docValue needed for certain conversions
// Return: value in pixels 
///////////////////////////////////////////////////////////////////////////////
ImageProcessor.unitsToPixels = function(value, units, resolution, docValue) {
  units = units.toString();
  var n = Number( value );
  if ( units.search( "inches" ) != -1 ) {
    n = value * resolution;
    return n;
  }
  if ( units.search( "cm" ) != -1 ) {
    n = value / 2.54 * resolution;
    return n;
  }
  if ( units.search( "mm" ) != -1 ) {
    n = value / 25.4 * resolution;
    return n;
  }
  if ( units.search( "points" ) != -1 ) {
    n = value * resolution / 72.72;
    return n;
  }
  if ( units.search( "picas" ) != -1 ) {
    n = value * resolution / 72;
    return n;
  }
  if ( ( units.search( "percent" ) != -1 ) && ( docValue != undefined ) ) {
    n = value * docValue / 100.0;
    return n;
  }
  return n;
};

ImageProcessor.removeAlphaChannels = function(doc) {
  var channels = doc.channels;
  var channelCount = channels.length - 1;
  while (channels[channelCount].kind != ChannelType.COMPONENT) {
    channels[channelCount].remove();
    channelCount--;
  }
};

ImageProcessor.createUniqueFileName = function(file, sfw) {
  var fname = file.strf("%f");
  var dir = file.strf("%d");
  var ext = file.strf("%e");
  var chr = '_'; // (sfw ? '-' : '_');

  // First, clean out any problematic characters
  fname = fname.replace(/[:\/\\*\?\"\<\>\|]/g, chr);  // '/\:*?"<>|' -> '_'
  if (sfw) {
    fname = fname.replace(/\s/g, chr);
  }
  file = File(dir + '/' + fname + '.' + ext);

  if (!file.exists) {
    return file;
  }

  // There is a dupe. Make unique by adding _## to the basename

  var idx = 1;
  while (file.exists) {
    var newFname = "%s/%s_%02d.%s".sprintf(dir, fname, idx++, ext);
    file = File(newFname);
  }

  return file;
};


ImageProcessor.attrsToIni = function(xml) {
  var ini = {};
  var attrs = xml.attributes();
  var len = attrs.length();
  for (var i = 0; i < len; i++) {
    var attr = attrs[i];
    ini[attr.localName()] = attr.toString();
  }
  return ini;
}

ImageProcessor.isValidImageFile = function(f) {
  function _winCheck(f) {
    // skip mac system files
    if (f.name.startsWith("._")) {
      return false;
    }

    var ext = f.strf('%e').toUpperCase();
    return (ext.length > 0) && app.windowsFileTypes.contains(ext);
  }
  function _macCheck(f) {
    return app.macintoshFileTypes.contains(f.type) || _winCheck(f);
  }

  return (((File.fs == "Macintosh") && _macCheck(f)) ||
          ((File.fs == "Windows") && _winCheck(f)));
};

ImageProcessor.createShortFileName = function(fname) {
  var max = ContactSheetUI.SHORT_FILENAME_LENGTH;
  if (fname.length > max) {
    fname = "..." + fname.substr(fname.length - max + 3, max - 3 );
  }
  return fname;
};

ImageProcessor.getFilesFromBridge = function() {
	var fileList;
	if ( BridgeTalk.isRunning( "bridge" ) ) {
    var bt = new BridgeTalk();
    bt.target = "bridge";
    bt.body =
      "var lst = photoshop.getBridgeFileListForAutomateCommand(true, false);" +
      "lst.toSource();";
    bt.onResult = function( inBT ) { fileList = eval( inBT.body ); }
    bt.onError = function( inBT ) { fileList = new Array(); }
    bt.send();
    bt.pump();
    $.sleep( 100 );
    var timeOutAt = ( new Date() ).getTime() + 5000;
    var currentTime = ( new Date() ).getTime();
    while ( ( currentTime < timeOutAt ) && ( undefined == fileList ) ) {
      bt.pump();
      $.sleep( 100 );
      currentTime = ( new Date() ).getTime();
    }
	}
	if ( undefined == fileList ) {
    fileList = new Array();
	}

	return fileList; 
};

ImageProcessor.getImageFilesFromBridge = function() {
	var list = ImageProcessor.getFilesFromBridge();
  var fileList = [];

  for (var i = 0; i < list.length; i++) {
    var file = list[i];
    if (psx.isValidImageFile(file)) {
      fileList.push(file);
    }
  }

  return fileList;
};



ImageProcessor.exec = function() {
	ImageProcessor.dialogMode = app.displayDialogs;
	app.displayDialogs = DialogModes.NO;

  try {
    // Version check...
    var v = toNumber(app.version.match(/^\d+/)[0]);
    if (v < ImageProcessor.REQUIRED_PS_VERSION) {
      alert(Strings.PSVersionError);
      return;
    }

    var mode = app.playbackDisplayDialogs;

    // if we are launched from the debugger OR we have no parameters
    // we need a UI
    if (mode == DialogModes.NO || app.playbackParameters.count == 0) {
      mode = DialogModes.ALL;
    }

    // only turn off the ui if we have parameters and are called from an action
    var opts = {};
    opts.headless = (app.playbackDisplayDialogs == DialogModes.ERROR);

    var obj = new ImageProcessor();

    // get bridge files/state

    if (app.playbackParameters.count > 0) {
      obj.runningFromBridge = false;
      obj.filesFromBridge = undefined;

      var desc = app.playbackParameters;
      if (desc.hasKey(sTID('ImageProcessorProSettings'))) {
        var str = desc.getString(sTID('ImageProcessorProSettings'));
        opts.settings = new XML(str);
        if (opts.settings.input.@source == "bridge") {
          obj.runningFromBridge = true;
          obj.filesFromBridge = ImageProcessor.getImageFilesFromBridge();
        }
      }


      // see if we are called by automation framework
      if (app.playbackParameters.hasKey(ImageProcessor.kFilesList)) {
        obj.runningFromBridge = true;
        obj.filesFromBridge = [];
        
        var flist = app.playbackParameters.getList(ImageProcessor.kFilesList);
        for (var i = 0; i < flist.count; i++) {
          obj.filesFromBridge.push(flist.getPath(i));
        }
      }

    } else {
      opts.headless = false;
    }

    if (opts.headless) {
      obj.settings = opts.settings;
      obj.process();

    } else {
      app.bringToFront();

      var win = obj.createDialog();

      // There are times when ScriptUI/PS gets really confused.
      // if win == undefined, there means it is probably
      // completely hosed and restarting PS is the only thing
      // we can do. RPB has seen this and there has been at least
      // one user that has seen the problem. If we don't handle
      // it the way we have, PS will lock up completely and require
      // an external kill.
      if (win == undefined) {
        Error.runtimeError(9005,
                           "Failed to create Image Processor Pro dialog.\r\n" +
                           "Please restart Photoshop.");
      }

      obj.findAllWidgets();

      if (opts.settings) {
        obj.writeSettings(opts.settings);
      } else {
        opts.settings = obj.settings = obj.loadDefaultUserOptions();
      }

      win.title = ImageProcessor.VTITLE_UI;
      win.center();

      var uiPrefs = undefined;
      if (obj.settings != undefined) {
        uiPrefs = obj.settings.uiPrefs;
      }
      obj.uiPrefs = uiPrefs;

      if (uiPrefs != undefined) {
        if (uiPrefs.lastSettingsFile != undefined) {
          obj.lastSettingsFile = File(uiPrefs.lastSettingsFile);
        }

        if (uiPrefs.lastX != undefined &&
            uiPrefs.lastY != undefined) {
          var x = toNumber(uiPrefs.lastX);
          if (!isNaN(x)) {
            var w = win.bounds.width;
            win.bounds.left = x;
            win.bounds.width = w;
          }

          var y = toNumber(uiPrefs.lastY);
          if (!isNaN(y)) {
            var h = win.bounds.height;
            win.bounds.top = y;
            win.bounds.height = h;
          }
        }
      }
            
      var res = win.show();

      if (res == 1) {
        var xml = obj.readSettings();
        xml.uiPrefs.lastX = win.bounds.x;
        xml.uiPrefs.lastY = win.bounds.y;

        if (obj.lastSettingsFile) {
          if (obj.lastSettingsFile instanceof File) {
            xml.uiPrefs.lastSettingsFile = obj.lastSettingsFile.toUIString();
          } else {
            xml.uiPrefs.lastSettingsFile = obj.lastSettingsFile;
          }
        }

        obj.settings = xml;

        LogFile.write(xml.toXMLString());
        obj.saveDefaultUserOptions(xml);
        obj.process();

      } else {
        obj.settings = undefined;
      }
    }

    if (obj.settings) {
      var desc = new ActionDescriptor();
      desc.putString(sTID('ImageProcessorProSettings'),
                     obj.settings.toXMLString());
      desc.putString(cTID('Msge'), "Settings for Image Processor Pro");

      app.playbackParameters = desc;
    }

  } catch (e) {
    if (e.number != 8007) {  // if not User Cancelled Operation
      var msg = psx.exceptionMessage(e);
      LogFile.write(msg);

      if (confirm(Strings.Sorry)) {
        alert(msg);
      }
    }
  }

  app.displayDialogs = ImageProcessor.dialogMode;
};

ImageProcessor.globalInit();
try {
  ImageProcessor.exec();
} catch (e) {
}
ImageProcessor.globalCleanup();

"ImageProcessorNG.jsx";
// EOF

